package cn.iocoder.yudao.module.customer.convert.customerAirLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerAirLog.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerAirLog.CustomerAirLogDO;

/**
 * 客户空运日志 Convert
 * @author 江楠
 */
@Mapper
public interface CustomerAirLogConvert {
    /*****转换MapStruct*****/
    CustomerAirLogConvert INSTANCE = Mappers.getMapper(CustomerAirLogConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerAirLogDO convert(CustomerAirLogCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerAirLogDO convert(CustomerAirLogUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerAirLogBackVO convert(CustomerAirLogDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerAirLogBackVO> convertList(List<CustomerAirLogDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerAirLogBackVO> convertPage(PageResult<CustomerAirLogDO> page);
}
