package cn.iocoder.yudao.module.customer.convert.customerApproval;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerApproval.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerApproval.CustomerApprovalDO;

/**
 * 客户相关审核详情 Convert
 * @author 系统管理员
 */
@Mapper
public interface CustomerApprovalConvert {
    /*****转换MapStruct*****/
    CustomerApprovalConvert INSTANCE = Mappers.getMapper(CustomerApprovalConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerApprovalDO convert(CustomerApprovalCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerApprovalDO convert(CustomerApprovalUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerApprovalBackVO convert(CustomerApprovalDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerApprovalBackVO> convertList(List<CustomerApprovalDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerApprovalBackVO> convertPage(PageResult<CustomerApprovalDO> page);
}
