package cn.iocoder.yudao.module.customer.convert.customerBank;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerBank.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerBank.CustomerBankDO;

/**
 * 客户银行账户 Convert
 * @author yanghao
 */
@Mapper
public interface CustomerBankConvert {
    /*****转换MapStruct*****/
    CustomerBankConvert INSTANCE = Mappers.getMapper(CustomerBankConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerBankDO convert(CustomerBankCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerBankDO convert(CustomerBankUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerBankBackVO convert(CustomerBankDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerBankBackVO> convertList(List<CustomerBankDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerBankBackVO> convertPage(PageResult<CustomerBankDO> page);
}
