package cn.iocoder.yudao.module.customer.convert.customerCompetitor;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerCompetitor.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCompetitor.CustomerCompetitorDO;

/**
 * 客户竞争对手 Convert
 * @author yanghao
 */
@Mapper
public interface CustomerCompetitorConvert {
    /*****转换MapStruct*****/
    CustomerCompetitorConvert INSTANCE = Mappers.getMapper(CustomerCompetitorConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerCompetitorDO convert(CustomerCompetitorCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerCompetitorDO convert(CustomerCompetitorUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerCompetitorBackVO convert(CustomerCompetitorDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerCompetitorBackVO> convertList(List<CustomerCompetitorDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerCompetitorBackVO> convertPage(PageResult<CustomerCompetitorDO> page);
}
