package cn.iocoder.yudao.module.customer.convert.customerCredit;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerCredit.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCredit.CustomerCreditDO;

/**
 * 信用等级 Convert
 * @author yanghao
 */
@Mapper
public interface CustomerCreditConvert {
    /*****转换MapStruct*****/
    CustomerCreditConvert INSTANCE = Mappers.getMapper(CustomerCreditConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerCreditDO convert(CustomerCreditCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerCreditDO convert(CustomerCreditUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerCreditBackVO convert(CustomerCreditDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerCreditBackVO> convertList(List<CustomerCreditDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerCreditBackVO> convertPage(PageResult<CustomerCreditDO> page);
}
