package cn.iocoder.yudao.module.customer.convert.customerCreditLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerCreditLog.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCreditLog.CustomerCreditLogDO;

/**
 * 客户信用日志 Convert
 * @author 系统管理员
 */
@Mapper
public interface CustomerCreditLogConvert {
    /*****转换MapStruct*****/
    CustomerCreditLogConvert INSTANCE = Mappers.getMapper(CustomerCreditLogConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerCreditLogDO convert(CustomerCreditLogCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerCreditLogDO convert(CustomerCreditLogUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerCreditLogBackVO convert(CustomerCreditLogDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerCreditLogBackVO> convertList(List<CustomerCreditLogDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerCreditLogBackVO> convertPage(PageResult<CustomerCreditLogDO> page);
}
