package cn.iocoder.yudao.module.customer.convert.customerCreditRule;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerCreditRule.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCreditRule.CustomerCreditRuleDO;

/**
 * 信用规则 Convert
 * @author yanghao
 */
@Mapper
public interface CustomerCreditRuleConvert {
    /*****转换MapStruct*****/
    CustomerCreditRuleConvert INSTANCE = Mappers.getMapper(CustomerCreditRuleConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerCreditRuleDO convert(CustomerCreditRuleCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerCreditRuleDO convert(CustomerCreditRuleUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerCreditRuleBackVO convert(CustomerCreditRuleDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerCreditRuleBackVO> convertList(List<CustomerCreditRuleDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerCreditRuleBackVO> convertPage(PageResult<CustomerCreditRuleDO> page);
}
