package cn.iocoder.yudao.module.customer.convert.customerLevel;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerLevel.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevel.CustomerLevelDO;

/**
 * 客户级别 Convert
 * @author yanghao
 */
@Mapper
public interface CustomerLevelConvert {
    /*****转换MapStruct*****/
    CustomerLevelConvert INSTANCE = Mappers.getMapper(CustomerLevelConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerLevelDO convert(CustomerLevelCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerLevelDO convert(CustomerLevelUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerLevelBackVO convert(CustomerLevelDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerLevelBackVO> convertList(List<CustomerLevelDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerLevelBackVO> convertPage(PageResult<CustomerLevelDO> page);
}
