package cn.iocoder.yudao.module.customer.convert.customerLevelLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerLevelLog.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevelLog.CustomerLevelLogDO;

/**
 * 客户等级日志 Convert
 * @author 系统管理员
 */
@Mapper
public interface CustomerLevelLogConvert {
    /*****转换MapStruct*****/
    CustomerLevelLogConvert INSTANCE = Mappers.getMapper(CustomerLevelLogConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerLevelLogDO convert(CustomerLevelLogCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerLevelLogDO convert(CustomerLevelLogUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerLevelLogBackVO convert(CustomerLevelLogDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerLevelLogBackVO> convertList(List<CustomerLevelLogDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerLevelLogBackVO> convertPage(PageResult<CustomerLevelLogDO> page);
}
