package cn.iocoder.yudao.module.customer.convert.customerLevelRule;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerLevelRule.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevelRule.CustomerLevelRuleDO;

/**
 * 客户级别规则 Convert
 * @author 系统管理员
 */
@Mapper
public interface CustomerLevelRuleConvert {
    /*****转换MapStruct*****/
    CustomerLevelRuleConvert INSTANCE = Mappers.getMapper(CustomerLevelRuleConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerLevelRuleDO convert(CustomerLevelRuleCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerLevelRuleDO convert(CustomerLevelRuleUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerLevelRuleBackVO convert(CustomerLevelRuleDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerLevelRuleBackVO> convertList(List<CustomerLevelRuleDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerLevelRuleBackVO> convertPage(PageResult<CustomerLevelRuleDO> page);
}
