package cn.iocoder.yudao.module.customer.convert.customerOperateLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerOperateLog.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerOperateLog.CustomerOperateLogDO;

/**
 * 客户操作日志 Convert
 * @author yanghao
 */
@Mapper
public interface CustomerOperateLogConvert {
    /*****转换MapStruct*****/
    CustomerOperateLogConvert INSTANCE = Mappers.getMapper(CustomerOperateLogConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerOperateLogDO convert(CustomerOperateLogCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerOperateLogDO convert(CustomerOperateLogUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerOperateLogBackVO convert(CustomerOperateLogDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerOperateLogBackVO> convertList(List<CustomerOperateLogDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerOperateLogBackVO> convertPage(PageResult<CustomerOperateLogDO> page);
}
