package cn.iocoder.yudao.module.customer.convert.customerPublicCatchLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.customerPublicCatchLog.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerPublicCatchLog.CustomerPublicCatchLogDO;

/**
 * 公海客户捞取日志 Convert
 * @author yanghao
 */
@Mapper
public interface CustomerPublicCatchLogConvert {
    /*****转换MapStruct*****/
    CustomerPublicCatchLogConvert INSTANCE = Mappers.getMapper(CustomerPublicCatchLogConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    CustomerPublicCatchLogDO convert(CustomerPublicCatchLogCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    CustomerPublicCatchLogDO convert(CustomerPublicCatchLogUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    CustomerPublicCatchLogBackVO convert(CustomerPublicCatchLogDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<CustomerPublicCatchLogBackVO> convertList(List<CustomerPublicCatchLogDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<CustomerPublicCatchLogBackVO> convertPage(PageResult<CustomerPublicCatchLogDO> page);
}
