package cn.iocoder.yudao.module.customer.convert.indirectCustomer;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomer.IndirectCustomerDO;
import cn.iocoder.yudao.module.customer.vo.indirectCustomer.*;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;

import java.util.List;

/**
 * 间接客户 Convert
 *
 * @author yanghao
 */
@Mapper
public interface IndirectCustomerConvert {
    /*****转换MapStruct*****/
    IndirectCustomerConvert INSTANCE = Mappers.getMapper(IndirectCustomerConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    IndirectCustomerDO convert(IndirectCustomerCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    IndirectCustomerDO convert(IndirectCustomerUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
     */
    IndirectCustomerBackVO convert(IndirectCustomerDO bean);

    IndirectCustomerDetailRespVO convertDetail(IndirectCustomerDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<IndirectCustomerBackVO> convertList(List<IndirectCustomerDO> list);


    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<IndirectCustomerExcelVO> convertExcelList(List<IndirectCustomerDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<IndirectCustomerBackVO> convertPage(PageResult<IndirectCustomerDO> page);
}
