package cn.iocoder.yudao.module.customer.convert.indirectCustomerContacts;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import cn.iocoder.yudao.module.customer.vo.indirectCustomerContacts.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomerContacts.IndirectCustomerContactsDO;

/**
 * 间接客户联系人 Convert
 * @author yanghao
 */
@Mapper
public interface IndirectCustomerContactsConvert {
    /*****转换MapStruct*****/
    IndirectCustomerContactsConvert INSTANCE = Mappers.getMapper(IndirectCustomerContactsConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    IndirectCustomerContactsDO convert(IndirectCustomerContactsCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    IndirectCustomerContactsDO convert(IndirectCustomerContactsUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    IndirectCustomerContactsBackVO convert(IndirectCustomerContactsDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<IndirectCustomerContactsRespVO> convertList(List<IndirectCustomerContactsDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<IndirectCustomerContactsBackVO> convertPage(PageResult<IndirectCustomerContactsDO> page);
}
