package cn.iocoder.yudao.module.customer.convert.zhongPao;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.customer.dal.dataobject.zhongPao.ZhongPaoDO;
import cn.iocoder.yudao.module.customer.vo.zhongPao.ZhongPaoBackVO;
import cn.iocoder.yudao.module.customer.vo.zhongPao.ZhongPaoCreateReqVO;
import cn.iocoder.yudao.module.customer.vo.zhongPao.ZhongPaoUpdateReqVO;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;

import java.util.List;

/**
 * 重泡货配置 Convert
 * @author yanghao
 */
@Mapper
public interface ZhongPaoConvert {
    /*****转换MapStruct*****/
    ZhongPaoConvert INSTANCE = Mappers.getMapper(ZhongPaoConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    ZhongPaoDO convert(ZhongPaoCreateReqVO bean);


    ZhongPaoCreateReqVO convertToCreateReqVo(ZhongPaoDO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    ZhongPaoDO convert(ZhongPaoUpdateReqVO bean);


    ZhongPaoUpdateReqVO convertToUpdateReqVo(ZhongPaoDO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    ZhongPaoBackVO convert(ZhongPaoDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<ZhongPaoBackVO> convertList(List<ZhongPaoDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<ZhongPaoBackVO> convertPage(PageResult<ZhongPaoDO> page);
}
