package cn.iocoder.yudao.module.customer.dal.dataobject.customer.commission;

import lombok.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户佣金类型 DO
 *
 * @author yanghao
 */
@TableName("ecw_customer_commission")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CustomerCommissionDO extends BaseDO {

    /**
     * 
     */
    @TableId
    private Long id;
    /**
     * 客户id
     */
    private Long customerId;
    /**
     * 佣金类型
     *
     * 枚举 {@link TODO commission_type 对应的类}
     */
    private Integer type;
    /**
     * 运输方式
     *
     * 枚举 {@link TODO transport_type 对应的类}
     */
    private Integer transportId;
    /**
     * 始发地id
     */
    private Long departureId;
    /**
     * 目的地id
     */
    private Long objectiveId;
    /**
     * 报关类别：我司全代：1，自单代报：2，混合报关：3
     *
     * 枚举 {@link TODO customs_type 对应的类}
     */
    private Integer customsType;
    /**
     * 产品备案
     *
     * 枚举 {@link TODO commission_product_approval 对应的类}
     */
    private Integer approval;
    /**
     * 暗佣类型 1产品2达标
     *
     * 枚举 {@link TODO commission_dark_type 对应的类}
     */
    private Integer darkReturnType;






    /**
     * 客户名称
     */
    @TableField(exist = false)
    private String customerName;

    /**
     * 主联系人
     */
    @TableField(exist = false)
    private String defaultContactName;

    /**
     * 主联系电话区号
     */
    @TableField(exist = false)
    private String defaultContactPhoneAreaCode;

    /**
     * 主联系电话
     */
    @TableField(exist = false)
    private String defaultContactPhone;


}
