package cn.iocoder.yudao.module.customer.dal.dataobject.customer.commission;

import lombok.*;

import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户佣金详情 DO
 *
 * @author yanghao
 */
@TableName("ecw_customer_commission_info")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CustomerCommissionInfoDO extends BaseDO {

    /**
     * 
     */
    @TableId
    private Long id;
    /**
     * 佣金表id
     */
    private Long commissionId;
    /**
     * 产品类型
     */
    private Long productType;
    /**
     * 产品属性
     */
    private Long productAttr;



    //-------暗佣--产品-------
    /**
     * 暗佣佣金
     */
    private BigDecimal darkCommission;
    /**
     * 暗佣货币
     */
    private Integer darkCurrency;
    /**
     * 暗佣单位
     *
     * 枚举 {@link TODO commission_unit 对应的类}
     */
    private Integer darkUnit;




    //-------暗佣+明佣----销售价上调-------
    /**
     * 暗佣上调
     */
    private BigDecimal darkAdjustCommission;
    /**
     * 暗佣货币上调
     */
    private Integer darkAdjustCurrency;
    /**
     * 暗佣单位上调
     *
     * 枚举 {@link TODO commission_unit 对应的类}
     */
    private Integer darkAdjustUnit;






    //-------暗佣----满-------
    /**
     * 满减
     */
    private BigDecimal amount;
    /**
     * 满的货多少币
     */
    private Integer amountCurrency;
    /**
     * 满多少的单位
     *
     * 枚举 {@link TODO commission_unit 对应的类}
     */
    private Integer amountUnit;




    //-------暗佣+明佣------暗佣佣金----
    //-------明佣----佣金-------
    //-------暗佣----满返 ---返金额-------

    /**
     * 返佣金的货币
     */
    private Integer refundCurrency;
    /**
     * 满返
     */
    private BigDecimal refund;
    /**
     * 返佣金的单位
     *
     * 枚举 {@link TODO commission_unit 对应的类}
     */
    private Integer refundUnit;

}
