package cn.iocoder.yudao.module.customer.dal.dataobject.customer.complaint;

import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户投诉 DO
 *
 * @author yanghao
 */
@TableName("ecw_customer_complaint")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CustomerComplaintDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;

    /**
     * 客户名称
     */
    private Long customerId;

    /**
     * 投诉编号
     */
    private String code;

    /**
     * app会员id
     */
    private Long memberUserId;

    /**
     * 标题
     */
    private String title;

    /**
     * 联系人
     */
    private String contacter;

    /**
     * 联系人电话
     */
    private String contactPhone;

    /**
     * 投诉类型
     *
     * 枚举 {@link TODO customer_complaint_type 对应的类}
     */
    private Integer type;
    /**
     * 订单号
     */
    private String orderId;
    /**
     * 提单号
     */
    private String ladingbillId;
    /**
     * 投诉内容
     */
    private String content;
    /**
     * 处理状态
     *
     * 枚举 {@link TODO customer_complaint_status 对应的类}
     */
    private Integer status;
    /**
     * 查明原因
     */
    private String ascertainReason;
    /**
     * 处理方案
     */
    private String plan;
    /**
     * 处理结果
     */
    private String result;
    /**
     * 赔付金额
     */
    private java.math.BigDecimal indemnity;
    /**
     * 管理员id
     */
    private Long adminId;
    /**
     * 赔付货币单位
     */
    private Integer currencyUnit;
    /**
     * 处理时间
     */
    private Date handleAt;
    /**
     * 取消原因
     */
    private String cancelReason;


}
