package cn.iocoder.yudao.module.customer.dal.dataobject.customer.follow;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import java.util.Date;

/**
 * 客户投诉跟进 DO
 *
 * @author yanghao
 */
@TableName("ecw_customer_follow")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CustomerFollowDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;


    /**
     * 客户ID
     */
    private Long customerId;

    /**
     * 投诉ID
     */
    private Long bizId;

    /**
     * 业务编号
     */
    private String bizNo;
    /**
     * 跟进类型
     * <p>
     * 枚举 {@link TODO customer_follow_type 对应的类}
     */
    private Integer followType;
    /**
     * 跟进时间
     */
    private Date followTime;
    /**
     * 联系人
     */
    private String contactName;
    /**
     * 跟进方式
     * <p>
     * 枚举 {@link  customer_follow_method 对应的类}
     */
    private Integer followMethod;
    /**
     * 跟进业务员
     */
    private Long followUserId;
    /**
     * 客户反馈
     */
    private String feedback;
    /**
     * 处理结果
     */
    private String result;
    /**
     * 管理员id
     */
    private Long adminId;


    /**
     * 跟进业务员
     */
    @TableField(exist = false)
    private String followUserName;

}
