package cn.iocoder.yudao.module.customer.dal.dataobject.customer.line;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

/**
 * 客户线路 DO
 *
 * @author yanghao
 */
@TableName("ecw_customer_line")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CustomerLineDO extends BaseDO {

    @TableId
    private Long id;

    /**
     * 客户ID
     */
    private Long customerId;
    /**
     * 始发仓库id
     */
    private Long departureId;
    /**
     * 目的仓库id
     */
    private String objectiveIds;

    /**
     * 重泡货类型，见字典zhong_pao_type
     */
    private Integer zhongPaoType;

}
