package cn.iocoder.yudao.module.customer.dal.dataobject.customerApproval;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户相关审核详情 DO
 *
 * @author 系统管理员
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_customer_approval")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerApprovalDO extends BaseDO {

    /**
     * 主键ID
     */
    @TableId
    private Long approvalId;
    /**
     * 客户ID
     */
    private Long customerId;
    /**
     * 流程表单实例ID
     */
    private String formId;
    /**
     * 审批类型1 延迟进入公海 2 移交客户
     */
    private Integer type;
    /**
     * 跟进业务员
     */
    private String followUpSalesmanId;
    /**
     * 审核内容详情
     */
    private String details;
    /**
     * 状态：1 处理中 2 通过 3 不通过 4 取消
     */
    private Integer status;
    /**
     * 处理结果
     */
    private String processingResults;
    /**
     * 结束人
     */
    private String finishBy;
    /**
     * 结束时间
     */
    private Date finishTime;

}
