package cn.iocoder.yudao.module.customer.dal.dataobject.customerBank;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户银行账户 DO
 *
 * @author yanghao
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_customer_bank")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerBankDO extends BaseDO {

    /**
     * 
     */
    @TableId
    private Long id;
    /**
     * 客户id
     */
    private Long customerId;
    /**
     * 银行账户
     */
    private String accountName;
    /**
     * 币种
     */
    private String currency;
    /**
     * 银行名称
     */
    private String bankName;
    /**
     * 银行账户
     */
    private String bankAccount;
    /**
     * 银行代码
     */
    private String bankCode;
    /**
     * 账户类型
     */
    private String accountType;
    /**
     * 银行地址
     */
    private String bankAddress;
    /**
     * 是否展示 默认为展示
     */
    private Integer status;

}
