package cn.iocoder.yudao.module.customer.dal.dataobject.customerCreditLog;

import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户信用日志 DO
 *
 * @author 系统管理员
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_customer_credit_log")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerCreditLogDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 客户id
     */
    private Long customerId;


    /**
     * 订单id
     */
    private Long orderId;

    /**
     * 订单编号
     */
    private String orderNo;

    /**
     * 信用规则id
     */
    private Long ruleId;

    /**
     * 规则得分
     */
    private Integer ruleScore;
    /**
     * 备注
     */
    private String remark;

}
