package cn.iocoder.yudao.module.customer.dal.dataobject.customerCreditRule;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 信用规则 DO
 *
 * @author yanghao
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_customer_credit_rule")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerCreditRuleDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 规则名称
     */
    private String name;
    /**
     * 规则名称En
     */
    private String nameEn;
    /**
     * 规则分类
     *
     * 枚举 {@link TODO customer_credit_rule_type 对应的类}
     */
    private Integer type;
    /**
     * 规则得分
     */
    private Integer score;
    /**
     * 备注
     */
    private String remark;

}
