package cn.iocoder.yudao.module.customer.dal.dataobject.customerFollowup;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户跟进 DO
 *
 * @author yanghao
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_customer_followup")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerFollowupDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 编号
     */
    private String number;
    /**
     * 上一级跟进单号
     */
    private String parentNumber;
    /**
     * 状态 字典customer_followup_status
     */
    private Integer status;
    /**
     * 客户编号
     */
    private Long customerId;
    /**
     * 报价单
     */
    private Long offerId;
    /**
     * 跟进类型 字典customer_followup_type
     */
    private Integer followType;
    /**
     * 跟进时间
     */
    private Date followTime;
    /**
     * 联系人
     */
    private String contactName;
    /**
     * 跟进方式 字典customer_followup_method
     */
    private Integer followMethod;
    /**
     * 客户经理/跟进业务员id
     */
    private Long followUserId;
    /**
     * 目的
     */
    private String purpose;
    /**
     * 跟进结果 字典customer_followup_result_type
     */
    private Integer resultType;
    /**
     * 客户反馈
     */
    private String feedback;
    /**
     * 附件 多个以逗号分隔
     */
    private String attatchment;
    /**
     * 下次跟进时间
     */
    private Date nextTime;
    /**
     * 下次跟进计划
     */
    private String nextPlan;



    @TableField(exist = false)
    private String customerNumber;
    @TableField(exist = false)
    private String offerNumber;
    //creator_name
    @TableField(exist = false)
    private String creatorName;
    // updater_name
    @TableField(exist = false)
    private String updaterName;

}
