package cn.iocoder.yudao.module.customer.dal.dataobject.customerOperateLog;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 客户操作日志 DO
 *
 * @author yanghao
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_customer_operate_log")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerOperateLogDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;

    /**
     * 客户id
     */
    private Long customerId;
    /**
     * 客户编号
     */
    private String number;
    /**
     * 客户名称
     */
    private String name;
    /**
     * 操作类型 见字典Customer_operate_type
     */
    private Integer operateType;
    /**
     * 老客户经理
     */
    private Long oldCustomerService;
    /**
     * 新客户经理
     */
    private Long newCustomerService;
    /**
     * 老的预计进入公海的时间
     */
    private Date oldEstimateEnterOpenSeaTime;
    /**
     * 新的进入公海的时间
     */
    private Date newEstimateEnterOpenSeaTime;;

    /**
     * 订单id
     */
    private Long orderId;

    /**
     * 订单编号
     */
    private String orderNo;
    /**
     * 备注
     */
    private String remark;
    /**
     * 操作人
     */
    private Long operator;
    /**
     * 操作人名称
     */
    private String operatorName;

    /**
     * 内容json
     */
    private String updateBody;

    /**
     * 差异json
     */
    private String note;

}
