package cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomer;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 间接客户 DO
 *
 * @author yanghao
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_indirect_customer")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class IndirectCustomerDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;

    /**
     * 来源客户id
     */
    private Long agentCustomerId;

    /**
     * 客户编号
     */
    private String number;
    /**
     * 客户名称
     */
    private String name;
    /**
     * 客户等级
     */
    private Integer level;
    /**
     * 信用等级
     */
    private Integer creditLevel;
    /**
     * 国家
     */
    private Long country;
    /**
     * 客户类型
     */
    private String type;
    /**
     * 客户货运类型 见customer_transport_type
     */
    private String transportType;
    /**
     * 客户资源类型 见customer_resource_type
     */
    private Integer resourceType;
    /**
     * 所属代理
     */
    private Long agentId;
    /**
     * 公司名称
     */
    private String company;
    /**
     * 联系地址
     */
    private String address;
    /**
     * 产品类型
     */
    private Long productType;
    /**
     * 产品id
     */
    private Long productId;
    /**
     * 常用提货网点
     */
    private Long pickupPoint;
    /**
     * 关联会员账号
     */
    private Long memberId;
    /**
     * 客户生日
     */
    private Date birthday;
    /**
     * 结算方式
     */
    private Integer balance;
    /**
     * 客户来源
     */
    private Integer source;
    /**
     * 图片
     */
    private String picture;
    /**
     * 跟进客服
     */
    private Long customerService;
    /**
     * 跟进客服分配时间
     */
    private Date customerServiceAssignedTime;
    /**
     * 推介人
     */
    private Long promoter;
    /**
     * 客户状态：1.线索2.意向3.成交
     */
    private Integer status;
    /**
     * 客户状态更新时间
     */
    private Date statusUpdateTime;
    /**
     * 是否被接收
     */
    private Boolean isCustomerServiceConfirmed;
    /**
     * 创建人
     */
    private Long founder;
    /**
     * 部门
     */
    private String department;
    /**
     * 发票抬头
     */
    private String invoiceTitle;
    /**
     * 纳税人识别号
     */
    private String licenseNumber;
    /**
     * 开户行
     */
    private String bank;
    /**
     * 账户
     */
    private String bankNumber;
    /**
     * 项目
     */
    private String project;
    /**
     * 开票地址
     */
    private String billingAddress;
    /**
     * 开票电话
     */
    private String billingTell;
    /**
     * 税率
     */
    private java.math.BigDecimal taxRate;
    /**
     * 完善时间
     */
    private Date perfectTime;
    /**
     * 备注
     */
    private String remarks;
    /**
     * 管理员id
     */
    private Long adminId;
    /**
     * 审批人id
     */
    private Long approver;
    /**
     * 通知人id
     */
    private Long notifier;
    /**
     * 其他审批id
     */
    private Long otherApprovalId;
    /**
     * 到仓确认
     */
    private Integer arrivalConfirm;
    /**
     * 重货标准(CBM)
     */
    private java.math.BigDecimal weightUnit;
    /**
     * 泡货标准
     */
    private java.math.BigDecimal lightUnit;
    /**
     * 重货标准修改人
     */
    private String weightEditWho;
    /**
     * 重货标准修时间
     */
    private Date weightEditTime;
    /**
     * 询价详情
     */
    private String enquiryInfo;
    /**
     * 是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建
     */
    private Integer isAuto;
    /**
     * 是否公海客户
     */
    private Boolean isInOpenSea;
    /**
     * 进入公海时间
     */
    private Date enterOpenSeaTime;
    /**
     * 预计进入公海池时间
     */
    private Date estimateEnterOpenSeaTime;
    /**
     * 延期x月
     */
    private Integer postponeMonth;
    /**
     * 从公海池捞取时间
     */
    private Date catchTime;
    /**
     * 是否显示提单价格
     */
    private Boolean isShowTidanPrice;
    /**
     * vip等级分数
     */
    private Long vipLevelScore;
    /**
     * 信用等级分数
     */
    private Long creditLevelScore;





    /**
     * 主联系人
     */
    @TableField(exist = false)
    private String defaultContactName;

    /**
     * 主联系电话
     */
    @TableField(exist = false)
    private String defaultContactPhone;

    /**
     * 主邮箱
     */
    @TableField(exist = false)
    private String defaultEmail;

    /**
     * 主社交方式
     */
    @TableField(exist = false)
    private Integer defaultSocial;

    /**
     * 主社交软件号码
     */
    @TableField(exist = false)
    private String defaultSocialNumber;



    /**
     * 来源客户名称
     */
    @TableField(exist = false)
    private String agentCustomerName;

    /**
     * 跟进客服名字
     */
    @TableField(exist = false)
    private String customerServiceName;

}
