package cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomerContacts;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 间接客户联系人 DO
 *
 * @author yanghao
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_indirect_customer_contacts")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class IndirectCustomerContactsDO extends BaseDO {

    /**
     * 
     */
    @TableId
    private Long id;
    /**
     * 客户id
     */
    private Long customerId;
    /**
     * 部门
     */
    private String department;
    /**
     * 职位
     */
    private String position;
    /**
     * 联系人
     */
    private String name;
    /**
     * 社交方式
     */
    private Integer social;
    /**
     * 社交软件号码
     */
    private String socialNumber;
    /**
     * 电子邮箱
     */
    private String email;
    /**
     * 默认联系人：1为默认
     */
    private Integer isDefault;
    /**
     * 关联账户id
     */
    private Long userid;
    /**
     * 关联账户名
     */
    private String username;
    /**
     * 区号
     */
    private String areaCode;
    /**
     * 手机号码(不带任何区号)
     */
    private String phoneNew;
    /**
     * 是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建
     */
    private Integer isAuto;

}
