package cn.iocoder.yudao.module.customer.dal.dataobject.zhongPao;

import lombok.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

import java.math.BigDecimal;

/**
 * 重泡货配置 DO
 *
 * @author yanghao
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_zhong_pao")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class ZhongPaoDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 重泡货类型 见字典zhong_pao_type
     *
     * 枚举 {@link TODO zhong_pao_type 对应的类}
     */
    private Integer type;
    /**
     * 临介值
     */
    private BigDecimal edge;
    /**
     * 公式
     */
    private BigDecimal formulas;
    /**
     * 传输方式ids
     *
     * 枚举 {@link TODO transport_type 对应的类}
     */
    private String transportTypes;
    /**
     * 始发地ID
     */
    private Long departureId;
    /**
     * 目的地ID列表
     */
    private String objectiveIds;

    /**
     * 状态 0:开启;1:关闭 见字典common_status
     */
    private Integer status;

}
