package cn.iocoder.yudao.module.customer.dal.mysql.customer;

import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.complaint.CustomerComplaintDO;
import cn.iocoder.yudao.module.customer.vo.customer.complaint.CustomerComplaintExcelVO;
import cn.iocoder.yudao.module.customer.vo.customer.complaint.CustomerComplaintExportReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.complaint.CustomerComplaintPageReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.complaint.CustomerComplaintRespVO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 客户投诉 Mapper
 *
 * @author yanghao
 */
@Mapper
public interface CustomerComplaintMapper extends BaseMapperX<CustomerComplaintDO> {


    @ResultType(CustomerComplaintRespVO.class)
    @Select({
            "<script>",
            "select plaint.*, admin.nickname as admin_nickname, customer.name as customer_name ",
            "from ecw_customer_complaint plaint ",
            "left join system_user admin on plaint.admin_id = admin.id ",
            "LEFT JOIN ecw_customer customer ON plaint.customer_id = customer.id ",

            "where plaint.deleted = 0 ",

            "<when test = 'query.memberUserId != null'>",
            "AND plaint.`member_user_id` = #{query.memberUserId}",
            "</when>",

            "<when test = 'query.customerId != null'>",
            "AND plaint.`customer_id` = #{query.customerId}",
            "</when>",

            "<when test = 'query.adminId != null'>",
            "AND plaint.`admin_id` = #{query.adminId}",
            "</when>",

            "<when test = 'query.type != null'>",
            "AND plaint.`type` = #{query.type}",
            "</when>",

            "<when test = 'query.status != null'>",
            "AND plaint.`status` = #{query.status}",
            "</when>",

            "<when test = 'query.code != null and query.code != \"\" '>",
            "AND plaint.`code` like concat('%',concat(#{query.code},'%'))",
            "</when>",

            "<when test = 'query.orderId != null and query.orderId != \"\" '>",
            "AND plaint.`order_id` like concat('%',concat(#{query.orderId},'%'))",
            "</when>",


            "<when test = 'query.ladingbillId != null and query.ladingbillId != \"\" '>",
            "AND plaint.`ladingbill_id` like concat('%',concat(#{query.ladingbillId},'%'))",
            "</when>",


            "<when test = 'query.beginCreateTime != null and query.endCreateTime != null '>",
                "AND plaint.`create_time` between #{query.beginCreateTime} and #{query.endCreateTime}",
            "</when>",

            "order by plaint.id desc",

            "</script>"
    })
    IPage<CustomerComplaintRespVO> selectPage(@Param("mpPage") IPage<CustomerComplaintRespVO> mpPage,
                                              @Param("query") CustomerComplaintPageReqVO query);


    @ResultType(CustomerComplaintExcelVO.class)
    @Select({
            "<script>",
            "select plaint.*, admin.nickname as admin_nickname, customer.name as customer_name, currency.title_zh as currency_unit_name ",
            "from ecw_customer_complaint plaint ",
            "left join system_user admin on plaint.admin_id = admin.id ",
            "LEFT JOIN ecw_customer customer ON plaint.customer_id = customer.id ",
            "LEFT JOIN ecw_currency currency ON plaint.currency_unit = currency.id ",

            "where plaint.deleted = 0 ",

            "<when test = 'query.customerId != null'>",
            "AND plaint.`customer_id` = #{query.customerId}",
            "</when>",

            "<when test = 'query.type != null'>",
            "AND plaint.`type` = #{query.type}",
            "</when>",

            "<when test = 'query.status != null'>",
            "AND plaint.`status` = #{query.status}",
            "</when>",

            "<when test = 'query.code != null and query.code != \"\" '>",
            "AND plaint.`code` like concat('%',concat(#{query.code},'%'))",
            "</when>",

            "<when test = 'query.orderId != null and query.orderId != \"\" '>",
            "AND plaint.`order_id` like concat('%',concat(#{query.orderId},'%'))",
            "</when>",


            "<when test = 'query.ladingbillId != null and query.ladingbillId != \"\" '>",
            "AND plaint.`ladingbill_id` like concat('%',concat(#{query.ladingbillId},'%'))",
            "</when>",


            "<when test = 'query.beginCreateTime != null and query.endCreateTime != null '>",
                "AND plaint.`create_time` between #{query.beginCreateTime} and #{query.endCreateTime}",
            "</when>",

            "</script>"
    })
    List<CustomerComplaintExcelVO> selectList(@Param("query") CustomerComplaintExportReqVO query);


}
