package cn.iocoder.yudao.module.customer.dal.mysql.customer;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.line.CustomerLineDO;
import cn.iocoder.yudao.module.customer.vo.customer.line.CustomerLineExportReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.line.CustomerLinePageReqVO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 客户线路 Mapper
 *
 * @author yanghao
 */
@Mapper
public interface CustomerLineMapper extends BaseMapperX<CustomerLineDO> {

    default PageResult<CustomerLineDO> selectPage(CustomerLinePageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CustomerLineDO>()
                .eqIfPresent(CustomerLineDO::getCustomerId, reqVO.getCustomerId())
                .eqIfPresent(CustomerLineDO::getZhongPaoType, reqVO.getZhongPaoType())
                .eqIfPresent(CustomerLineDO::getDepartureId, reqVO.getDepartureId())
                .eqIfPresent(CustomerLineDO::getObjectiveIds, reqVO.getObjectiveIds())
                .betweenIfPresent(CustomerLineDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(CustomerLineDO::getId));
    }

    default List<CustomerLineDO> selectList(CustomerLineExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<CustomerLineDO>()
                .eqIfPresent(CustomerLineDO::getCustomerId, reqVO.getCustomerId())
                .eqIfPresent(CustomerLineDO::getDepartureId, reqVO.getDepartureId())
                .eqIfPresent(CustomerLineDO::getZhongPaoType, reqVO.getZhongPaoType())
                .eqIfPresent(CustomerLineDO::getObjectiveIds, reqVO.getObjectiveIds())
                .betweenIfPresent(CustomerLineDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(CustomerLineDO::getId));
    }

}
