package cn.iocoder.yudao.module.customer.dal.mysql.customer.commission;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.commission.CustomerCommissionInfoDO;
import cn.iocoder.yudao.module.customer.vo.customer.commission.CustomerCommissionInfoExportReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.commission.CustomerCommissionInfoPageReqVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 客户佣金详情 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface CustomerCommissionInfoMapper extends BaseMapperX<CustomerCommissionInfoDO> {

    default PageResult<CustomerCommissionInfoDO> selectPage(CustomerCommissionInfoPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CustomerCommissionInfoDO>()
                .eqIfPresent(CustomerCommissionInfoDO::getCommissionId, reqVO.getCommissionId())
                .eqIfPresent(CustomerCommissionInfoDO::getProductType, reqVO.getProductType())
                .eqIfPresent(CustomerCommissionInfoDO::getProductAttr, reqVO.getProductAttr())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkCommission, reqVO.getDarkCommission())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkCurrency, reqVO.getDarkCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkUnit, reqVO.getDarkUnit())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkAdjustCommission, reqVO.getDarkAdjustCommission())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkAdjustCurrency, reqVO.getDarkAdjustCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkAdjustUnit, reqVO.getDarkAdjustUnit())
                .eqIfPresent(CustomerCommissionInfoDO::getAmount, reqVO.getAmount())
                .eqIfPresent(CustomerCommissionInfoDO::getAmountCurrency, reqVO.getAmountCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getAmountUnit, reqVO.getAmountUnit())
                .eqIfPresent(CustomerCommissionInfoDO::getRefundCurrency, reqVO.getRefundCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getRefund, reqVO.getRefund())
                .eqIfPresent(CustomerCommissionInfoDO::getRefundUnit, reqVO.getRefundUnit())
                .betweenIfPresent(CustomerCommissionInfoDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(CustomerCommissionInfoDO::getId));
    }

    default List<CustomerCommissionInfoDO> selectList(CustomerCommissionInfoExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<CustomerCommissionInfoDO>()
                .eqIfPresent(CustomerCommissionInfoDO::getCommissionId, reqVO.getCommissionId())
                .eqIfPresent(CustomerCommissionInfoDO::getProductType, reqVO.getProductType())
                .eqIfPresent(CustomerCommissionInfoDO::getProductAttr, reqVO.getProductAttr())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkCommission, reqVO.getDarkCommission())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkCurrency, reqVO.getDarkCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkUnit, reqVO.getDarkUnit())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkAdjustCommission, reqVO.getDarkAdjustCommission())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkAdjustCurrency, reqVO.getDarkAdjustCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getDarkAdjustUnit, reqVO.getDarkAdjustUnit())
                .eqIfPresent(CustomerCommissionInfoDO::getAmount, reqVO.getAmount())
                .eqIfPresent(CustomerCommissionInfoDO::getAmountCurrency, reqVO.getAmountCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getAmountUnit, reqVO.getAmountUnit())
                .eqIfPresent(CustomerCommissionInfoDO::getRefundCurrency, reqVO.getRefundCurrency())
                .eqIfPresent(CustomerCommissionInfoDO::getRefund, reqVO.getRefund())
                .eqIfPresent(CustomerCommissionInfoDO::getRefundUnit, reqVO.getRefundUnit())
                .betweenIfPresent(CustomerCommissionInfoDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(CustomerCommissionInfoDO::getId));
    }


    void deleteByCommissionId(@Param("commissionId") Long commissionId);


    @Select({
            "select info.* from ecw_customer_commission_info info ",
            "inner join ecw_customer_commission com on info.commission_id = com.id ",
            "where info.deleted = 0 and com.deleted = 0 and com.customer_id = #{customerId}"
    })
    List<CustomerCommissionInfoDO> selectByCustomerId(@Param("customerId") Long customerId);



}
