package cn.iocoder.yudao.module.customer.dal.mysql.customerAirLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerAirLog.CustomerAirLogDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerAirLog.*;

/**
 * 客户空运日志 Mapper
 * @author 江楠
 */
@Mapper
public interface CustomerAirLogMapper extends AbstractMapper<CustomerAirLogDO> {
    @Override
    default PageResult<CustomerAirLogDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerAirLogQueryVO) {
            CustomerAirLogQueryVO vo = (CustomerAirLogQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerAirLogDO>()
                .eqIfPresent(CustomerAirLogDO::getCustomerId, vo.getCustomerId())
                .eqIfPresent(CustomerAirLogDO::getCustomerNumber, vo.getCustomerNumber())
                .eqIfPresent(CustomerAirLogDO::getIsAir, vo.getIsAir())
                .betweenIfPresent(CustomerAirLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerAirLogDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerAirLogDO> selectList(Object object) {
        if (object instanceof CustomerAirLogQueryVO) {
            CustomerAirLogQueryVO vo = (CustomerAirLogQueryVO)object;
            return selectList(new LambdaQuery<CustomerAirLogDO>()
                .eqIfPresent(CustomerAirLogDO::getCustomerId, vo.getCustomerId())
                .eqIfPresent(CustomerAirLogDO::getCustomerNumber, vo.getCustomerNumber())
                .eqIfPresent(CustomerAirLogDO::getIsAir, vo.getIsAir())
                .betweenIfPresent(CustomerAirLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerAirLogDO::getId));
        }

        return null;
    }
}
