package cn.iocoder.yudao.module.customer.dal.mysql.customerBank;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerBank.CustomerBankDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerBank.*;

/**
 * 客户银行账户 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerBankMapper extends AbstractMapper<CustomerBankDO> {
    @Override
    default PageResult<CustomerBankDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerBankQueryVO) {
            CustomerBankQueryVO vo = (CustomerBankQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerBankDO>()
                .eqIfPresent(CustomerBankDO::getCustomerId, vo.getCustomerId())
                .likeIfPresent(CustomerBankDO::getAccountName, vo.getAccountName())
                .eqIfPresent(CustomerBankDO::getCurrency, vo.getCurrency())
                .likeIfPresent(CustomerBankDO::getBankName, vo.getBankName())
                .eqIfPresent(CustomerBankDO::getBankAccount, vo.getBankAccount())
                .eqIfPresent(CustomerBankDO::getBankCode, vo.getBankCode())
                .eqIfPresent(CustomerBankDO::getAccountType, vo.getAccountType())
                .eqIfPresent(CustomerBankDO::getBankAddress, vo.getBankAddress())
                .eqIfPresent(CustomerBankDO::getStatus, vo.getStatus())
                .betweenIfPresent(CustomerBankDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerBankDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerBankDO> selectList(Object object) {
        if (object instanceof CustomerBankQueryVO) {
            CustomerBankQueryVO vo = (CustomerBankQueryVO)object;
            return selectList(new LambdaQuery<CustomerBankDO>()
                .eqIfPresent(CustomerBankDO::getCustomerId, vo.getCustomerId())
                .likeIfPresent(CustomerBankDO::getAccountName, vo.getAccountName())
                .eqIfPresent(CustomerBankDO::getCurrency, vo.getCurrency())
                .likeIfPresent(CustomerBankDO::getBankName, vo.getBankName())
                .eqIfPresent(CustomerBankDO::getBankAccount, vo.getBankAccount())
                .eqIfPresent(CustomerBankDO::getBankCode, vo.getBankCode())
                .eqIfPresent(CustomerBankDO::getAccountType, vo.getAccountType())
                .eqIfPresent(CustomerBankDO::getBankAddress, vo.getBankAddress())
                .eqIfPresent(CustomerBankDO::getStatus, vo.getStatus())
                .betweenIfPresent(CustomerBankDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerBankDO::getId));
        }

        return null;
    }
}
