package cn.iocoder.yudao.module.customer.dal.mysql.customerCompetitor;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCompetitor.CustomerCompetitorDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerCompetitor.*;

/**
 * 客户竞争对手 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerCompetitorMapper extends AbstractMapper<CustomerCompetitorDO> {
    @Override
    default PageResult<CustomerCompetitorDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerCompetitorQueryVO) {
            CustomerCompetitorQueryVO vo = (CustomerCompetitorQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerCompetitorDO>()
                .likeIfPresent(CustomerCompetitorDO::getName, vo.getName())
                .betweenIfPresent(CustomerCompetitorDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerCompetitorDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerCompetitorDO> selectList(Object object) {
        if (object instanceof CustomerCompetitorQueryVO) {
            CustomerCompetitorQueryVO vo = (CustomerCompetitorQueryVO)object;
            return selectList(new LambdaQuery<CustomerCompetitorDO>()
                .likeIfPresent(CustomerCompetitorDO::getName, vo.getName())
                .betweenIfPresent(CustomerCompetitorDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerCompetitorDO::getId));
        }

        return null;
    }
}
