package cn.iocoder.yudao.module.customer.dal.mysql.customerCredit;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCredit.CustomerCreditDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerCredit.*;

/**
 * 信用等级 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerCreditMapper extends AbstractMapper<CustomerCreditDO> {
    @Override
    default PageResult<CustomerCreditDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerCreditQueryVO) {
            CustomerCreditQueryVO vo = (CustomerCreditQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerCreditDO>()
                .eqIfPresent(CustomerCreditDO::getScoreMax, vo.getScoreMax())
                .eqIfPresent(CustomerCreditDO::getScoreMin, vo.getScoreMin())
                    .orderByDesc(CustomerCreditDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerCreditDO> selectList(Object object) {
        if (object instanceof CustomerCreditQueryVO) {
            CustomerCreditQueryVO vo = (CustomerCreditQueryVO)object;
            return selectList(new LambdaQuery<CustomerCreditDO>()
                .eqIfPresent(CustomerCreditDO::getScoreMax, vo.getScoreMax())
                .eqIfPresent(CustomerCreditDO::getScoreMin, vo.getScoreMin())
                    .orderByDesc(CustomerCreditDO::getId));
        }

        return null;
    }
}
