package cn.iocoder.yudao.module.customer.dal.mysql.customerCreditRule;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCreditRule.CustomerCreditRuleDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerCreditRule.*;

/**
 * 信用规则 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerCreditRuleMapper extends AbstractMapper<CustomerCreditRuleDO> {
    @Override
    default PageResult<CustomerCreditRuleDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerCreditRuleQueryVO) {
            CustomerCreditRuleQueryVO vo = (CustomerCreditRuleQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerCreditRuleDO>()
                .likeIfPresent(CustomerCreditRuleDO::getName, vo.getName())
                .likeIfPresent(CustomerCreditRuleDO::getNameEn, vo.getNameEn())
                .eqIfPresent(CustomerCreditRuleDO::getType, vo.getType())
                .betweenIfPresent(CustomerCreditRuleDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerCreditRuleDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerCreditRuleDO> selectList(Object object) {
        if (object instanceof CustomerCreditRuleQueryVO) {
            CustomerCreditRuleQueryVO vo = (CustomerCreditRuleQueryVO)object;
            return selectList(new LambdaQuery<CustomerCreditRuleDO>()
                .likeIfPresent(CustomerCreditRuleDO::getName, vo.getName())
                .likeIfPresent(CustomerCreditRuleDO::getNameEn, vo.getNameEn())
                .eqIfPresent(CustomerCreditRuleDO::getType, vo.getType())
                .betweenIfPresent(CustomerCreditRuleDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerCreditRuleDO::getId));
        }

        return null;
    }
}
