package cn.iocoder.yudao.module.customer.dal.mysql.customerDetail;

import cn.iocoder.yudao.module.customer.vo.customerDetail.*;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface CustomerDetailMapper {
    /**
     * 查询客户订单
     *
     * @param page
     * @param queryWrapper
     * @return
     */
    IPage<CustomerOrderBackVo> selectCustomerOrderPage(IPage page, @Param(Constants.WRAPPER) Wrapper queryWrapper);


    /**
     * 查询客户报价
     *
     * @param page
     * @param queryWrapper
     * @return
     */
    IPage<CustomerOfferBackVo> selectCustomerOfferPage(IPage page, @Param(Constants.WRAPPER) Wrapper queryWrapper);


    /**
     * 查询跟进分页
     *
     * @param page
     * @param queryWrapper
     * @return
     */
    IPage<CustomerFollowBackVo> selectCustomerFollowPage(IPage page, @Param(Constants.WRAPPER) Wrapper queryWrapper);


    /**
     * 查询客诉分页
     *
     * @param page
     * @param queryWrapper
     * @return
     */
    IPage<CustomerComplaintBackVO> selectCustomerComplaintPage(IPage page, @Param(Constants.WRAPPER) Wrapper queryWrapper);


    /**
     * 查询账单分页
     *
     * @param page
     * @param queryWrapper
     * @return
     */
    IPage<CustomerReceivableBackVO> selectCustomerReceiptPage(IPage page, @Param(Constants.WRAPPER) Wrapper queryWrapper);


    /**
     * 得到订单总数
     *
     * @return
     *//*
    Long getOrderCount(@Param(Constants.WRAPPER) Wrapper queryWrapper);*/

    Long getOrderCountByControl(@Param("customerId") Long customerId,@Param("isControl") Boolean isControl);
    /**
     * 得到订单总数
     *
     * @return
     */
    Long getOrderCountByTransportId(@Param("customerId") Long customerId,@Param("transportId") Long transportId);

    /**
     * 得到下单数
     *
     * @param customerId
     * @return
     */
    Long getBaojiaCount(@Param("customerId") Long customerId);

    /**
     * 得到入仓的总数
     *
     * @param customerId
     * @return
     */
    Long getRucangCount(@Param("customerId") Long customerId);


    /**
     * 得到下单数
     *
     * @param customerId
     * @return
     */
    Long getXiadanCount(@Param("customerId") Long customerId);

    /**
     * 得到出货订单数
     *
     * @param customerId
     * @return
     */
    Long getChuhuoCount(@Param("customerId") Long customerId);

    /**
     * 得到始发仓库订单数
     *
     * @param customerId
     * @return
     */
    Long getStartWareHouseCount(@Param("customerId") Long customerId);

    /**
     * 得到目的仓库订单数
     *
     * @param customerId
     * @return
     */
    Long getEndWareHouseCount(@Param("customerId") Long customerId);

    /**
     * 得到最后的订单数据
     *
     * @param customerId
     * @return
     */
    OrderDto getLastOrderByCustomerId(@Param("customerId") Long customerId);

}
