package cn.iocoder.yudao.module.customer.dal.mysql.customerFollowup;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.CustomerDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerFollowup.CustomerFollowupDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.customer.dto.CustomerPageReqDTO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerFollowup.*;
import org.apache.ibatis.annotations.Param;

/**
 * 客户跟进 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerFollowupMapper extends AbstractMapper<CustomerFollowupDO> {

    List<CustomerFollowupDO> selectPage1(@Param("start") Integer start, @Param("size") Integer size,
                                       @Param("query") CustomerFollowupQueryVO customerFollowupQueryVO);

    Long selectCount1(@Param("query") CustomerFollowupQueryVO customerFollowupQueryVO);


    @Override
    default PageResult<CustomerFollowupDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerFollowupQueryVO) {
            CustomerFollowupQueryVO vo = (CustomerFollowupQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerFollowupDO>()
                .eqIfPresent(CustomerFollowupDO::getNumber, vo.getNumber())
                .eqIfPresent(CustomerFollowupDO::getParentNumber, vo.getParentNumber())
                .eqIfPresent(CustomerFollowupDO::getStatus, vo.getStatus())
                .eqIfPresent(CustomerFollowupDO::getCustomerId, vo.getCustomerId())
                .eqIfPresent(CustomerFollowupDO::getOfferId, vo.getOfferId())
                .eqIfPresent(CustomerFollowupDO::getFollowType, vo.getFollowType())
                .betweenIfPresent(CustomerFollowupDO::getFollowTime, vo.getBeginFollowTime(), vo.getEndFollowTime())
                .likeIfPresent(CustomerFollowupDO::getContactName, vo.getContactName())
                .eqIfPresent(CustomerFollowupDO::getFollowMethod, vo.getFollowMethod())
                .eqIfPresent(CustomerFollowupDO::getFollowUserId, vo.getFollowUserId())
                .eqIfPresent(CustomerFollowupDO::getPurpose, vo.getPurpose())
                .eqIfPresent(CustomerFollowupDO::getResultType, vo.getResultType())
                .eqIfPresent(CustomerFollowupDO::getFeedback, vo.getFeedback())
                .eqIfPresent(CustomerFollowupDO::getAttatchment, vo.getAttatchment())
                .betweenIfPresent(CustomerFollowupDO::getNextTime, vo.getBeginNextTime(), vo.getEndNextTime())
                .eqIfPresent(CustomerFollowupDO::getNextPlan, vo.getNextPlan())
                .betweenIfPresent(CustomerFollowupDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerFollowupDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerFollowupDO> selectList(Object object) {
        if (object instanceof CustomerFollowupQueryVO) {
            CustomerFollowupQueryVO vo = (CustomerFollowupQueryVO)object;
            return selectList(new LambdaQuery<CustomerFollowupDO>()
                .eqIfPresent(CustomerFollowupDO::getNumber, vo.getNumber())
                .eqIfPresent(CustomerFollowupDO::getParentNumber, vo.getParentNumber())
                .eqIfPresent(CustomerFollowupDO::getStatus, vo.getStatus())
                .eqIfPresent(CustomerFollowupDO::getCustomerId, vo.getCustomerId())
                .eqIfPresent(CustomerFollowupDO::getOfferId, vo.getOfferId())
                .eqIfPresent(CustomerFollowupDO::getFollowType, vo.getFollowType())
                .betweenIfPresent(CustomerFollowupDO::getFollowTime, vo.getBeginFollowTime(), vo.getEndFollowTime())
                .likeIfPresent(CustomerFollowupDO::getContactName, vo.getContactName())
                .eqIfPresent(CustomerFollowupDO::getFollowMethod, vo.getFollowMethod())
                .eqIfPresent(CustomerFollowupDO::getFollowUserId, vo.getFollowUserId())
                .eqIfPresent(CustomerFollowupDO::getPurpose, vo.getPurpose())
                .eqIfPresent(CustomerFollowupDO::getResultType, vo.getResultType())
                .eqIfPresent(CustomerFollowupDO::getFeedback, vo.getFeedback())
                .eqIfPresent(CustomerFollowupDO::getAttatchment, vo.getAttatchment())
                .betweenIfPresent(CustomerFollowupDO::getNextTime, vo.getBeginNextTime(), vo.getEndNextTime())
                .eqIfPresent(CustomerFollowupDO::getNextPlan, vo.getNextPlan())
                .betweenIfPresent(CustomerFollowupDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerFollowupDO::getId));
        }

        return null;
    }
}
