package cn.iocoder.yudao.module.customer.dal.mysql.customerLevel;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevel.CustomerLevelDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerLevel.*;

/**
 * 客户级别 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerLevelMapper extends AbstractMapper<CustomerLevelDO> {
    @Override
    default PageResult<CustomerLevelDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerLevelQueryVO) {
            CustomerLevelQueryVO vo = (CustomerLevelQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerLevelDO>()
                .eqIfPresent(CustomerLevelDO::getScoreMax, vo.getScoreMax())
                .eqIfPresent(CustomerLevelDO::getScoreMin, vo.getScoreMin())
                .betweenIfPresent(CustomerLevelDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerLevelDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerLevelDO> selectList(Object object) {
        if (object instanceof CustomerLevelQueryVO) {
            CustomerLevelQueryVO vo = (CustomerLevelQueryVO)object;
            return selectList(new LambdaQuery<CustomerLevelDO>()
                .eqIfPresent(CustomerLevelDO::getScoreMax, vo.getScoreMax())
                .eqIfPresent(CustomerLevelDO::getScoreMin, vo.getScoreMin())
                .betweenIfPresent(CustomerLevelDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerLevelDO::getId));
        }

        return null;
    }
}
