package cn.iocoder.yudao.module.customer.dal.mysql.customerLevelLog;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevelLog.CustomerLevelLogDO;
import cn.iocoder.yudao.module.customer.vo.customerLevelLog.CustomerLevelLogBackVO;
import cn.iocoder.yudao.module.customer.vo.customerLevelLog.CustomerLevelLogQueryVO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 客户等级日志 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface CustomerLevelLogMapper extends AbstractMapper<CustomerLevelLogDO> {
    @Override
    default PageResult<CustomerLevelLogDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerLevelLogQueryVO) {
            CustomerLevelLogQueryVO vo = (CustomerLevelLogQueryVO) object;
            return selectPage(page, new LambdaQuery<CustomerLevelLogDO>()
                    .betweenIfPresent(CustomerLevelLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .eqIfPresent(CustomerLevelLogDO::getCustomerId, vo.getCustomerId())
                    .eqIfPresent(CustomerLevelLogDO::getRuleId, vo.getRuleId())
                    .eqIfPresent(CustomerLevelLogDO::getRemark, vo.getRemark())
                    .orderByDesc(CustomerLevelLogDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerLevelLogDO> selectList(Object object) {
        if (object instanceof CustomerLevelLogQueryVO) {
            CustomerLevelLogQueryVO vo = (CustomerLevelLogQueryVO) object;
            return selectList(new LambdaQuery<CustomerLevelLogDO>()
                    .betweenIfPresent(CustomerLevelLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .eqIfPresent(CustomerLevelLogDO::getCustomerId, vo.getCustomerId())
                    .eqIfPresent(CustomerLevelLogDO::getRuleId, vo.getRuleId())
                    .eqIfPresent(CustomerLevelLogDO::getRemark, vo.getRemark())
                    .orderByDesc(CustomerLevelLogDO::getId));
        }

        return null;
    }


    @ResultType(CustomerLevelLogBackVO.class)
    @Select({
            "<script>",
            "select log.*, ",
            "rule.name, rule.name_en,",
            "rule.type, rule.score from ecw_customer_level_log log ",
            "inner join ecw_customer_level_rule rule on rule.id = log.rule_id ",
            "where log.deleted = 0 and rule.deleted = 0 ",
            "<when test = 'query.customerId != null'>",
            "AND log.`customer_id` = #{query.customerId}",
            "</when>",
            "order by id desc",
            "</script>"
    })
    IPage<CustomerLevelLogBackVO> selectPage(@Param("mPage") IPage<CustomerLevelLogBackVO> mpPage, @Param("query") CustomerLevelLogQueryVO query);
}
