package cn.iocoder.yudao.module.customer.dal.mysql.customerLevelRule;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevelRule.CustomerLevelRuleDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerLevelRule.*;

/**
 * 客户级别规则 Mapper
 * @author 系统管理员
 */
@Mapper
public interface CustomerLevelRuleMapper extends AbstractMapper<CustomerLevelRuleDO> {
    @Override
    default PageResult<CustomerLevelRuleDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerLevelRuleQueryVO) {
            CustomerLevelRuleQueryVO vo = (CustomerLevelRuleQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerLevelRuleDO>()
                .likeIfPresent(CustomerLevelRuleDO::getName, vo.getName())
                .likeIfPresent(CustomerLevelRuleDO::getNameEn, vo.getNameEn())
                .eqIfPresent(CustomerLevelRuleDO::getType, vo.getType())
                .betweenIfPresent(CustomerLevelRuleDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerLevelRuleDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerLevelRuleDO> selectList(Object object) {
        if (object instanceof CustomerLevelRuleQueryVO) {
            CustomerLevelRuleQueryVO vo = (CustomerLevelRuleQueryVO)object;
            return selectList(new LambdaQuery<CustomerLevelRuleDO>()
                .likeIfPresent(CustomerLevelRuleDO::getName, vo.getName())
                .likeIfPresent(CustomerLevelRuleDO::getNameEn, vo.getNameEn())
                .eqIfPresent(CustomerLevelRuleDO::getType, vo.getType())
                .betweenIfPresent(CustomerLevelRuleDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerLevelRuleDO::getId));
        }

        return null;
    }
}
