package cn.iocoder.yudao.module.customer.dal.mysql.customerOperateLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerOperateLog.CustomerOperateLogDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerOperateLog.*;

/**
 * 客户操作日志 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerOperateLogMapper extends AbstractMapper<CustomerOperateLogDO> {
    @Override
    default PageResult<CustomerOperateLogDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerOperateLogQueryVO) {
            CustomerOperateLogQueryVO vo = (CustomerOperateLogQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerOperateLogDO>()
                .eqIfPresent(CustomerOperateLogDO::getNumber, vo.getNumber())
                .eqIfPresent(CustomerOperateLogDO::getCustomerId, vo.getCustomerId())
                .likeIfPresent(CustomerOperateLogDO::getName, vo.getName())
                .eqIfPresent(CustomerOperateLogDO::getOperateType, vo.getOperateType())
                .eqIfPresent(CustomerOperateLogDO::getOldCustomerService, vo.getOldCustomerService())
                .eqIfPresent(CustomerOperateLogDO::getNewCustomerService, vo.getNewCustomerService())
                .eqIfPresent(CustomerOperateLogDO::getOrderId, vo.getOrderId())
                .eqIfPresent(CustomerOperateLogDO::getOrderNo, vo.getOrderNo())
                .eqIfPresent(CustomerOperateLogDO::getRemark, vo.getRemark())
                .eqIfPresent(CustomerOperateLogDO::getOperator, vo.getOperator())
                .betweenIfPresent(CustomerOperateLogDO::getOldEstimateEnterOpenSeaTime, vo.getBeginOldEstimateEnterOpenSeaTime(), vo.getEndOldEstimateEnterOpenSeaTime())
                .betweenIfPresent(CustomerOperateLogDO::getNewEstimateEnterOpenSeaTime, vo.getBeginNewEstimateEnterOpenSeaTime(), vo.getEndNewEstimateEnterOpenSeaTime())
                .betweenIfPresent(CustomerOperateLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerOperateLogDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerOperateLogDO> selectList(Object object) {
        if (object instanceof CustomerOperateLogQueryVO) {
            CustomerOperateLogQueryVO vo = (CustomerOperateLogQueryVO)object;
            return selectList(new LambdaQuery<CustomerOperateLogDO>()
                .eqIfPresent(CustomerOperateLogDO::getNumber, vo.getNumber())
                .eqIfPresent(CustomerOperateLogDO::getCustomerId, vo.getCustomerId())
                .likeIfPresent(CustomerOperateLogDO::getName, vo.getName())
                .eqIfPresent(CustomerOperateLogDO::getOperateType, vo.getOperateType())
                .eqIfPresent(CustomerOperateLogDO::getOldCustomerService, vo.getOldCustomerService())
                .eqIfPresent(CustomerOperateLogDO::getNewCustomerService, vo.getNewCustomerService())
                .eqIfPresent(CustomerOperateLogDO::getOrderId, vo.getOrderId())
                .eqIfPresent(CustomerOperateLogDO::getOrderNo, vo.getOrderNo())
                .eqIfPresent(CustomerOperateLogDO::getRemark, vo.getRemark())
                .eqIfPresent(CustomerOperateLogDO::getOperator, vo.getOperator())
                .betweenIfPresent(CustomerOperateLogDO::getOldEstimateEnterOpenSeaTime, vo.getBeginOldEstimateEnterOpenSeaTime(), vo.getEndOldEstimateEnterOpenSeaTime())
                .betweenIfPresent(CustomerOperateLogDO::getNewEstimateEnterOpenSeaTime, vo.getBeginNewEstimateEnterOpenSeaTime(), vo.getEndNewEstimateEnterOpenSeaTime())
                .betweenIfPresent(CustomerOperateLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerOperateLogDO::getId));
        }

        return null;
    }
}
