package cn.iocoder.yudao.module.customer.dal.mysql.customerPublicCatchLog;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerPublicCatchLog.CustomerPublicCatchLogDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.customerPublicCatchLog.*;

/**
 * 公海客户捞取日志 Mapper
 * @author yanghao
 */
@Mapper
public interface CustomerPublicCatchLogMapper extends AbstractMapper<CustomerPublicCatchLogDO> {
    @Override
    default PageResult<CustomerPublicCatchLogDO> selectPage(PageVO page, Object object) {
        if (object instanceof CustomerPublicCatchLogQueryVO) {
            CustomerPublicCatchLogQueryVO vo = (CustomerPublicCatchLogQueryVO)object;
            return selectPage(page, new LambdaQuery<CustomerPublicCatchLogDO>()
                .eqIfPresent(CustomerPublicCatchLogDO::getCustomerId, vo.getCustomerId())
                .eqIfPresent(CustomerPublicCatchLogDO::getCatchUserId, vo.getCatchUserId())
                .betweenIfPresent(CustomerPublicCatchLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerPublicCatchLogDO::getId));
        }

        return null;
    }

    @Override
    default List<CustomerPublicCatchLogDO> selectList(Object object) {
        if (object instanceof CustomerPublicCatchLogQueryVO) {
            CustomerPublicCatchLogQueryVO vo = (CustomerPublicCatchLogQueryVO)object;
            return selectList(new LambdaQuery<CustomerPublicCatchLogDO>()
                .eqIfPresent(CustomerPublicCatchLogDO::getCustomerId, vo.getCustomerId())
                .eqIfPresent(CustomerPublicCatchLogDO::getCatchUserId, vo.getCatchUserId())
                .betweenIfPresent(CustomerPublicCatchLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(CustomerPublicCatchLogDO::getId));
        }

        return null;
    }
}
