package cn.iocoder.yudao.module.customer.dal.mysql.indirectCustomer;

import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomer.IndirectCustomerDO;
import cn.iocoder.yudao.module.customer.dto.indirectCustomer.IndirectCustomerPageReqDTO;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 间接客户 Mapper
 * @author yanghao
 */
@Mapper
public interface IndirectCustomerMapper extends AbstractMapper<IndirectCustomerDO> {


    IPage<IndirectCustomerDO> getPage(IPage<IndirectCustomerDO> page,
                              @Param(Constants.WRAPPER) Wrapper<IndirectCustomerDO> queryWrapper);

    List<IndirectCustomerDO> getList(@Param(Constants.WRAPPER) Wrapper<IndirectCustomerDO> queryWrapper);

    List<IndirectCustomerDO> getIndirectCustomerPageReq(@Param("start") int start, @Param("size") int size, @Param("query") IndirectCustomerPageReqDTO pageReqVO);

    long getOpenSeaCustomerPageReqCount(@Param("query") IndirectCustomerPageReqDTO pageReqVO);

    List<IndirectCustomerDO> getIndirectCustomerListReq(@Param("query") IndirectCustomerPageReqDTO reqVO);
}
