package cn.iocoder.yudao.module.customer.dal.mysql.indirectCustomerContacts;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomerContacts.IndirectCustomerContactsDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.customer.vo.indirectCustomerContacts.*;

/**
 * 间接客户联系人 Mapper
 * @author yanghao
 */
@Mapper
public interface IndirectCustomerContactsMapper extends AbstractMapper<IndirectCustomerContactsDO> {
    @Override
    default PageResult<IndirectCustomerContactsDO> selectPage(PageVO page, Object object) {
        if (object instanceof IndirectCustomerContactsQueryVO) {
            IndirectCustomerContactsQueryVO vo = (IndirectCustomerContactsQueryVO)object;
            return selectPage(page, new LambdaQuery<IndirectCustomerContactsDO>()
                .eqIfPresent(IndirectCustomerContactsDO::getCustomerId, vo.getCustomerId())
                .likeIfPresent(IndirectCustomerContactsDO::getName, vo.getName())
                .eqIfPresent(IndirectCustomerContactsDO::getSocialNumber, vo.getSocialNumber())
                .eqIfPresent(IndirectCustomerContactsDO::getEmail, vo.getEmail())
                .eqIfPresent(IndirectCustomerContactsDO::getIsDefault, vo.getIsDefault())
                .eqIfPresent(IndirectCustomerContactsDO::getUserid, vo.getUserid())
                .likeIfPresent(IndirectCustomerContactsDO::getUsername, vo.getUsername())
                .eqIfPresent(IndirectCustomerContactsDO::getAreaCode, vo.getAreaCode())
                .eqIfPresent(IndirectCustomerContactsDO::getPhoneNew, vo.getPhoneNew())
                .eqIfPresent(IndirectCustomerContactsDO::getIsAuto, vo.getIsAuto())
                .betweenIfPresent(IndirectCustomerContactsDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(IndirectCustomerContactsDO::getId));
        }

        return null;
    }

    @Override
    default List<IndirectCustomerContactsDO> selectList(Object object) {
        if (object instanceof IndirectCustomerContactsQueryVO) {
            IndirectCustomerContactsQueryVO vo = (IndirectCustomerContactsQueryVO)object;
            return selectList(new LambdaQuery<IndirectCustomerContactsDO>()
                .eqIfPresent(IndirectCustomerContactsDO::getCustomerId, vo.getCustomerId())
                .likeIfPresent(IndirectCustomerContactsDO::getName, vo.getName())
                .eqIfPresent(IndirectCustomerContactsDO::getSocialNumber, vo.getSocialNumber())
                .eqIfPresent(IndirectCustomerContactsDO::getEmail, vo.getEmail())
                .eqIfPresent(IndirectCustomerContactsDO::getIsDefault, vo.getIsDefault())
                .eqIfPresent(IndirectCustomerContactsDO::getUserid, vo.getUserid())
                .likeIfPresent(IndirectCustomerContactsDO::getUsername, vo.getUsername())
                .eqIfPresent(IndirectCustomerContactsDO::getAreaCode, vo.getAreaCode())
                .eqIfPresent(IndirectCustomerContactsDO::getPhoneNew, vo.getPhoneNew())
                .eqIfPresent(IndirectCustomerContactsDO::getIsAuto, vo.getIsAuto())
                .betweenIfPresent(IndirectCustomerContactsDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(IndirectCustomerContactsDO::getId));
        }

        return null;
    }
}
