package cn.iocoder.yudao.module.customer.dal.mysql.syncAirCustomer;

import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerContacts.CustomerContactsDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.syncAirCustomer.SyncAirCustomerDO;
import cn.iocoder.yudao.module.customer.vo.customer.vo.UserVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 同步空运客户 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface SyncAirCustomerMapper extends AbstractMapper<SyncAirCustomerDO> {

    @ResultType(CustomerContactsDO.class)
    @Select({
            "<script>",
            "select *  from ecw_customer_contacts s where concat_ws('',s.area_code,s.phone_new) = #{phone}",
            "</script>"
    })
    List<CustomerContactsDO> getAllCustomerContactByPhone(@Param("phone") String query);


    @ResultType(UserVo.class)
    @Select({
            "<script>",
            "select id,username from system_user t where t.username in ('001','002','003','004','005','006','007','008','009')",
            "</script>"
    })
    List<UserVo> getUserMapList();

}
