package cn.iocoder.yudao.module.customer.dal.mysql.zhongPao;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.customer.dal.dataobject.zhongPao.ZhongPaoDO;
import cn.iocoder.yudao.module.customer.vo.zhongPao.ZhongPaoQueryVO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 重泡货配置 Mapper
 * @author yanghao
 */
@Mapper
public interface ZhongPaoMapper extends AbstractMapper<ZhongPaoDO> {
    @Override
    default PageResult<ZhongPaoDO> selectPage(PageVO page, Object object) {
        if (object instanceof ZhongPaoQueryVO) {
            ZhongPaoQueryVO vo = (ZhongPaoQueryVO)object;
            return selectPage(page, new LambdaQuery<ZhongPaoDO>()
                .eqIfPresent(ZhongPaoDO::getType, vo.getType())
                .eqIfPresent(ZhongPaoDO::getDepartureId, vo.getDepartureId())
                .eqIfPresent(ZhongPaoDO::getObjectiveIds, vo.getObjectiveIds())
                .eqIfPresent(ZhongPaoDO::getStatus, vo.getStatus())
                .betweenIfPresent(ZhongPaoDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ZhongPaoDO::getId));
        }

        return null;
    }

    @Override
    default List<ZhongPaoDO> selectList(Object object) {
        if (object instanceof ZhongPaoQueryVO) {
            ZhongPaoQueryVO vo = (ZhongPaoQueryVO)object;
            return selectList(new LambdaQuery<ZhongPaoDO>()
                .eqIfPresent(ZhongPaoDO::getType, vo.getType())
                .eqIfPresent(ZhongPaoDO::getDepartureId, vo.getDepartureId())
                .eqIfPresent(ZhongPaoDO::getObjectiveIds, vo.getObjectiveIds())
                .eqIfPresent(ZhongPaoDO::getStatus, vo.getStatus())
                .betweenIfPresent(ZhongPaoDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ZhongPaoDO::getId));
        }

        return null;
    }
}
