package cn.iocoder.yudao.module.customer.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ApiModel("管理后台 - 客户佣金根据订单的条件查询 dto")
public class CustomerCommissionQueryDto {

    @ApiModelProperty(value = "客户id")
    @NotNull(message = "客户id")
    private Long customerId;

    @ApiModelProperty(value = "线路id")
    private Long lineId;

    @ApiModelProperty(value = "产品id")
    private Long productId;

    @ApiModelProperty(value = "报关类别：我司全代：1，自单代报：2，混合报关：3")
    private Integer customsType;

    @ApiModelProperty(value = "产品备案(0 无牌 1 有牌 2 中性)")
    private Integer approval;

    @ApiModelProperty(value = "原价运费")
    private BigDecimal orgFreight;

    @ApiModelProperty(value = "运费货币ID")
    private Integer freightCurrencyId;

    @ApiModelProperty(value = "运费计量单位ID")
    private Long freightVolumeId;


}
