package cn.iocoder.yudao.module.customer.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户延期审核详情
* @author zhengYi
*/
@Data
@ApiModel("客户延期审核详情")
public class CustomerDelayApprovalInfoDto {

    @ApiModelProperty(value = "主键ID")
    private Long approvalId;

    @ApiModelProperty(value = "客户ID", required = true)
    private Long customerId;

    @ApiModelProperty(value = "客户名称")
    private String customerName;

    @ApiModelProperty(value = "客户编号")
    private String customerNumber;

    @ApiModelProperty(value = "客户创建时间")
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    private Date customerCreateTime;

    @ApiModelProperty(value = "流程表单实例ID")
    private String formId;

    @ApiModelProperty(value = "审批类型 1 延迟进入公海")
    private Integer type;

    /**
     * 预计进入公海时间
     */
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    @ApiModelProperty(value = "原预计进入公海时间")
    private Date orgEstimateEnterOpenSeaTime;

    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    @ApiModelProperty(value = "新的预计进入公海时间")
    private Date estimateEnterOpenSeaTime;

    @ApiModelProperty(value = "跟进业务员(客服或经理)")
    private String followUpSalesmanId;

    @ApiModelProperty(value = "跟进业务员(客服或经理)")
    private String followUpSalesmanName;

    @ApiModelProperty(value = "申请凭证")
    private String voucher;

    @ApiModelProperty(value = "申请原因")
    private String reason;

    @ApiModelProperty(value = "状态：0 初始状态 1 处理中 2 通过 3 不通过 4 取消")
    private Integer status;

    @ApiModelProperty(value = "处理结果")
    private String processingResults;

    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "结束人")
    private String finishBy;

    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束时间")
    private Date finishTime;


    @ApiModelProperty(value = "抄送人(id逗号拼接)")
    private String ccIds;

    @ApiModelProperty(value = "备注")
    private String remarks;

}
