package cn.iocoder.yudao.module.customer.dto;

import cn.iocoder.yudao.module.customer.vo.customer.vo.CustomerHandOverReqVO;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户移交审核详情
* @author zhengYi
*/
@Data
@ApiModel("客户移交审核详情")
public class CustomerHandoverApprovalInfoDto {

    @ApiModelProperty(value = "审批类型 1 延迟进入公海 2 移交审批")
    private Integer type;

    @ApiModelProperty(value = "移交客户对象列表")
    private List<CustomerHandoverDetailDto> customerHandoverDetailDtoList;

    @ApiModelProperty(value = "新客户经理id")
    private Long newCustomerServiceId;

    @ApiModelProperty(value = "新客户经理名称")
    private String newCustomerServiceName;

    @ApiModelProperty(value = "新客户经理部门")
    private String newCustomerServiceDeptName;

    @ApiModelProperty(value = "申请原因")
    private String reason;





    @ApiModelProperty(value = "主键ID")
    private Long approvalId;

    @ApiModelProperty(value = "流程表单实例ID")
    private String formId;

    @ApiModelProperty(value = "状态：0 初始状态 1 处理中 2 通过 3 不通过 4 取消")
    private Integer status;

    @ApiModelProperty(value = "处理结果")
    private String processingResults;

    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "结束人")
    private String finishBy;

    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束时间")
    private Date finishTime;


    @ApiModelProperty(value = "抄送人(id逗号拼接)")
    private String ccIds;

    @ApiModelProperty(value = "备注")
    private String remarks;

}
