package cn.iocoder.yudao.module.customer.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
 * 移交客户对象
 *
 * @author zhengYi
 */
@Data
@ApiModel("移交客户对象")
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
public class CustomerHandoverDetailDto {

    @ApiModelProperty(value = "客户ID")
    private Long customerId;

    @ApiModelProperty(value = "客户名称")
    private String customerName;

    @ApiModelProperty(value = "客户名称En")
    private String customerNameEn;

    @ApiModelProperty(value = "客户编号")
    private String customerNumber;


    @ApiModelProperty(value = "原客户经理id")
    private Long oldCustomerServiceId;

    @ApiModelProperty(value = "原客户经理id")
    private String oldCustomerServiceName;

    @ApiModelProperty(value = "原客户经理部门")
    private String oldCustomerServiceDeptName;


    @ApiModelProperty(value = "老的预计进入公海的时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date oldEstimateEnterOpenSeaTime;

}
