package cn.iocoder.yudao.module.customer.dto.indirectCustomer;

import cn.iocoder.yudao.framework.common.pojo.PageParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;
@Data
@ApiModel("管理后台 - 间接客户查询 DTO")
public class IndirectCustomerPageReqDTO  {

    @ApiModelProperty(value = "客户编号")
    private String number;

    @ApiModelProperty(value = "客户名称")
    private String name;

    @ApiModelProperty(value = "客户来源id")
    private Long agentId;

    @ApiModelProperty(value = "客户经理")
    private List<Long> customerService;


    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;



    @ApiModelProperty(value = "主联系人")
    private String defaultContactName;

    @ApiModelProperty(value = "主联系电话")
    private String defaultContactPhone;

    @ApiModelProperty(value = "市场获客")
    private List<Integer> marketType;

    /**
     * 客户来源
     */
    private List<Integer>  source;

    @ApiModelProperty(value = "会员编号")
    private String memberCode;
    @ApiModelProperty(value = "会员名称")
    private String memberName;
    @ApiModelProperty(value = "会员手机")
    private String memberMobile;
    @ApiModelProperty(value = "会员区号")
    private String memberAreaCode;
}
