package cn.iocoder.yudao.module.customer.listener;


import cn.iocoder.yudao.framework.apollo.core.event.AdminClientCreateEvent;
import cn.iocoder.yudao.module.customer.service.indirectCustomer.IndirectCustomerService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

import java.util.Objects;

/**
 * 会员创建收货人事件监听器
 *
 * @author yanghao
 */
@Component("AdminClientCreateEventListener")
@AllArgsConstructor
@Slf4j
public class AdminClientCreateEventListener {

    private final IndirectCustomerService indirectCustomerService;
    /**
     * 有最新编号记录则执行修改或插入操作，无最新编号记录执行查询最新编号记录操作
     *
     * @param event 编号记录
     */
    // @EventListener(AdminClientCreateEvent.class)
    public void orderNumberLongEvent(AdminClientCreateEvent event) {
        if (Objects.isNull(event)){
            log.error("会员创建收货人监听事件为空");
            return;
        }
        if (event.getUid() != null){
            try {
                // indirectCustomerService.createIndirectCustomer(event);
            } catch (Exception e) {
                log.error("会员创建收货人监听事件 - 创建间接客户失败", e);
            }

        }

    }
}
