package cn.iocoder.yudao.module.customer.service.customer;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.BooleanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.iocoder.yudao.framework.apollo.core.event.AssignConfirmedCustomerEvent;
import cn.iocoder.yudao.framework.apollo.core.event.Customer.ReceiveCustomerCalTypeEvent;
import cn.iocoder.yudao.framework.apollo.core.event.AutoProcessNotCustomerServiceExceptionEvent;
import cn.iocoder.yudao.framework.apollo.core.event.Customer.ReceiveCustomerCalTypeEvent;
import cn.iocoder.yudao.framework.apollo.core.event.QueryEstimateEnterOpenSeaTimeEvent;
import cn.iocoder.yudao.framework.apollo.core.event.Customer.CalculateCustomerTypeEvent;
import cn.iocoder.yudao.framework.apollo.core.vo.ApplyInfoVO;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.date.DateUtils;
import cn.iocoder.yudao.framework.common.util.json.JsonUtils;
import cn.iocoder.yudao.framework.dict.core.dto.DictDataRespDTO;
import cn.iocoder.yudao.framework.dict.core.util.DictFrameworkUtils;
import cn.iocoder.yudao.framework.i18n.core.I18nMessage;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.security.core.LoginUser;
import cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils;
import cn.iocoder.yudao.framework.web.core.util.WebFrameworkUtils;
import cn.iocoder.yudao.module.bpm.api.BpmCreateServiceFactory;
import cn.iocoder.yudao.module.bpm.resp.TaskResp;
import cn.iocoder.yudao.module.customer.convert.customer.CustomerConvert;
import cn.iocoder.yudao.module.customer.convert.customer.line.CustomerLineConvert;
import cn.iocoder.yudao.module.customer.convert.customerBank.CustomerBankConvert;
import cn.iocoder.yudao.module.customer.convert.customerContacts.CustomerContactsConvert;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.CustomerDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.line.CustomerLineDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerAirLog.CustomerAirLogDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerApproval.CustomerApprovalDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerBank.CustomerBankDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerContacts.CustomerContactsDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerPublicCatchLog.CustomerPublicCatchLogDO;
import cn.iocoder.yudao.module.customer.dal.mysql.customer.CustomerLineMapper;
import cn.iocoder.yudao.module.customer.dal.mysql.customer.CustomerMapper;
import cn.iocoder.yudao.module.customer.dal.mysql.customerAirLog.CustomerAirLogMapper;
import cn.iocoder.yudao.module.customer.dal.mysql.customerBank.CustomerBankMapper;
import cn.iocoder.yudao.module.customer.dal.mysql.customerContacts.CustomerContactsMapper;
import cn.iocoder.yudao.module.customer.dal.mysql.customerPublicCatchLog.CustomerPublicCatchLogMapper;
import cn.iocoder.yudao.module.customer.dto.*;
import cn.iocoder.yudao.module.customer.service.customerApproval.CustomerApprovalService;
import cn.iocoder.yudao.module.customer.service.customerContacts.CustomerContactsService;
import cn.iocoder.yudao.module.customer.service.customerOperateLog.CustomerOperateLogService;
import cn.iocoder.yudao.module.customer.vo.customer.customerContacts.CustomerContactsBaseVO;
import cn.iocoder.yudao.module.customer.vo.customer.customerContacts.CustomerContactsCreateReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.customerContacts.CustomerContactsUpdateReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.line.CustomerLineCreateReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.line.CustomerLineUpdateReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.vo.*;
import cn.iocoder.yudao.module.customer.vo.customerBank.CustomerBankCreateReqVO;
import cn.iocoder.yudao.module.customer.vo.customerBank.CustomerBankUpdateReqVO;
import cn.iocoder.yudao.module.customer.vo.customerDetail.CustomerOrderBackPageVO;
import cn.iocoder.yudao.module.customer.vo.customerOperateLog.CustomerOperateLogCreateReqVO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.country.CountryDO;
import cn.iocoder.yudao.module.ecw.enums.*;
import cn.iocoder.yudao.module.ecw.service.country.CountryService;
import cn.iocoder.yudao.module.ecw.service.internalMessage.InternalMessageService;
import cn.iocoder.yudao.module.ecw.service.paramValid.ParamValidatorService;
import cn.iocoder.yudao.module.ecw.vo.internalMessage.InternalMessageCreateReqVO;
import cn.iocoder.yudao.module.member.api.user.MemberUserApi;
import cn.iocoder.yudao.module.system.api.dept.DeptApi;
import cn.iocoder.yudao.module.system.api.dept.dto.DeptRespDTO;
import cn.iocoder.yudao.module.system.api.user.AdminUserApi;
import cn.iocoder.yudao.module.system.api.user.dto.AdminUserRespDTO;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import lombok.extern.log4j.Log4j2;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Param;
import org.redisson.api.RLock;
import org.redisson.api.RedissonClient;
import org.springframework.context.ApplicationContext;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils.getLoginUserId;
import static cn.iocoder.yudao.module.bpm.enums.WorkFlowEmus.QUOTATION_CUSTOMER_DELAY_PUBLIC;
import static cn.iocoder.yudao.module.bpm.enums.WorkFlowEmus.QUOTATION_CUSTOMER_HANDOVER;
import static cn.iocoder.yudao.module.ecw.enums.ErrorCodeConstants.*;

/**
 * 客户 Service 实现类
 *
 * @author yanghao
 */
@Log4j2
@Service
@Validated
public class CustomerServiceImpl extends AbstractService<CustomerMapper,
        CustomerDO> implements CustomerService {

    @Resource
    private CustomerMapper customerMapper;


    @Resource
    private ParamValidatorService paramValidatorService;


    @Resource
    private CustomerAirLogMapper customerAirLogMapper;

    @Resource
    private CustomerContactsMapper customerContactsMapper;

    @Resource
    private CustomerContactsService customerContactsService;

    @Resource
    private CustomerLineMapper customerLineMapper;

    @Resource
    CustomerBankMapper customerBankMapper;

    @Resource
    private MemberUserApi memberUserApi;

    @Resource
    private AdminUserApi adminUserApi;

    @Resource
    private DeptApi deptApi;

    @Resource
    private CustomerPublicCatchLogMapper customerPublicCatchLogMapper;

    @Resource
    private CustomerApprovalService customerApprovalService;

    @Resource
    private BpmCreateServiceFactory bpmCreateServiceFactory;

    @Resource
    private CountryService countryService;

    @Resource
    private CustomerOperateLogService customerOperateLogService;

    @Resource
    private InternalMessageService internalMessageService;

    @Resource
    private ApplicationContext applicationContext;

    @Resource
    private RedissonClient redissonClient;

    public static final String logFormat = "[%d]联系人：%s 区号：%s 电话：%s 默认：(%s)";

    //合并操作日志
    public void doMergeCustomerOperateLog(long customer_id1, long customer_id2) {

        customerMapper.doMergeCustomerOperateLog(customer_id1, customer_id2);
    }

    //合并客户信用日志
    public void doMergeCustomerCreditLog(long customer_id1, long customer_id2) {
        customerMapper.doMergeCustomerCreditLog(customer_id1, customer_id2);
    }

    //合并客户登记日志
    public void doMergeCustomerLevelLog(long customer_id1, long customer_id2) {
        customerMapper.doMergeCustomerLevelLog(customer_id1, customer_id2);
    }


    /*
     发货人带来的收货人，
     改为进入待分配列表
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public CustomerContactsDO createConsigeeCustomer(String name,
                                                     String areaCode,
                                                     String phone,
                                                     String company,
                                                     String email,
                                                     CustomerDO consignorCustomerDO,
                                                     String orderNo) {
        Long customerService = null;

        if (consignorCustomerDO != null) {
            customerService = consignorCustomerDO.getCustomerService();

            // 待分配。 若是发货人为代理和同行时，订单的收货人不同步到待分配客户
            boolean isProxyConsignor = StringUtils.isNotEmpty(consignorCustomerDO.getRoles())
                    && (consignorCustomerDO.getRoles().contains("2") || consignorCustomerDO.getRoles().contains("3"));
            if (isProxyConsignor) {
                log.info("若是发货人为代理和同行时，订单的收货人不同步到待分配客户");
                return null;
            }
        }

        CustomerCreateReqVO customerCreateReqVO = new CustomerCreateReqVO();

        // 订单发货人是否人跟进客户经理，有则分配给客户经理待接收，没有则放到待分配客户。
        if (customerService != null) {
            // 发货人客户经理
            // 修改为进入待分配列表
            //修改发货人带来的收货人，进入待分配列表，只需要改此处
            //customerCreateReqVO.setCustomerService(customerService);
            customerCreateReqVO.setCustomerService(null);
            // 第1个发货人客户经理
            //customerCreateReqVO.setConsigneeFirstCustomerService(customerService);
            customerCreateReqVO.setConsigneeFirstCustomerService(null);
            //end  修改为进入待分配列表
        }


        customerCreateReqVO.setName(name);
        customerCreateReqVO.setCompany(company);
        customerCreateReqVO.setCreateTime(new Date());

        customerCreateReqVO.setType("1"); // 收货人
        customerCreateReqVO.setSource(12); // 发货人推荐
        customerCreateReqVO.setResourceType(2); // 公司客户
        // 状态为已成交
        customerCreateReqVO.setStatus(CustomerStatusEnum.DEAL.getValue());
        // web订单收货人
        customerCreateReqVO.setIsWebOrderConsigneeSync(true);

        CustomerContactsCreateReqVO customerContactsCreateReqVO =
                new CustomerContactsCreateReqVO();
        customerContactsCreateReqVO.setName(name);
        customerContactsCreateReqVO.setPhoneNew(phone);
        customerContactsCreateReqVO.setIsDefault(1);

        CountryDO countryDO = countryService.getCountry(areaCode);
        customerContactsCreateReqVO.setAreaCode(countryDO.getTel());
        customerCreateReqVO.setCountry(countryDO.getId());

        customerCreateReqVO.setCustomerContacts(Arrays.asList(customerContactsCreateReqVO));
        //customerCreateReqVO.setCustomerOperateLogRemark("管理端创建收货人时关联创建客户");
        // 修改日志记录信息
        customerCreateReqVO.setCustomerOperateLogRemark("管理端创建收货人时关联创建客户，进待分配列表");
        customerCreateReqVO.setCustomerOperateLogOrderNo(orderNo);

        customerCreateReqVO.setCreateFrom(CustomerCreateFromEnum.APP_CONSIGNOR.getValue());

        Long customerId = this.createCustomer(customerCreateReqVO);

        List<CustomerContactsDO> customerContactsDOS =
                customerContactsMapper.selectList(new LambdaQueryWrapperX<CustomerContactsDO>().eq(CustomerContactsDO::getCustomerId, customerId).eq(CustomerContactsDO::getIsDefault, true));

        return customerContactsDOS.stream().findFirst().orElse(new CustomerContactsDO());
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Long createCustomer(CustomerCreateReqVO createReqVO) {

        //创建人
        if (createReqVO.getFounder() == null) {
            createReqVO.setFounder(WebFrameworkUtils.getLoginUserId());
        }

        if (createReqVO.getResourceType() == null) {
            //1. web端新增订单的收货人 2. 注册的会员  这两个是公司资源，会被设置为2。未设置的即是其他途径新建的，即是自主开发的。
            createReqVO.setResourceType(1); //自主开发
        }

        //若国家为空，则根据默认手机号码的国家来设置
        if (createReqVO.getCountry() == null) {
            List<CustomerContactsCreateReqVO> customerContacts = createReqVO.getCustomerContacts();
            if (CollectionUtil.isNotEmpty(customerContacts)) {
                CustomerContactsCreateReqVO customerContactsCreateReqVO = customerContacts.stream().filter(t -> Objects.equals(t.getIsDefault(), 1)).findFirst().orElse(null);
                if (customerContactsCreateReqVO != null) {
                    String areaCode = customerContactsCreateReqVO.getAreaCode();
                    if (StringUtils.isNotEmpty(areaCode)) {
                        CountryDO country = countryService.getCountry(areaCode);
                        if (country != null) {
                            createReqVO.setCountry(country.getId());
                        }
                    }
                }
            }
        }

        // 插入
        CustomerDO customer = CustomerConvert.INSTANCE.convert(createReqVO);

        String customerServiceConfirmedStr = "";
        //20221227 #1947 在全部客户列表新增的客户，新建人跟客户经理一致的话，不用再去到待接受客户，直接到我的客户列表
        if (customer.getCustomerService() != null && WebFrameworkUtils.getLoginUserId().equals(customer.getCustomerService())
                && Boolean.FALSE.equals(createReqVO.getIsWebOrderConsigneeSync())) {
            customer.setIsCustomerServiceConfirmed(true);
            customerServiceConfirmedStr = " 创建人与客户经理一致";
        }

        //待分配页面进来的，需要直接分配给客户经理
        if (Boolean.TRUE.equals(customer.getIsCustomerServiceConfirmed())) {
            // 分配时间
            customer.setCustomerServiceAssignedTime(new Date());
            // 设置跟进客户经理
            customer.setCustomerService(WebFrameworkUtils.getLoginUserId());

            // 获取方式：自主创建
            customer.setGetMethod(CustomerGetMethodEnum.CREATE.getValue());

            // 归属时间：当前时间
            customer.setCustomerServiceConfirmedTime(new Date());

            boolean isFcl = isFcl(customer);

            if (isFcl) {
                customer.setEstimateEnterOpenSeaTime(null);
            } else {
                // 接收后一个月，无任何报价、下单则掉入公海
                //Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(new Date(), 1).toJdkDate();
                Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(new Date(), 3).toJdkDate(); //改为3个月
                if (customer.getEstimateEnterOpenSeaTime() == null || customer.getEstimateEnterOpenSeaTime().compareTo(estimateEnterOpenSeaTime) == -1) {
                    customer.setEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime);
                }
            }

            customerServiceConfirmedStr += " 已接收";
        } else {

            // 若客户经理不为空但分配时间为空，则设置分配时间为当前时间
            if (customer.getCustomerService() != null && customer.getCustomerServiceAssignedTime() == null) {
                // 分配时间
                customer.setCustomerServiceAssignedTime(new Date());
                customer.setIsCustomerServiceConfirmed(false);
                customer.setIsInOpenSea(false);
            }
            Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(new Date(), 3).toJdkDate(); //改为3个月
            customer.setEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime);

        }

        Long customerIdNew = null;
        Long countryId = customer.getCountry();
        // customer.setResourceType(null);

        RLock rLock = redissonClient.getLock("customer_number");
        try {
            boolean success = rLock.tryLock(5, 5, TimeUnit.SECONDS);
            if (!success) throw new ServiceException(500, "操作忙，请稍后再试");

            String customerNumber = genCustomerNumber(countryId);
            customer.setNumber(customerNumber);

            //添加用户
            customerMapper.insert(customer);
            customerIdNew = customer.getId();

        } catch (InterruptedException e) {
            e.printStackTrace();
        } finally {
            if (rLock.isLocked()) {
                rLock.unlock();
            }
        }

        Long customerId = customerIdNew;

        if (customerId != null) {
            //设置银行账号
            List<CustomerBankCreateReqVO> customerBanks = createReqVO.getCustomerBanks();
            if (CollectionUtil.isNotEmpty(customerBanks)) {
                List<CustomerBankDO> customerBankDOList = customerBanks.stream().map(reqVO -> {
                    CustomerBankDO convert = CustomerBankConvert.INSTANCE.convert(reqVO);
                    convert.setCustomerId(customerId);
                    return convert;
                }).collect(Collectors.toList());
                customerBankMapper.insertBatch(customerBankDOList);
            }

            //设置联系人
            List<CustomerContactsCreateReqVO> customerContacts = createReqVO.getCustomerContacts();
            if (!CollectionUtils.isEmpty(customerContacts)) {

                for (CustomerContactsCreateReqVO customerContactReq : customerContacts) {

                    associateContact(customerId, customerContactReq);
                }
            }

            //客户路线
            List<CustomerLineCreateReqVO> customerLines = createReqVO.getCustomerLines();
            if (!CollectionUtils.isEmpty(customerLines)) {
                List<CustomerLineDO> customerLineDOList = customerLines.stream().map(customerLineCreateReqVO -> {
                    CustomerLineDO customerLineDO = CustomerLineConvert.INSTANCE.convert(customerLineCreateReqVO);
                    customerLineDO.setCustomerId(customerId);
                    return customerLineDO;
                }).collect(Collectors.toList());
                customerLineMapper.insertBatch(customerLineDOList);
            }

            //纪录创建日志
            String remark = createReqVO.getCustomerOperateLogRemark() != null ?
                    (createReqVO.getCustomerOperateLogRemark() + customerServiceConfirmedStr) : customerServiceConfirmedStr;
            String customerOperateLogOrderNo = createReqVO.getCustomerOperateLogOrderNo();

            CustomerDO customerDO = customerMapper.selectById(customerId);
            LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
            CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                    .setOperator(loginUser == null ? null : loginUser.getId())
                    .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                    .setCustomerId(customerDO.getId())
                    .setNumber(customerDO.getNumber())
                    .setName(customerDO.getName())
                    .setOldCustomerService(null)
                    .setNewCustomerService(customerDO.getCustomerService())
                    .setOldEstimateEnterOpenSeaTime(null)
                    .setNewEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                    .setOrderId(null)
                    .setOrderNo(customerOperateLogOrderNo)
                    .setOperateType(CustomerOperateTypeEnum.CREATE.getValue())
                    .setRemark(remark);
            customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
        }

        // 返回
        return customerId;
    }

    @Override
    public boolean isFcl(CustomerDO customer) {
        boolean isFcl = StringUtils.isNotEmpty(customer.getTransportType())
                && customer.getTransportType().contains("3");
        return isFcl;
    }

    private String genCustomerNumber(Long countryId) {
        //生成客户编码
        String nameShort = "TMP";
        Long maxNumber = 0L;

        if (countryId == null) {
            countryId = 0L;
        }

        CountryDO countryDO = countryService.getCountry(countryId);
        if (countryDO != null) {
            nameShort = countryDO.getNameShort();
        }
        if (StringUtils.isEmpty(nameShort) || nameShort.equals("TMP")) {
            nameShort = "TMP";
            maxNumber = customerMapper.getCustomerTmpMaxNumber(nameShort);
        } else {
            maxNumber = customerMapper.getCustomerCountryMaxNumber(nameShort);
        }
        if (maxNumber == null) {
            maxNumber = 0L;
        }
        maxNumber += 1;

        //小于4位 前面补0
        String number = StrUtil.fillBefore(String.valueOf(maxNumber), '0', 5);
        String customerNumber = nameShort + number;
        return customerNumber;
    }

    private void associateContact(Long customerId, CustomerContactsCreateReqVO customerContactReq) {
        CustomerContactsDO customerContactsDO = customerContactsService.getUniqueOneAndValidate(customerContactReq.getAreaCode(), customerContactReq.getPhoneNew(), null);

        if (customerContactsDO != null) {
            // customerContactsDO.setCustomerId(customerId);
            // //设置是否默认
            // customerContactsDO.setIsDefault(customerContactReq.getIsDefault());
            // //当请求联系人设置有关系帐号时，则将其设置进去
            // if (customerContactReq.getUserid() != null && customerContactsDO.getUserid() == null) {
            //     customerContactsDO.setUserid(customerContactReq.getUserid());
            // }
            // customerContactsMapper.updateById(customerContactsDO);

            throw exception(ErrorCodeConstants.CUSTOMER_CONTACTS_ALREADY_BIND, customerContactReq.getPhoneNew());
        } else {
            customerContactsDO = CustomerContactsConvert.INSTANCE.convert(customerContactReq);
            customerContactsDO.setCustomerId(customerId);
            customerContactsMapper.insert(customerContactsDO);
        }

    }

    @Override
    public void updateCustomer(CustomerUpdateReqVO updateReqVO) {
        // 校验存在
        Long customerId = updateReqVO.getId();

        this.validateCustomerExists(customerId);

        CustomerDO customerOld = customerMapper.selectOne(CustomerDO::getId, customerId);

        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                .setOperator(loginUser == null ? null : loginUser.getId())
                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                .setCustomerId(customerOld.getId())
                .setNumber(customerOld.getNumber())
                .setName(customerOld.getName());

        // 更新
        CustomerDO customerNew = CustomerConvert.INSTANCE.convert(updateReqVO);


        boolean isFcl = isFcl(customerNew);

        //完善信息后，就代表被接收，就退出公海池
        if (!Boolean.TRUE.equals(customerOld.getIsCustomerServiceConfirmed())
                && Boolean.TRUE.equals(customerNew.getIsCustomerServiceConfirmed())) {
            Date now = new Date();
            //退出公海
            customerNew.setIsInOpenSea(false);

            //更新客户经理
            customerNew.setCustomerService(WebFrameworkUtils.getLoginUserId());
            //设置接收
            customerNew.setIsCustomerServiceConfirmed(true);
            //老的无分配时间时，需要设置分配时间
            if (customerOld.getCustomerServiceAssignedTime() == null) {
                customerNew.setCustomerServiceAssignedTime(now);
            }
            // 获取方式：分配/移交接收
            customerNew.setGetMethod(CustomerGetMethodEnum.ASSIGN.getValue());
            //老的归属时间为空，就设置归属时间
            customerNew.setCustomerServiceConfirmedTime(now);

            //设置预计进行公海池时间
            //海运整柜 不掉入公海
            if (isFcl) {
                customerNew.setEstimateEnterOpenSeaTime(null);
            } else {
                //Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(now, 1).toJdkDate();
                Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(now, 3).toJdkDate();//改为3个月
                if (customerNew.getEstimateEnterOpenSeaTime() == null || customerNew.getEstimateEnterOpenSeaTime().compareTo(estimateEnterOpenSeaTime) == -1) {
                    customerNew.setEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime);
                }
            }

            //纪录接收日志
            customerOperateLogCreateReqVO.setOperateType(CustomerOperateTypeEnum.RECEIVE.getValue())
                    .setNewCustomerService(customerNew.getCustomerService())
                    .setOldCustomerService(customerOld.getCustomerService())
                    .setNewEstimateEnterOpenSeaTime(isFcl ? null : customerNew.getEstimateEnterOpenSeaTime())
                    .setOldEstimateEnterOpenSeaTime(customerOld.getEstimateEnterOpenSeaTime())
                    .setUpdateBody(JSONObject.toJSONString(updateReqVO))
                    .setRemark("完善-确认接收" + (isFcl ? "(整柜客户)" : ""));

            //分配确认接收回调
            applicationContext.publishEvent(new AssignConfirmedCustomerEvent(customerId, customerNew.getCustomerService()));

            //完善客户信息顺便确认接收，对客户类型做逻辑运算
            // 添加接收确认后判断客户是新客户还是老客户逻辑
            //前面的逻辑有可能改了客户的业绩类型，需要再次获取客户信息
            CustomerDO customer2 = customerMapper.selectById(customerId);
            ReceiveCustomerCalTypeEvent event = new ReceiveCustomerCalTypeEvent();
            event.setCustomerId(customerId);
            event.setCustomerNumber(customer2.getNumber());
            event.setIsNew(customer2.getIsNew());
            applicationContext.publishEvent(event);
            //end  添加接收确认后判断客户是新客户还是老客户逻辑


        } else {
            //纪录编辑日志
            customerOperateLogCreateReqVO.setOperateType(CustomerOperateTypeEnum.UPDATE.getValue())
                    .setNewCustomerService(customerNew.getCustomerService())
                    .setOldCustomerService(customerOld.getCustomerService())
                    .setNewEstimateEnterOpenSeaTime(isFcl ? null : customerNew.getEstimateEnterOpenSeaTime())
                    .setOldEstimateEnterOpenSeaTime(customerOld.getEstimateEnterOpenSeaTime())
                    .setUpdateBody(JSONObject.toJSONString(updateReqVO))
                    .setRemark("页面编辑修改客户");
        }

        Long countryNew = customerNew.getCountry();
        if (!Objects.equals(countryNew, customerOld.getCountry()) && countryNew != null) {

            RLock rLock = redissonClient.getLock("customer_number");
            try {
                boolean success = rLock.tryLock(5, 5, TimeUnit.SECONDS);
                if (!success) throw new ServiceException(500, "操作忙，请稍后再试");

                String customerNumber = genCustomerNumber(countryNew);
                customerNew.setNumber(customerNumber);

                customerMapper.updateById(customerNew);

            } catch (InterruptedException e) {
                e.printStackTrace();
            } finally {
                if (rLock.isLocked()) {
                    rLock.unlock();
                }
            }

        } else {
            customerMapper.updateById(customerNew);
        }

        //设置weightUnit和lightUnit为null
        if (customerNew.getWeightUnit() == null || customerNew.getWeightUnit().compareTo(BigDecimal.ZERO) == 0) {
            customerMapper.updateWeightUnitToNull(customerId);
        }
        if (customerNew.getLightUnit() == null || customerNew.getLightUnit().compareTo(BigDecimal.ZERO) == 0) {
            customerMapper.updateLightUnitToNull(customerId);
        }
        if (isFcl) {
            customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
            log.info("更新客户[{}]包含海运整柜，设置不掉入公海", customerId);
        }

        //比较
        List<ApplyInfoVO> applyInfoVOList = new ArrayList<>();
        this.compareCustomer(customerOld, customerNew, applyInfoVOList);

        //更新联系人
        List<CustomerContactsUpdateReqVO> customerContactsNew = updateReqVO.getCustomerContacts();
        if (!CollectionUtils.isEmpty(customerContactsNew)) {

            //联系人有重复时，提示
            Map<String, Long> countMap = customerContactsNew.stream().collect(Collectors.groupingBy(CustomerContactsBaseVO::getPhoneNew, Collectors.counting()));
            countMap.keySet().stream().filter(t -> countMap.get(t) > 1).findFirst().ifPresent(phone -> {
                throw exception(CUSTOMER_CONTACTS_ALREADY_BIND, phone);
            });

            List<CustomerContactsDO> customerContactsOld = customerContactsMapper.selectList(CustomerContactsDO::getCustomerId, customerId);
            if (!CollectionUtils.isEmpty(customerContactsOld)) {

                //old contact id
                List<Long> idsOld = customerContactsOld.stream().map(CustomerContactsDO::getId).collect(Collectors.toList());

                //update contact
                List<CustomerContactsDO> updateList = customerContactsNew.stream().filter(t -> idsOld.contains(t.getId())).map(customerContactsUpdateReqVO ->
                {
                    CustomerContactsDO convert1 = CustomerContactsConvert.INSTANCE.convert(customerContactsUpdateReqVO);
                    convert1.setCustomerId(customerId);

                    //纪录更新日志
                    CustomerContactsDO d = customerContactsMapper.selectById(customerContactsUpdateReqVO.getId());
                    if (!Objects.equals(d.getName(), convert1.getName()) || !Objects.equals(d.getAreaCode(), convert1.getAreaCode())
                            || !Objects.equals(d.getPhoneNew(), convert1.getPhoneNew()) || !Objects.equals(d.getIsDefault(), convert1.getIsDefault())) {
                        String orgValue = String.format(logFormat, d.getId(), d.getName(), d.getAreaCode(), d.getPhoneNew(), Integer.valueOf(1).equals(d.getIsDefault()) ? "是" : "否");
                        String newValue = String.format(logFormat, convert1.getId(), convert1.getName(), convert1.getAreaCode(), convert1.getPhoneNew(), Integer.valueOf(1).equals(d.getIsDefault()) ? "是" : "否");
                        applyInfoVOList.add(new ApplyInfoVO("更新联系人", newValue, orgValue));
                    }

                    return convert1;
                }).collect(Collectors.toList());
                if (!CollectionUtils.isEmpty(updateList)) {
                    customerContactsMapper.updateBatch(updateList);

                    //上面的更新不会将userid置null，故再将userid为null的进行更新
                    updateList.stream().filter(t -> t.getUserid() == null).forEach(customerContactsDO -> {
                        customerContactsMapper.update(null,
                                new LambdaUpdateWrapper<CustomerContactsDO>().eq(CustomerContactsDO::getId, customerContactsDO.getId())
                                        .set(CustomerContactsDO::getUserid, null));
                    });
                }

                //delete contact
                List<Long> deleteIds = idsOld.stream().filter(old -> customerContactsNew.stream().noneMatch(u -> old.equals(u.getId()))).collect(Collectors.toList());
                if (!CollectionUtils.isEmpty(deleteIds)) {

                    //纪录删除日志
                    List<CustomerContactsDO> deleteList = customerContactsMapper.selectBatchIds(deleteIds);
                    if (CollectionUtil.isNotEmpty(deleteList)) {
                        deleteList.stream().forEach(d -> {
                            String orgValue = String.format(logFormat, d.getId(), d.getName(), d.getAreaCode(), d.getPhoneNew(), Integer.valueOf(1).equals(d.getIsDefault()) ? "是" : "否");
                            applyInfoVOList.add(new ApplyInfoVO("删除联系人", null, orgValue));
                        });
                    }

                    customerContactsMapper.deleteBatchIds(deleteIds);
                }
            }

            List<CustomerContactsDO> customerContactsOldTmp = CollectionUtils.isEmpty(customerContactsOld) ? new ArrayList<CustomerContactsDO>() : customerContactsOld;
            //add contact
            customerContactsNew.stream()
                    .filter(t -> customerContactsOldTmp.stream().noneMatch(old -> old.getId().equals(t.getId())))
                    .forEach(customerContactsUpdateReqVO -> {

                        CustomerContactsCreateReqVO customerContactsCreateReqVO =
                                BeanUtil.copyProperties(customerContactsUpdateReqVO, CustomerContactsCreateReqVO.class);
                        customerContactsCreateReqVO.setCustomerId(customerId);

                        //纪录添加日志
                        String newValue = String.format(logFormat, null, customerContactsCreateReqVO.getName(), customerContactsCreateReqVO.getAreaCode(),
                                customerContactsCreateReqVO.getPhoneNew(), Boolean.TRUE.equals(customerContactsCreateReqVO.getIsDefault()) ? "是" : "否");
                        applyInfoVOList.add(new ApplyInfoVO("新增联系人", newValue, null));

                        associateContact(customerId, customerContactsCreateReqVO);
                    });
        }

        //客户线路处理
        List<CustomerLineUpdateReqVO> customerLines = updateReqVO.getCustomerLines();
        if (!CollectionUtils.isEmpty(customerLines)) {

            //设置客户id
            customerLines.stream().forEach(customerLineUpdateReqVO -> customerLineUpdateReqVO.setCustomerId(customerId));

            List<CustomerLineDO> customerLinesOld = customerLineMapper.selectList(CustomerLineDO::getCustomerId, customerId);
            if (!CollectionUtils.isEmpty(customerLinesOld)) {

                //old line id
                List<Long> idsOld = customerLinesOld.stream().map(CustomerLineDO::getId).collect(Collectors.toList());

                //update line
                List<CustomerLineDO> updateList = customerLines.stream().filter(t -> idsOld.contains(t.getId())).map(customerLinesUpdateReqVO ->
                        CustomerLineConvert.INSTANCE.convert(customerLinesUpdateReqVO)).collect(Collectors.toList());
                if (!CollectionUtils.isEmpty(updateList)) {
                    customerLineMapper.updateBatch(updateList);
                }

                //delete line
                List<Long> deleteIds = idsOld.stream().filter(old -> customerLines.stream().noneMatch(u -> old.equals(u.getId()))).collect(Collectors.toList());
                if (!CollectionUtils.isEmpty(deleteIds)) {
                    customerLineMapper.deleteBatchIds(deleteIds);
                }
            }

            //add line
            List<CustomerLineDO> createDoList = customerLines.stream().filter(t -> t.getId() == null)
                    .map(customerLinesUpdateReqVO -> {
                        CustomerLineDO convert = CustomerLineConvert.INSTANCE.convert(customerLinesUpdateReqVO);
                        return convert;
                    }).collect(Collectors.toList());
            customerLineMapper.insertBatch(createDoList);
        } else {
            //删除所有指定路线
            customerLineMapper.delete(new LambdaQueryWrapperX<CustomerLineDO>().eq(CustomerLineDO::getCustomerId, customerId));
        }


        //客户银行账户处理
        List<CustomerBankUpdateReqVO> customerBanks = updateReqVO.getCustomerBanks();
        if (CollectionUtil.isNotEmpty(customerBanks)) {

            //设置客户id
            customerBanks.stream().forEach(customerLineUpdateReqVO -> customerLineUpdateReqVO.setCustomerId(customerId));

            List<CustomerBankDO> customerBanksOld = customerBankMapper.selectList(CustomerBankDO::getCustomerId, customerId);
            if (CollectionUtil.isNotEmpty(customerBanksOld)) {

                //old bank id
                List<Long> idsOld = customerBanksOld.stream().map(CustomerBankDO::getId).collect(Collectors.toList());

                //update line
                List<CustomerBankDO> updateList = customerBanks.stream().filter(t -> idsOld.contains(t.getId())).map(customerBanksUpdateReqVO ->
                        CustomerBankConvert.INSTANCE.convert(customerBanksUpdateReqVO)).collect(Collectors.toList());
                if (!CollectionUtils.isEmpty(updateList)) {
                    customerBankMapper.updateBatch(updateList);
                }

                //delete line
                List<Long> deleteIds = idsOld.stream().filter(old -> customerBanks.stream().noneMatch(u -> old.equals(u.getId()))).collect(Collectors.toList());
                if (!CollectionUtils.isEmpty(deleteIds)) {
                    customerBankMapper.deleteBatchIds(deleteIds);
                }
            }


            //add line
            List<CustomerBankDO> createDoList = customerBanks.stream().filter(t -> t.getId() == null)
                    .map(customerBanksUpdateReqVO -> {
                        CustomerBankDO convert = CustomerBankConvert.INSTANCE.convert(customerBanksUpdateReqVO);
                        return convert;
                    }).collect(Collectors.toList());
            customerBankMapper.insertBatch(createDoList);
        } else {
            //删除所有银行账户
            customerBankMapper.delete(new LambdaQueryWrapperX<CustomerBankDO>().eq(CustomerBankDO::getCustomerId, customerId));
        }

        if (CollectionUtil.isNotEmpty(applyInfoVOList)) {
            customerOperateLogCreateReqVO.setNote(JSON.toJSONString(applyInfoVOList));
        }
        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
    }


    private void compareCustomer(CustomerDO customerOld, CustomerDO customerNew, List<ApplyInfoVO> applyInfoList) {
        if (customerOld == null || customerNew == null) {
            log.warn("customerOld is null or customerNew is null");
        }

        ApplyInfoVO infoVO = null;

        //客户名称
        String nameNew = customerNew.getName();
        String nameOld = customerOld.getName();
        if (!Objects.equals(nameOld, nameNew)) {
            infoVO = new ApplyInfoVO("客户名称", StringUtils.isNotEmpty(nameNew) ? nameNew : "空",
                    StringUtils.isNotEmpty(nameOld) ? nameOld : "空");
            applyInfoList.add(infoVO);
        }

        //客户国家
        Long countryNew = customerNew.getCountry();
        Long countryOld = customerOld.getCountry();
        if (!Objects.equals(countryOld, countryNew)) {
            infoVO = new ApplyInfoVO();
            infoVO.setName("国家");
            infoVO.setType(0);

            if (countryNew != null) {
                CountryDO country = countryService.getCountry(countryNew);
                infoVO.setNewValue(country != null ? (I18nMessage.getLang() == 0 ? country.getNameZh() : country.getNameEn()) : "空");
            } else {
                infoVO.setNewValue("空");
            }

            if (countryOld != null) {
                CountryDO country = countryService.getCountry(countryOld);
                infoVO.setOrgValue(country != null ? (I18nMessage.getLang() == 0 ? country.getNameZh() : country.getNameEn()) : "空");
            } else {
                infoVO.setOrgValue("空");
            }
            applyInfoList.add(infoVO);
        }

        //客户编码
        String numberNew = customerNew.getNumber();
        String numberOld = customerOld.getNumber();
        if (!Objects.equals(numberOld, numberNew)) {
            infoVO = new ApplyInfoVO("修改编号", StringUtils.isNotEmpty(numberNew) ? numberNew : "空",
                    StringUtils.isNotEmpty(numberOld) ? numberOld : "空");
            applyInfoList.add(infoVO);
        }


        //客户类型
        String typeNew = customerNew.getType();
        String typeOld = customerOld.getType();
        String typeSortOld = StringUtils.isNotEmpty(typeOld) ?
                Arrays.stream(typeOld.split(",")).filter(Objects::nonNull).sorted(Comparator.comparingInt(Integer::parseInt)).collect(Collectors.joining(",")) : "";
        String typeSortNew = StringUtils.isNotEmpty(typeNew) ?
                Arrays.stream(typeNew.split(",")).filter(Objects::nonNull).sorted(Comparator.comparingInt(Integer::parseInt)).collect(Collectors.joining(",")) : "";

        if (!Objects.equals(typeSortOld, typeSortNew)) {

            infoVO = new ApplyInfoVO();
            infoVO.setName("客户类型");
            if (StringUtils.isNotEmpty(typeOld)) {
                String typeNamesOld = Arrays.stream(typeSortOld.split(",")).map(s -> {
                    DictDataRespDTO typeDto = DictFrameworkUtils.getDictDataFromCache("customer_type", s);
                    return I18nMessage.getLang() == 0 ? typeDto.getLabel() : typeDto.getLabelEn();
                }).collect(Collectors.joining(","));
                infoVO.setOrgValue(StringUtils.isNotEmpty(typeNamesOld) ? typeNamesOld : "空");
            } else {
                infoVO.setOrgValue("空");
            }

            if (StringUtils.isNotEmpty(typeNew)) {
                String typeNamesNew = Arrays.stream(typeSortNew.split(",")).map(s -> {
                    DictDataRespDTO typeDto = DictFrameworkUtils.getDictDataFromCache("customer_type", s);
                    return I18nMessage.getLang() == 0 ? typeDto.getLabel() : typeDto.getLabelEn();
                }).collect(Collectors.joining(","));
                infoVO.setNewValue(StringUtils.isNotEmpty(typeNamesNew) ? typeNamesNew : "空");
            } else {
                infoVO.setNewValue("空");
            }

            applyInfoList.add(infoVO);
        }


        //出货渠道
        String transportTypeNew = customerNew.getTransportType();
        String transportTypeOld = customerOld.getTransportType();
        String transportTypeSortOld = StringUtils.isNotEmpty(transportTypeOld) ?
                Arrays.stream(transportTypeOld.split(",")).filter(StringUtils::isNotBlank).sorted(Comparator.comparingInt(Integer::parseInt)).collect(Collectors.joining(",")) : "";
        String transportTypeSortNew = StringUtils.isNotEmpty(transportTypeNew) ?
                Arrays.stream(transportTypeNew.split(",")).filter(StringUtils::isNotBlank).sorted(Comparator.comparingInt(Integer::parseInt)).collect(Collectors.joining(",")) : "";

        if (!Objects.equals(transportTypeSortOld, transportTypeSortNew)) {

            infoVO = new ApplyInfoVO();
            infoVO.setName("出货渠道");
            if (StringUtils.isNotEmpty(transportTypeOld)) {
                String transportTypeNamesOld = Arrays.stream(transportTypeSortOld.split(",")).map(s -> {
                    DictDataRespDTO typeDto = DictFrameworkUtils.getDictDataFromCache("customer_transport_type", s);
                    return I18nMessage.getLang() == 0 ? typeDto.getLabel() : typeDto.getLabelEn();
                }).collect(Collectors.joining(","));
                infoVO.setOrgValue(StringUtils.isNotEmpty(transportTypeNamesOld) ? transportTypeNamesOld : "空");
            } else {
                infoVO.setOrgValue("空");
            }

            if (StringUtils.isNotEmpty(transportTypeNew)) {
                String transportTypeNamesNew = Arrays.stream(transportTypeSortNew.split(",")).map(s -> {
                    DictDataRespDTO typeDto = DictFrameworkUtils.getDictDataFromCache("customer_transport_type", s);
                    return I18nMessage.getLang() == 0 ? typeDto.getLabel() : typeDto.getLabelEn();
                }).collect(Collectors.joining(","));
                infoVO.setNewValue(StringUtils.isNotEmpty(transportTypeNamesNew) ? transportTypeNamesNew : "空");
            } else {
                infoVO.setNewValue("空");
            }

            applyInfoList.add(infoVO);
        }

        //公司名称
        String companyNew = customerNew.getCompany();
        String companyOld = customerOld.getCompany();
        if (!Objects.equals(companyOld, companyNew)) {
            infoVO = new ApplyInfoVO("公司名称",
                    StringUtils.isNotEmpty(companyNew) ? companyNew : "空",
                    StringUtils.isNotEmpty(companyOld) ? companyOld : "空");
            applyInfoList.add(infoVO);
        }

        //客户来源
        Integer sourceNew = customerNew.getSource();
        Integer sourceOld = customerOld.getSource();
        if (!Objects.equals(sourceOld, sourceNew)) {
            infoVO = new ApplyInfoVO();
            infoVO.setName("客户来源");
            infoVO.setType(0);

            if (sourceNew != null) {
                DictDataRespDTO sourceDto = DictFrameworkUtils.getDictDataFromCache("customer_source", sourceNew.toString());
                infoVO.setNewValue(sourceDto != null ? (I18nMessage.getLang() == 0 ? sourceDto.getLabel() : sourceDto.getLabelEn()) : "空");
            } else {
                infoVO.setNewValue("空");
            }

            if (sourceOld != null) {
                DictDataRespDTO sourceDto = DictFrameworkUtils.getDictDataFromCache("customer_source", sourceOld.toString());
                infoVO.setOrgValue(sourceDto != null ? (I18nMessage.getLang() == 0 ? sourceDto.getLabel() : sourceDto.getLabelEn()) : "空");
            } else {
                infoVO.setOrgValue("空");
            }
            applyInfoList.add(infoVO);
        }

        //推介人
        Long promoterNew = customerNew.getPromoter();
        Long promoterOld = customerOld.getPromoter();
        if (!Objects.equals(promoterNew, promoterOld)) {
            infoVO = new ApplyInfoVO();
            infoVO.setName("推介人");
            infoVO.setType(0);

            if (promoterNew != null) {
                CustomerDO promoterDO = customerMapper.selectById(promoterNew);
                infoVO.setNewValue(String.format("%s[%d]", promoterDO != null ? promoterDO.getName() : "空", promoterNew));
            } else {
                infoVO.setNewValue("空");
            }

            if (promoterOld != null) {
                CustomerDO promoterDO = customerMapper.selectById(promoterOld);
                infoVO.setOrgValue(String.format("%s[%d]", promoterDO != null ? promoterDO.getName() : "空", promoterOld));
            } else {
                infoVO.setOrgValue("空");
            }
            applyInfoList.add(infoVO);
        }

        //结算方式
        Integer balanceNew = customerNew.getBalance();
        Integer balanceOld = customerOld.getBalance();
        if (!Objects.equals(balanceOld, balanceNew)) {
            infoVO = new ApplyInfoVO();
            infoVO.setName("结算方式");
            infoVO.setType(0);

            if (balanceNew != null) {
                DictDataRespDTO dto = DictFrameworkUtils.getDictDataFromCache("customer_balance", balanceNew.toString());
                infoVO.setNewValue(dto != null ? (I18nMessage.getLang() == 0 ? dto.getLabel() : dto.getLabelEn()) : "空");
            } else {
                infoVO.setNewValue("空");
            }

            if (balanceOld != null) {
                DictDataRespDTO dto = DictFrameworkUtils.getDictDataFromCache("customer_balance", balanceOld.toString());
                infoVO.setOrgValue(dto != null ? (I18nMessage.getLang() == 0 ? dto.getLabel() : dto.getLabelEn()) : "空");
            } else {
                infoVO.setOrgValue("空");
            }
            applyInfoList.add(infoVO);
        }

        //是否显示提单价格
        Boolean isShowTidanPriceNew = customerNew.getIsShowTidanPrice();
        Boolean isShowTidanPriceOld = customerOld.getIsShowTidanPrice();
        if (!Objects.equals(isShowTidanPriceOld, isShowTidanPriceNew)) {
            infoVO = new ApplyInfoVO("是否显示提单价格", Boolean.TRUE.equals(isShowTidanPriceNew) ? "开" : "关",
                    Boolean.TRUE.equals(isShowTidanPriceOld) ? "开" : "关");
            applyInfoList.add(infoVO);
        }

        //到仓确认
        Integer arrivalConfirmNew = customerNew.getArrivalConfirm();
        Integer arrivalConfirmOld = customerOld.getArrivalConfirm();
        if (!Objects.equals(arrivalConfirmOld, arrivalConfirmNew)) {
            infoVO = new ApplyInfoVO("到仓确认",
                    arrivalConfirmNew != null && arrivalConfirmNew.equals(1) ? "开" : "关",
                    arrivalConfirmOld != null && arrivalConfirmOld.equals(1) ? "开" : "关");
            applyInfoList.add(infoVO);
        }

        //重货标准
        BigDecimal weightUnitNew = customerNew.getWeightUnit();
        BigDecimal weightUnitOld = customerOld.getWeightUnit();
        if ((weightUnitOld != null && weightUnitNew != null && weightUnitOld.compareTo(weightUnitNew) != 0)
                || (weightUnitOld != null && weightUnitNew == null)
                || (weightUnitOld == null && weightUnitNew != null)) {
            infoVO = new ApplyInfoVO("重货标准",
                    weightUnitNew != null ? weightUnitNew.toPlainString() : "关",
                    weightUnitOld != null ? weightUnitOld.toPlainString() : "关");
            applyInfoList.add(infoVO);
        }

        //泡货标准
        BigDecimal lightUnitNew = customerNew.getLightUnit();
        BigDecimal lightUnitOld = customerOld.getLightUnit();
        if ((lightUnitOld != null && lightUnitNew != null && lightUnitOld.compareTo(lightUnitNew) != 0)
                || (lightUnitOld != null && lightUnitNew == null)
                || (lightUnitOld == null && lightUnitNew != null)) {
            infoVO = new ApplyInfoVO("泡货标准",
                    lightUnitNew != null ? lightUnitNew.toPlainString() : "关",
                    lightUnitOld != null ? lightUnitOld.toPlainString() : "关");
            applyInfoList.add(infoVO);
        }

    }

    @Override
    public void deleteCustomer(Long id) {
        // 校验存在
        this.validateCustomerExists(id);

        //删除客户联系人
        Map<String, Object> paramMap = new HashMap<>();
        paramMap.put("customer_id", id);
        customerContactsMapper.deleteByMap(paramMap);

        //删除客户线路
        customerLineMapper.deleteByMap(paramMap);

        //删除银行账号
        customerBankMapper.deleteByMap(paramMap);

        // 删除
        CustomerDO customer = customerMapper.selectById(id);

        customerMapper.deleteById(id);

        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                .setOperator(loginUser == null ? null : loginUser.getId())
                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                .setCustomerId(customer.getId())
                .setNumber(customer.getNumber())
                .setName(customer.getName())
                .setOldCustomerService(customer.getCustomerService())
                .setNewCustomerService(customer.getCustomerService())
                .setOldEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                .setNewEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                .setOperateType(CustomerOperateTypeEnum.DELETE.getValue())
                .setRemark("删除客户");
        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

    }

    private void validateCustomerExists(Long id) {
        if (customerMapper.selectById(id) == null) {
            throw exception(CUSTOMER_NOT_EXISTS);
        }
    }

    @Override
    public CustomerDO getCustomer(Long id) {
        return customerMapper.selectById(id);
    }

    @Override
    public CustomerDetailRespVO getCustomerDetailRespVO(Long id) {
        return customerMapper.getCustomerDetailRespVO(id);
    }

    @Override
    public List<CustomerDO> getCustomerList(Collection<Long> ids) {
        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapper = new LambdaQueryWrapperX<CustomerDO>()
                .inIfPresent(CustomerDO::getId, ids)
                .eq(BaseDO::getDeleted, false)

                .orderByDesc(CustomerDO::getId);
        return customerMapper.getList(customerDOLambdaQueryWrapper);
    }

    //@Override
    //public List<CustomerDO> getMyCustomerList(Long customerService) {
    //    return customerMapper.getMyCustomerList(customerService);
    //}

    @Override
    public PageResult<CustomerDO> getCustomerPage(CustomerPageReqVO pageReqVO) {

        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(pageReqVO);

        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, pageReqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, pageReqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, pageReqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, pageReqVO.getCountry())
                .eqIfPresent(CustomerDO::getIsInOpenSea, pageReqVO.getIsInOpenSea())
                .eqIfPresent(CustomerDO::getSource, pageReqVO.getSource())
                .eqIfPresent(CustomerDO::getCustomerService, pageReqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, pageReqVO.getStatus())
                .eqIfPresent(CustomerDO::getResourceType, pageReqVO.getResourceType())
                .eqIfPresent(CustomerDO::getDepartment, pageReqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, pageReqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsCustomerServiceConfirmed, pageReqVO.getIsCustomerServiceConfirmed())
                .eqIfPresent(CustomerDO::getIsPotential, pageReqVO.getIsPotential())
                .betweenIfPresent(CustomerDO::getCreateTime, pageReqVO.getBeginCreateTime(), pageReqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(pageReqVO.getType()), "FIND_IN_SET ('" + pageReqVO.getType() + "',  type)")

                .apply(pageReqVO.getCreditLevel() != null, "credit_level = {0}", pageReqVO.getCreditLevel())
                //主联系人
                .apply(StringUtils.isNotEmpty(pageReqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", pageReqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(pageReqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", pageReqVO.getDefaultContactPhone()))

                .gt(StringUtils.isNotBlank(pageReqVO.getFlag4QueryCondition()), CustomerDO::getCustomerServiceAssignedTime, DateUtils.formatDateTime(DateUtils.addDate(new Date(), Calendar.HOUR, -24)))

                .orderByDesc(CustomerDO::getId);

        //添加获客方式
        if (null != pageReqVO.getMarketType()) {
            if (pageReqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (pageReqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }

        customerMapper.getPage(mpPage, customerDOLambdaQueryWrapperX);

        return new PageResult<>(mpPage.getRecords(), mpPage.getTotal());
    }

    @Override
    public PageResult<CustomerDO> getMyCustomerPage(CustomerPageReqDTO pageReqVO, PageVO page) {

        page.setPage(pageReqVO.getPageNo());
        page.setRows(pageReqVO.getPageSize());

        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(page);
        log.warn(I18nMessage.getLang().toString());
        int start = (page.getPage() - 1) * page.getRows();
        int size = page.getRows();
        List<CustomerDO> list = customerMapper.getMyPage(start, size, pageReqVO);
        long total = customerMapper.getMyPageCount(pageReqVO);
        return new PageResult<>(list, total,
                mpPage.getSize(), page.getPage(),
                (total + mpPage.getSize() - 1) / mpPage.getSize());
    }

    @Override
    public PageResult<CustomerDO> getDeptCustomerPage(CustomerPageReqVO reqVO) {
        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(reqVO);

        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, reqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, reqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, reqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, reqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, reqVO.getSource())
                .eqIfPresent(CustomerDO::getCustomerService, reqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getStatus, reqVO.getStatus())
                .eqIfPresent(CustomerDO::getDepartment, reqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsCustomerServiceConfirmed, reqVO.getIsCustomerServiceConfirmed())
                .eqIfPresent(CustomerDO::getIsPotential, reqVO.getIsPotential())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .betweenIfPresent(CustomerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(reqVO.getType()), "FIND_IN_SET ('" + reqVO.getType() + "',  type)")

                .apply(reqVO.getCreditLevel() != null, "credit_level = {0}", reqVO.getCreditLevel())
                //主联系人
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", reqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", reqVO.getDefaultContactPhone()))

                .gt(StringUtils.isNotBlank(reqVO.getFlag4QueryCondition()), CustomerDO::getCustomerServiceAssignedTime, DateUtils.formatDateTime(DateUtils.addDate(new Date(), Calendar.HOUR, -24)))

                .orderByDesc(CustomerDO::getId);

        //添加获客方式
        if (null != reqVO.getMarketType()) {
            if (reqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (reqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }
        }

        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        if (null != loginUser && null != loginUser.getDeptId()) {
            customerDOLambdaQueryWrapperX.apply(" dept_id = " + loginUser.getDeptId());
        }

        customerMapper.getPage(mpPage, customerDOLambdaQueryWrapperX);

        return new PageResult<>(mpPage.getRecords(), mpPage.getTotal());
    }

    @Override
    public PageResult<CustomerDO> getDeptCustomerPageReq(CustomerPageReqDTO pageReqVO, PageVO page) {

        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(page);
        log.warn(I18nMessage.getLang().toString());

        page.setPage(pageReqVO.getPageNo());
        page.setRows(pageReqVO.getPageSize());

        int start = (page.getPage() - 1) * page.getRows();
        int size = page.getRows();
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        Long deptId = null;
        if (null != loginUser && null != loginUser.getDeptId()) {
            deptId = loginUser.getDeptId();
        }

        // List<CustomerDO> list =
        //         customerMapper.getDeptCustomerPageReq(start, size, pageReqVO, deptId);
        // long total = customerMapper.getDeptCustomerPageReqCount(pageReqVO, deptId);
        // return new PageResult<>(list, total, mpPage.getSize(), page.getPage(), (total + mpPage.getSize() - 1) / mpPage.getSize());

        // 20240905 注释上面内容，调整使用全部客户分页查询语句
        pageReqVO.setDeptIds(Arrays.asList(deptId));
        return this.getMyCustomerPage(pageReqVO, page);
    }

    @Override
    public List<CustomerDO> getDeptCustomerExcelVoListReq(CustomerExportReqDTO reqVO) {
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        Long deptId = null;
        if (null != loginUser && loginUser.getDeptId() > 0) {
            deptId = loginUser.getDeptId();
        }
        // return customerMapper.getDeptCustomerExcelVoListReq(reqVO, deptId);

        reqVO.setDeptIds(Arrays.asList(deptId));
        return customerMapper.getMyPage(null, null, reqVO);
    }

    @Override
    public List<CustomerDO> getDeptCustomerExcelVoList(CustomerExportReqVO reqVO) {

        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, reqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, reqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, reqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, reqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, reqVO.getSource())
                .eqIfPresent(CustomerDO::getCustomerService, reqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getStatus, reqVO.getStatus())
                .eqIfPresent(CustomerDO::getDepartment, reqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsCustomerServiceConfirmed, reqVO.getIsCustomerServiceConfirmed())
                .eqIfPresent(CustomerDO::getIsPotential, reqVO.getIsPotential())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .betweenIfPresent(CustomerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(reqVO.getType()), "FIND_IN_SET ('" + reqVO.getType() + "',  type)")

                .apply(reqVO.getCreditLevel() != null, "credit_level = {0}", reqVO.getCreditLevel())
                //主联系人
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", reqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", reqVO.getDefaultContactPhone()))

                .gt(StringUtils.isNotBlank(reqVO.getFlag4QueryCondition()), CustomerDO::getCustomerServiceAssignedTime, DateUtils.formatDateTime(DateUtils.addDate(new Date(), Calendar.HOUR, -24)))

                .orderByDesc(CustomerDO::getId);

        //添加获客方式
        if (null != reqVO.getMarketType()) {
            if (reqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (reqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }
        }

        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        if (null != loginUser && null != loginUser.getDeptId()) {
            customerDOLambdaQueryWrapperX.apply(" dept_id = " + loginUser.getDeptId());
        }

        return customerMapper.getCustomerExcelVoList(customerDOLambdaQueryWrapperX);
    }

    @Override
    public PageResult<CustomerDO> getWaitToAssignedCustomerPage(CustomerPageReqVO reqVO) {


        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(reqVO);

        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, reqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, reqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, reqVO.getLevel())
                .eqIfPresent(CustomerDO::getSource, reqVO.getSource())
                .eqIfPresent(CustomerDO::getCountry, reqVO.getCountry())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getCustomerService, reqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, reqVO.getStatus())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getDepartment, reqVO.getDepartment())
                .eqIfPresent(CustomerDO::getIsPotential, reqVO.getIsPotential())
                .betweenIfPresent(CustomerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(reqVO.getType()), "FIND_IN_SET ('" + reqVO.getType() + "',  type)")

                .apply(reqVO.getCreditLevel() != null, "credit_level = {0}", reqVO.getCreditLevel())

                //主联系人
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", reqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", reqVO.getDefaultContactPhone()))

                //跟进 客服 is null
                .isNull(CustomerDO::getCustomerService)
                //未被接收
                .eq(CustomerDO::getIsCustomerServiceConfirmed, false)
                //非公海数据
                .eq(CustomerDO::getIsInOpenSea, false)

                .orderByDesc(CustomerDO::getId);

        //添加获客方式
        if (null != reqVO.getMarketType()) {
            if (reqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (reqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }

        customerMapper.getPage(mpPage, customerDOLambdaQueryWrapperX);

        return new PageResult<>(mpPage.getRecords(), mpPage.getTotal());
    }

    /**
     * 获得待分配客户列表 支持多个筛选
     *
     * @param pageReqVO
     * @param page
     * @return
     */
    @Override
    public PageResult<CustomerDO> getWaitToAssignedCustomerPageReq(CustomerPageReqDTO pageReqVO, PageVO page) {
        pageReqVO.setIsInOpenSea(false);
        pageReqVO.setIsCustomerServiceConfirmed(false);
        pageReqVO.setCustomerService(null);
        // IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(page);
        // log.warn(I18nMessage.getLang().toString());
        //
        // page.setPage(pageReqVO.getPageNo());
        // page.setRows(pageReqVO.getPageSize());
        //
        // int start = (page.getPage() - 1) * page.getRows();
        // int size = page.getRows();
        // List<CustomerDO> list =
        //         customerMapper.getWaitToAssignedCustomerPageReq(start, size, pageReqVO);
        // long total = customerMapper.getWaitToAssignedCustomerPageReqCount(pageReqVO);
        // return new PageResult<>(list, total, mpPage.getSize(), page.getPage(), (total + mpPage.getSize() - 1) / mpPage.getSize());
        return this.getMyCustomerPage(pageReqVO, page);
    }

    @Override
    public List<CustomerDO> getWaitToAssignedCustomerExcelVoList(CustomerExportReqVO exportReqVO) {
        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, exportReqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, exportReqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, exportReqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, exportReqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, exportReqVO.getSource())
                .eqIfPresent(CustomerDO::getResourceType, exportReqVO.getResourceType())
                .eqIfPresent(CustomerDO::getCustomerService, exportReqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, exportReqVO.getStatus())
                .eqIfPresent(CustomerDO::getDepartment, exportReqVO.getDepartment())
                .eqIfPresent(CustomerDO::getIsPotential, exportReqVO.getIsPotential())
                .betweenIfPresent(CustomerDO::getCreateTime, exportReqVO.getBeginCreateTime(), exportReqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(exportReqVO.getType()), "FIND_IN_SET ('" + exportReqVO.getType() + "',  type)")

                .apply(exportReqVO.getCreditLevel() != null, "credit_level = {0}", exportReqVO.getCreditLevel())

                //主联系人
                .apply(StringUtils.isNotEmpty(exportReqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", exportReqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(exportReqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", exportReqVO.getDefaultContactPhone()))

                //跟进 客服 is null
                .isNull(CustomerDO::getCustomerService)
                //未被接收
                .eq(CustomerDO::getIsCustomerServiceConfirmed, false)
                //非公海数据
                .eq(CustomerDO::getIsInOpenSea, false)

                .orderByDesc(CustomerDO::getId);
        //添加获客方式
        if (null != exportReqVO.getMarketType()) {
            if (exportReqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (exportReqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }

        return customerMapper.getCustomerExcelVoList(customerDOLambdaQueryWrapperX);
    }

    @Override
    public List<CustomerDO> getWaitToAssignedCustomerExcelVoListReq(CustomerExportReqDTO reqVO) {
        // return customerMapper.getWaitToAssignedCustomerListReq(reqVO);
        return customerMapper.getMyPage(null, null, reqVO);
    }

    @Override
    public PageResult<CustomerDO> getWaitToConfirmCustomerPage(CustomerPageReqVO pageReqVO) {

        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(pageReqVO);

        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, pageReqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, pageReqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, pageReqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, pageReqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, pageReqVO.getSource())
                .eqIfPresent(CustomerDO::getResourceType, pageReqVO.getResourceType())
                .eqIfPresent(CustomerDO::getCustomerService, pageReqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, pageReqVO.getStatus())
                .eqIfPresent(CustomerDO::getDepartment, pageReqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, pageReqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsPotential, pageReqVO.getIsPotential())
                .betweenIfPresent(CustomerDO::getCreateTime, pageReqVO.getBeginCreateTime(), pageReqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(pageReqVO.getType()), "FIND_IN_SET ('" + pageReqVO.getType() + "',  type)")

                .apply(pageReqVO.getCreditLevel() != null, "credit_level = {0}", pageReqVO.getCreditLevel())

                //主联系人
                .apply(StringUtils.isNotEmpty(pageReqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", pageReqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(pageReqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", pageReqVO.getDefaultContactPhone()))

                //客户经理
                .eq(CustomerDO::getCustomerService, pageReqVO.getCustomerService())
                //未被接收
                .eq(CustomerDO::getIsCustomerServiceConfirmed, false)
                //非公海数据
                .eq(CustomerDO::getIsInOpenSea, false)

                // .gt(CustomerDO::getCustomerServiceAssignedTime, DateUtils.formatDateTime(DateUtils.addDate(new Date(),Calendar.HOUR,-24)))

                .orderByDesc(CustomerDO::getId);
        //添加获客方式
        if (null != pageReqVO.getMarketType()) {
            if (pageReqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (pageReqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }

        customerMapper.getPage(mpPage, customerDOLambdaQueryWrapperX);

        return new PageResult<>(mpPage.getRecords(), mpPage.getTotal());
    }

    @Override
    public PageResult<CustomerDO> getWaitToConfirmCustomerPageReq(CustomerPageReqDTO pageReqVO, PageVO page) {
        pageReqVO.setIsCustomerServiceConfirmed(false);
        pageReqVO.setIsInOpenSea(false);
        // IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(page);
        // log.warn(I18nMessage.getLang().toString());
        //
        // page.setPage(pageReqVO.getPageNo());
        // page.setRows(pageReqVO.getPageSize());
        //
        // int start = (page.getPage() - 1) * page.getRows();
        // int size = page.getRows();
        // List<CustomerDO> list =
        //         customerMapper.getWaitToConfirmCustomerPageReq(start, size, pageReqVO);
        // long total = customerMapper.getWaitToConfirmCustomerPageReqCount(pageReqVO);
        // return new PageResult<>(list, total, mpPage.getSize(), page.getPage(), (total + mpPage.getSize() - 1) / mpPage.getSize());

        return this.getMyCustomerPage(pageReqVO, page);
    }

    @Override
    public List<CustomerDO> getWaitToConfirmCustomerExcelVoList(CustomerExportReqVO reqVO) {
        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, reqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, reqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, reqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, reqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, reqVO.getSource())
                .eqIfPresent(CustomerDO::getCustomerService, reqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, reqVO.getStatus())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getDepartment, reqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsPotential, reqVO.getIsPotential())
                .betweenIfPresent(CustomerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(reqVO.getType()), "FIND_IN_SET ('" + reqVO.getType() + "',  type)")

                .apply(reqVO.getCreditLevel() != null, "credit_level = {0}", reqVO.getCreditLevel())

                //主联系人
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", reqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", reqVO.getDefaultContactPhone()))

                //客户经理
                .eq(CustomerDO::getCustomerService, reqVO.getCustomerService())
                //未被接收
                .eq(CustomerDO::getIsCustomerServiceConfirmed, false)
                //非公海数据
                .eq(CustomerDO::getIsInOpenSea, false)

                // .gt(CustomerDO::getCustomerServiceAssignedTime, DateUtils.formatDateTime(DateUtils.addDate(new Date(),Calendar.HOUR,-24)))

                .orderByDesc(CustomerDO::getId);
        //添加获客方式
        if (null != reqVO.getMarketType()) {
            if (reqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (reqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }

        return customerMapper.getCustomerExcelVoList(customerDOLambdaQueryWrapperX);
    }

    /**
     * 我的待接收客户列表, 用于 Excel 导出 ,支持多选
     *
     * @param reqVO
     * @return
     */
    @Override
    public List<CustomerDO> getWaitToConfirmCustomerExcelVoListReq(CustomerExportReqDTO reqVO) {
        reqVO.setIsCustomerServiceConfirmed(false);
        reqVO.setIsInOpenSea(false);
        List<Long> setCustomerService = new ArrayList<Long>();
        if (getLoginUserId() != null) {
            setCustomerService.add(getLoginUserId());
            reqVO.setCustomerService(setCustomerService);
        }

        // return customerMapper.getWaitToConfirmCustomerExcelVoListReq(reqVO);
        return customerMapper.getMyPage(null, null, reqVO);
    }

    @Override
    public PageResult<CustomerDO> getOpenSeaCustomerPage(CustomerPageReqVO reqVO) {


        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(reqVO);

        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, reqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, reqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, reqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, reqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, reqVO.getSource())
                .eqIfPresent(CustomerDO::getCustomerService, reqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, reqVO.getStatus())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getDepartment, reqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsPotential, reqVO.getIsPotential())
                .betweenIfPresent(CustomerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(reqVO.getType()), "FIND_IN_SET ('" + reqVO.getType() + "',  type)")

                .apply(reqVO.getCreditLevel() != null, "credit_level = {0}", reqVO.getCreditLevel())

                //主联系人
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", reqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", reqVO.getDefaultContactPhone()))

                //在公海
                .eq(CustomerDO::getIsInOpenSea, true)
                //进入公海池时间不为空
                .isNotNull(CustomerDO::getEnterOpenSeaTime)

                .orderByDesc(CustomerDO::getId);

        //添加获客方式
        if (null != reqVO.getMarketType()) {
            if (reqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (reqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }
        customerMapper.getPage(mpPage, customerDOLambdaQueryWrapperX);

        return new PageResult<>(mpPage.getRecords(), mpPage.getTotal());
    }

    @Override
    public PageResult<CustomerDO> getOpenSeaCustomerPageReq(CustomerPageReqDTO pageReqVO, PageVO page) {
        pageReqVO.setIsInOpenSea(true);

        // IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(page);
        // log.warn(I18nMessage.getLang().toString());
        //
        // page.setPage(pageReqVO.getPageNo());
        // page.setRows(pageReqVO.getPageSize());
        //
        // int start = (page.getPage() - 1) * page.getRows();
        // int size = page.getRows();
        // List<CustomerDO> list =
        //         customerMapper.getOpenSeaCustomerPageReq(start, size, pageReqVO);
        // long total = customerMapper.getOpenSeaCustomerPageReqCount(pageReqVO);
        // return new PageResult<>(list, total, mpPage.getSize(), page.getPage(), (total + mpPage.getSize() - 1) / mpPage.getSize());

        return this.getMyCustomerPage(pageReqVO, page);
    }

    @Override
    public List<CustomerDO> getPublicCustomerExcelVoList(CustomerExportReqVO reqVO) {
        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, reqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, reqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, reqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, reqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, reqVO.getSource())
                .eqIfPresent(CustomerDO::getCustomerService, reqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, reqVO.getStatus())
                .eqIfPresent(CustomerDO::getDepartment, reqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsPotential, reqVO.getIsPotential())
                .betweenIfPresent(CustomerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(reqVO.getType()), "FIND_IN_SET ('" + reqVO.getType() + "',  type)")

                .apply(reqVO.getCreditLevel() != null, "credit_level = {0}", reqVO.getCreditLevel())

                //主联系人
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", reqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", reqVO.getDefaultContactPhone()))

                //在公海
                .eq(CustomerDO::getIsInOpenSea, true)
                //进入公海池时间不为空
                .isNotNull(CustomerDO::getEnterOpenSeaTime)

                .orderByDesc(CustomerDO::getId);

        //添加获客方式
        if (null != reqVO.getMarketType()) {
            if (reqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (reqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }


        return customerMapper.getCustomerExcelVoList(customerDOLambdaQueryWrapperX);
    }

    @Override
    public List<CustomerDO> getPublicCustomerExcelVoReqList(@Param("query") CustomerExportReqDTO reqVO) {
        reqVO.setIsInOpenSea(true);
        // return customerMapper.getPublicCustomerExcelVoReqList(reqVO);
        return customerMapper.getMyPage(null, null, reqVO);
    }

    @Override
    public List<CustomerDO> getCustomerExcelVoList(CustomerExportReqVO reqVO) {
        LambdaQueryWrapper<CustomerDO> customerDOLambdaQueryWrapperX = new LambdaQueryWrapperX<CustomerDO>()
                .likeIfPresent(CustomerDO::getNumber, reqVO.getNumber())
                .likeIfPresent(CustomerDO::getName, reqVO.getName())
                .eqIfPresent(CustomerDO::getLevel, reqVO.getLevel())
                .eqIfPresent(CustomerDO::getCountry, reqVO.getCountry())
                .eqIfPresent(CustomerDO::getSource, reqVO.getSource())
                .eqIfPresent(CustomerDO::getCustomerService, reqVO.getCustomerService())
                .eqIfPresent(CustomerDO::getStatus, reqVO.getStatus())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getDepartment, reqVO.getDepartment())
                .eqIfPresent(CustomerDO::getResourceType, reqVO.getResourceType())
                .eqIfPresent(CustomerDO::getIsPotential, reqVO.getIsPotential())
                .eqIfPresent(CustomerDO::getIsCustomerServiceConfirmed, reqVO.getIsCustomerServiceConfirmed())
                .betweenIfPresent(CustomerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .eq(BaseDO::getDeleted, false)

                .apply(StringUtils.isNotEmpty(reqVO.getType()), "FIND_IN_SET ('" + reqVO.getType() + "',  type)")

                .apply(reqVO.getCreditLevel() != null, "credit_level = {0}", reqVO.getCreditLevel())
                //主联系人
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactName()), "default_contact_name like {0}", String.format("%%%s%%", reqVO.getDefaultContactName()))
                //主联系电话
                .apply(StringUtils.isNotEmpty(reqVO.getDefaultContactPhone()), "all_contact_phone like {0}", String.format("%%%s%%", reqVO.getDefaultContactPhone()))

                .gt(StringUtils.isNotBlank(reqVO.getFlag4QueryCondition()), CustomerDO::getCustomerServiceAssignedTime, DateUtils.formatDateTime(DateUtils.addDate(new Date(), Calendar.HOUR, -24)))

                .orderByDesc(CustomerDO::getId);
        //添加获客方式
        if (null != reqVO.getMarketType()) {
            if (reqVO.getMarketType() == 1) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is not null ");
            }
            if (reqVO.getMarketType() == 2) {
                customerDOLambdaQueryWrapperX.apply(" customer_service is null ");
            }

        }

        return customerMapper.getCustomerExcelVoList(customerDOLambdaQueryWrapperX);
    }

    @Override
    public List<CustomerDO> getMyCustomerExcelVoList(CustomerExportReqDTO reqVO) {
        // return customerMapper.getMyCustomerExcelVoList(reqVO);
        return customerMapper.getMyPage(null, null, reqVO);
    }

    @Override
    public PageResult<CustomerDO> searchCustomer(CustomerSelectReqVO customerSelectReqVO) {

//        IPage<CustomerDO> mpPage = MyBatisUtils.buildPage(customerSelectReqVO);

//        QueryWrapper<CustomerDO> customerDOLambdaQueryWrapper = new QueryWrapper<CustomerDO>()
//                .eq("deleted", false)
//                .eq(customerSelectReqVO.getCustomerType() != null, "type", customerSelectReqVO.getCustomerType())
//                .eq(customerSelectReqVO.getCustomerLevel() != null, "level", customerSelectReqVO.getCustomerLevel())
//                .and(
//                        StringUtils.isNotEmpty(customerSelectReqVO.getSearchKey()),
//                        i -> i.like("name", customerSelectReqVO.getSearchKey())
//                                .or()
//                                .like("default_contact_phone", customerSelectReqVO.getSearchKey())
//                ).orderByDesc("id").last("limit " + customerSelectReqVO.getPageSize());
        // IPage<CustomerDO> page = customerMapper.getPage(mpPage, customerDOLambdaQueryWrapper);
        // return new PageResult<>(mpPage.getRecords(), mpPage.getTotal());
//        List<CustomerDO> list = customerMapper.getList(customerDOLambdaQueryWrapper);
        List<CustomerDO> list = customerMapper.searchCustomer(customerSelectReqVO);
        return new PageResult<>(list, list.size());
    }


    @Override
    public void moveWaitConfirmUserToWaitAssigned(Integer hours) {
        List<CustomerDO> waitConfirmUserToWaitAssigned = customerMapper.getWaitConfirmUserToWaitAssigned(hours);

        if (CollectionUtil.isNotEmpty(waitConfirmUserToWaitAssigned)) {
            //纪录日志
            for (CustomerDO customerDO : waitConfirmUserToWaitAssigned) {

                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(null).setOperatorName(null)
                        .setCustomerId(customerDO.getId())
                        .setNumber(customerDO.getNumber())
                        .setName(customerDO.getName())
                        .setOldCustomerService(customerDO.getCustomerService())
                        .setNewCustomerService(null)
                        .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                        .setOrderId(null).setOrderNo(null)
                        .setOperateType(CustomerOperateTypeEnum.WAIT_TO_ASSIGN.getValue())
                        .setRemark("超时未接收[" + hours + "h]，掉入待分配");
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

            }

            //转移
            customerMapper.moveToWaitAssigned(waitConfirmUserToWaitAssigned);
        }

    }

    @Override
    public void moveWebConsigneeCustomerToWaitAssigned(Integer hours) {
        List<CustomerDO> webConsigneeCustomerToWaitAssigned = customerMapper.getWebConsigneeCustomerToWaitAssigned(hours);

        if (CollectionUtil.isNotEmpty(webConsigneeCustomerToWaitAssigned)) {

            for (CustomerDO customerDO : webConsigneeCustomerToWaitAssigned) {

                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(null).setOperatorName(null)
                        .setCustomerId(customerDO.getId())
                        .setNumber(customerDO.getNumber())
                        .setName(customerDO.getName())
                        .setOldCustomerService(customerDO.getCustomerService())
                        .setNewCustomerService(null)
                        .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                        .setOrderId(null).setOrderNo(null)
                        .setOperateType(CustomerOperateTypeEnum.WAIT_TO_ASSIGN.getValue())
                        .setRemark("定时任务，web收货人客户达到" + hours + "小时后自动转入待分配");
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
            }

            customerMapper.moveToWaitAssigned(webConsigneeCustomerToWaitAssigned);
        }
    }

    public void scheduleCustomerRefresh2(Integer val1, Integer val2, Integer val3) {

        if (Objects.isNull(val1)) {
            val1 = 30;
        }
        if (Objects.isNull(val2)) {
            val1 = 3;
        }
        if (Objects.isNull(val3)) {
            val1 = 6;
        }

        log.info("定时进入公海池开始工作");

        //查询要掉入公海的客户列表
        List<CustomerDO> toOpenSeaTimeAfterLimitDayCustomerList = customerMapper.getToOpenSeaTimeAfterLimitDayCustomerList(0);

        if (CollectionUtil.isNotEmpty(toOpenSeaTimeAfterLimitDayCustomerList)) {

            toOpenSeaTimeAfterLimitDayCustomerList.forEach(customerDO -> {
                // 打印日志
                log.info("检测将客户[{}]移入公海池。预计进入公海池时间={} 客户编号={}",
                        customerDO.getName(), customerDO.getEstimateEnterOpenSeaTime(), customerDO.getNumber());

                //掉入公海纪录
                CustomerOperateLogCreateReqVO createReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(null).setOperatorName(null)
                        .setCustomerId(customerDO.getId())
                        .setNumber(customerDO.getNumber())
                        .setName(customerDO.getName())
                        .setNewCustomerService(null)
                        .setOldCustomerService(customerDO.getCustomerService())
                        .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                        .setOperateType(CustomerOperateTypeEnum.ENTER_TO_OPEN_SEA.getValue())
                        .setRemark("掉入公海池");
                customerOperateLogService.createOperateLog(createReqVO);

            });

            String cancelReason = I18nMessage.getMessage("customer.enter.to.open.sea.cancel.delay.approval");
            List<Long> customerIdListAll = toOpenSeaTimeAfterLimitDayCustomerList.stream().map(CustomerDO::getId).collect(Collectors.toList());
            //入公海池前先取消延期申请, 因为可能出现一次太多数据的情况，批次处理
            CollectionUtil.split(customerIdListAll, 100).stream().forEach(customerIds -> {
                this.batchCancelDelayApproval(customerIds, cancelReason);
            });

            //执行更新
            customerMapper.enterToOpenSea(toOpenSeaTimeAfterLimitDayCustomerList);
            log.info("进入公海池更新结束");

        } else {
            log.info("无可进入公海池的用户");
        }

    }

    private Integer getCustomerTime(String label, int i) {
        DictDataRespDTO dictDataRespDTO = DictFrameworkUtils.parseDictDataFromCache("customer_time", label);
        return dictDataRespDTO != null ? Integer.valueOf(dictDataRespDTO.getValue()) : i;
    }

    @Override
    public CustomerDO getByMemberUserId(Long memberUserId) {
        return customerMapper.getByMemberUserId(memberUserId);
    }

    @Override
    @Async
    public void asyncUpdateCompany(Long customerId, String company) {
        if (StringUtils.isNotBlank(company)) {
            CustomerDO customerDO = new CustomerDO();
            customerDO.setId(customerId);
            customerDO.setCompany(company);
            this.updateById(customerDO);
        }
    }

    @Override
    public void updateCustomerStatus(Long customerId, CustomerStatusEnum customerStatusEnum) {
        if (customerId != null) {
            CustomerDO customerDO = this.getById(customerId);
            if (customerDO != null) {
                if (customerStatusEnum.equals(CustomerStatusEnum.DEAL) && !customerDO.getStatus().equals(CustomerStatusEnum.DEAL.getValue())) {
                    customerDO.setCreateOfferPostponeNum(0);
                }
                customerDO.setStatus(customerStatusEnum.getValue());
                customerMapper.updateById(customerDO);

                //更新关联会员的成交状态
                memberUserApi.updateMemberUserDealStatus(customerId, customerStatusEnum.getValue());
            }
        }
    }

    @Override
    public CustomerDelayApprovalInfoDto getDelayApprovalInfo(Long customerId) {
        CustomerDelayApprovalInfoDto delayApprovalInfoDto = new CustomerDelayApprovalInfoDto();
        CustomerApprovalDO approvalDO = customerApprovalService.getOne(new LambdaQueryWrapper<CustomerApprovalDO>()
                .eq(CustomerApprovalDO::getType, 1)
                .eq(CustomerApprovalDO::getStatus, 1)
                .eq(CustomerApprovalDO::getCustomerId, customerId)
                .orderByDesc(CustomerApprovalDO::getApprovalId)
                .last("limit 1")
        );
        if (Objects.nonNull(approvalDO)) {
            delayApprovalInfoDto = JSONObject.parseObject(approvalDO.getDetails(), CustomerDelayApprovalInfoDto.class);
            delayApprovalInfoDto.setStatus(approvalDO.getStatus());
            delayApprovalInfoDto.setFormId(approvalDO.getFormId());
            delayApprovalInfoDto.setApprovalId(approvalDO.getApprovalId());
        } else {
            CustomerDO customerDO = customerMapper.selectById(customerId);
            if (Objects.isNull(customerDO)) {
                throw exception(CUSTOMER_NOT_EXISTS);
            }
            delayApprovalInfoDto.setCustomerName(customerDO.getName());
            delayApprovalInfoDto.setCustomerId(customerId);
            delayApprovalInfoDto.setOrgEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime());
            delayApprovalInfoDto.setStatus(0);
            AdminUserRespDTO adminUserRespDTO = adminUserApi.getUser(customerDO.getCustomerService());
            if (Objects.nonNull(adminUserRespDTO)) {
                delayApprovalInfoDto.setFollowUpSalesmanId(String.valueOf(adminUserRespDTO.getId()));
                delayApprovalInfoDto.setFollowUpSalesmanName(adminUserRespDTO.getNickname());
            }
        }
        return delayApprovalInfoDto;
    }

    @Override
    public CustomerDelayApprovalInfoDto getDelayApproval(Long approvalId) {
        CustomerDelayApprovalInfoDto delayApprovalInfoDto = new CustomerDelayApprovalInfoDto();
        CustomerApprovalDO approvalDO = customerApprovalService.getCustomerApproval(approvalId);
        if (Objects.nonNull(approvalDO)) {
            delayApprovalInfoDto = JSONObject.parseObject(approvalDO.getDetails(), CustomerDelayApprovalInfoDto.class);
            delayApprovalInfoDto.setStatus(approvalDO.getStatus());
            delayApprovalInfoDto.setFormId(approvalDO.getFormId());
            delayApprovalInfoDto.setApprovalId(approvalDO.getApprovalId());
        }
        return delayApprovalInfoDto;
    }

    @Override
    public void delayApproval(CustomerDelayApprovalInfoDto delayApprovalInfoDto) {
        if (Objects.isNull(delayApprovalInfoDto.getEstimateEnterOpenSeaTime())) {
            throw exception(ESTIMATE_ENTER_OPEN_SEA_TIME_NOT_NULL);
        }
        String creator = String.valueOf(getLoginUserId());
        CustomerDO customerDO = customerMapper.selectById(delayApprovalInfoDto.getCustomerId());
        if (Objects.isNull(customerDO)) {
            throw exception(CUSTOMER_NOT_EXISTS);
        }
        if (customerDO.getDelayApprovalNum() >= 1) {
            throw exception(CUSTOMER_DELAY_APPROVAL_MORE_THEN_ONE);
        }
        if (customerDO.getIsInOpenSea()) {
            throw exception(CUSTOMER_HAS_IN_OPEN_SEA);
        }
        if (customerDO.getEstimateEnterOpenSeaTime() == null) {
            if (customerDO.getCustomerService() == null) {
                throw exception(CUSTOMER_CANNOT_DELAY_APPROVAL_WITH_NO_CUSTOMER_SERVICE);
            }
            if (customerDO.getCustomerService() != null && !Boolean.TRUE.equals(customerDO.getIsCustomerServiceConfirmed())) {
                throw exception(CUSTOMER_CANNOT_DELAY_APPROVAL_WITH_CUSTOMER_SERVICE_UNCONFIRMED);
            }
            throw exception(CUSTOMER_CANNOT_DELAY_APPROVAL_WITH_NO_ENTER_OPEN_SEA_TIME);
        }
        // TODO 待加入配置 最大延期时间
        //long maxTime = 31 * 24 * 60 * 60 * 1000L;//原逻辑按一个月31天计算 ，现改为最多6个月
        long maxTime = 6 * 31 * 24 * 60 * 60 * 1000L;//原逻辑按一个月31天计算 ，现改为最多6个月
//        long minTime = 24 * 60 * 60 * 1000L;
        long time = DateUtils.getTimeInMillis(delayApprovalInfoDto.getEstimateEnterOpenSeaTime()) - DateUtils.getTimeInMillis(customerDO.getEstimateEnterOpenSeaTime());
        if (time <= 0 || time > maxTime) {
            throw exception(ESTIMATE_ENTER_OPEN_SEA_TIME_DELAY_TRANSFINITE);
        }
        delayApprovalInfoDto.setCustomerName(customerDO.getName());
        delayApprovalInfoDto.setCustomerNumber(customerDO.getNumber());
        delayApprovalInfoDto.setCustomerCreateTime(customerDO.getCreateTime());
        delayApprovalInfoDto.setCustomerId(delayApprovalInfoDto.getCustomerId());
        delayApprovalInfoDto.setOrgEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime());
        AdminUserRespDTO adminUserRespDTO = adminUserApi.getUser(customerDO.getCustomerService());
        if (Objects.nonNull(adminUserRespDTO)) {
            delayApprovalInfoDto.setFollowUpSalesmanId(String.valueOf(adminUserRespDTO.getId()));
            delayApprovalInfoDto.setFollowUpSalesmanName(adminUserRespDTO.getNickname());
        }
        delayApprovalInfoDto.setStatus(1);
        CustomerApprovalDO customerApprovalDO = new CustomerApprovalDO();
        customerApprovalDO.setCustomerId(delayApprovalInfoDto.getCustomerId());
        customerApprovalDO.setDetails(JSONObject.toJSONString(delayApprovalInfoDto));
        customerApprovalDO.setType(1);
        customerApprovalDO.setStatus(1);
        customerApprovalDO.setFollowUpSalesmanId(String.valueOf(customerDO.getCustomerService()));
        customerApprovalDO.setCreateTime(new Date());
        customerApprovalService.save(customerApprovalDO);
        String formId = bpmCreateServiceFactory.createBmp(Long.valueOf(creator), customerApprovalDO.getApprovalId(), QUOTATION_CUSTOMER_DELAY_PUBLIC.getKey(),
                customerDO.getNumber(), StringUtils.isNotBlank(delayApprovalInfoDto.getCcIds()) ? delayApprovalInfoDto.getCcIds().split(StrUtil.COMMA) : null);
        customerApprovalDO.setFormId(formId);
        customerApprovalService.updateById(customerApprovalDO);

        //记录延期申请审核次数
        customerMapper.updateCustomerDelayApprovalNum(customerDO.getId(), customerDO.getDelayApprovalNum() + 1);

        //纪录日志
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                .setOperator(loginUser == null ? null : loginUser.getId())
                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                .setCustomerId(customerDO.getId())
                .setNumber(customerDO.getNumber())
                .setName(customerDO.getName())
                .setNewCustomerService(customerDO.getCustomerService())
                .setOldCustomerService(customerDO.getCustomerService())
                .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                .setNewEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                .setOperateType(CustomerOperateTypeEnum.DELAY_APPLY.getValue())
                .setRemark("提交延期调入公海池申请-延期至" + DateUtils.formatDate(delayApprovalInfoDto.getEstimateEnterOpenSeaTime()));
        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
    }


    @Override
    public void cancelDelayApproval(Long approveId, String reason) {
        Long userId = getLoginUserId();
        CustomerApprovalDO approvalDO = customerApprovalService.getById(approveId);
        if (approvalDO.getDeleted() || (approvalDO.getType() != 1 && approvalDO.getStatus() != 1)) {
            throw exception(CUSTOMER_APPROVAL_STATUS_NOT_CORRECT);
        }
        if (Objects.isNull(approvalDO.getFormId())) {
            throw exception(CUSTOMER_APPROVAL_FORM_ID_NOT_EXISTS);
        }
        bpmCreateServiceFactory.cancelBmpById(userId, approvalDO.getFormId(), reason);
    }

    @Override
    public void batchCancelDelayApproval(List<Long> customerIds, String reason) {
        if (CollectionUtils.isEmpty(customerIds)) {
            return;
        }
        List<CustomerApprovalDO> approvalDOList = customerApprovalService.list(new LambdaQueryWrapper<CustomerApprovalDO>()
                .in(CustomerApprovalDO::getCustomerId, customerIds)
                .eq(CustomerApprovalDO::getStatus, 1));
        approvalDOList = approvalDOList.stream().peek(a -> {
            a.setStatus(4);
            a.setProcessingResults(reason);
        }).collect(Collectors.toList());
        customerApprovalService.updateBatch(approvalDOList);

    }

    @Override
    public void approvalCustomerDelay(String approveId, Integer result) {
        CustomerApprovalDO approvalDO = customerApprovalService.getById(approveId);
        if (Objects.isNull(approvalDO)) {
            throw exception(CUSTOMER_APPROVAL_INFO_NOT_FIND);
        }
        approvalDO.setStatus(result);
        if (result == 1) {
            // 进行中的审批直接返回
            return;
        }
        CustomerDO customerDO = customerMapper.selectById(approvalDO.getCustomerId());
        if (Objects.isNull(customerDO) || customerDO.getIsInOpenSea()) {
            // 客户不存在取消
            approvalDO.setStatus(4);
            approvalDO.setProcessingResults(Objects.isNull(customerDO) ? "客户不存在了，取消审核" : "客户掉入公海池，取消审核");
            customerApprovalService.updateById(approvalDO);
            return;
        }
        // 查询最后审核的详细信息
        TaskResp taskResp = bpmCreateServiceFactory.getLastTaskByProcessInstanceId(approvalDO.getFormId());
        CustomerDelayApprovalInfoDto delayApprovalInfoDto = JSONObject.parseObject(approvalDO.getDetails(), CustomerDelayApprovalInfoDto.class);
        delayApprovalInfoDto.setStatus(result);
        delayApprovalInfoDto.setProcessingResults(taskResp.getComment());
        // 查询最后审核的详细信息
        approvalDO.setDetails(JSONObject.toJSONString(delayApprovalInfoDto));
        approvalDO.setFinishBy(String.valueOf(taskResp.getAssigneeUser().getId()));
        approvalDO.setFinishTime(new Date());
        approvalDO.setProcessingResults(taskResp.getComment());
        customerApprovalService.updateById(approvalDO);
        if (result == 3 || result == 4) {
            //纪录日志
            LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
            CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                    .setOperator(loginUser == null ? null : loginUser.getId())
                    .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                    .setCustomerId(customerDO.getId())
                    .setNumber(customerDO.getNumber())
                    .setName(customerDO.getName())
                    .setNewCustomerService(customerDO.getCustomerService())
                    .setOldCustomerService(customerDO.getCustomerService())
                    .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                    .setNewEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                    .setOperateType(CustomerOperateTypeEnum.DELAY_APPLY.getValue())
                    .setRemark("申请延期审批" + (result == 3 ? "拒绝" : "取消"));
            customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

            return;
        }
        Date oldEstimateEnterOpenSeaTime = customerDO.getEstimateEnterOpenSeaTime();
        customerDO.setEstimateEnterOpenSeaTime(delayApprovalInfoDto.getEstimateEnterOpenSeaTime());

        //纪录日志
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                .setOperator(loginUser == null ? null : loginUser.getId())
                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                .setCustomerId(customerDO.getId())
                .setNumber(customerDO.getNumber())
                .setName(customerDO.getName())
                .setNewCustomerService(customerDO.getCustomerService())
                .setOldCustomerService(customerDO.getCustomerService())
                .setOldEstimateEnterOpenSeaTime(oldEstimateEnterOpenSeaTime)
                .setNewEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                .setOperateType(CustomerOperateTypeEnum.DELAY_APPLY.getValue())
                .setRemark("申请延期审批通过");
        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

        //更新客户
        customerMapper.updateById(customerDO);
    }

    @Override
    public void approvalCustomerTransfer(String approveId, Integer result) {
        CustomerApprovalDO approvalDO = customerApprovalService.getById(approveId);
        if (Objects.isNull(approvalDO)) {
            throw exception(CUSTOMER_APPROVAL_INFO_NOT_FIND);
        }
        approvalDO.setStatus(result);
        if (result == 1) {
            // 进行中的审批直接返回
            return;
        }

        // 查询最后审核的详细信息
        TaskResp taskResp = bpmCreateServiceFactory.getLastTaskByProcessInstanceId(approvalDO.getFormId());
        CustomerHandoverApprovalInfoDto customerHandoverApprovalInfoDto = JSONObject.parseObject(approvalDO.getDetails(), CustomerHandoverApprovalInfoDto.class);
        customerHandoverApprovalInfoDto.setStatus(result);
        customerHandoverApprovalInfoDto.setProcessingResults(taskResp.getComment());
        // 查询最后审核的详细信息
        approvalDO.setDetails(JSONObject.toJSONString(customerHandoverApprovalInfoDto));
        approvalDO.setFinishBy(String.valueOf(taskResp.getAssigneeUser().getId()));
        approvalDO.setFinishTime(new Date());
        approvalDO.setProcessingResults(taskResp.getComment());
        customerApprovalService.updateById(approvalDO);

        if (customerHandoverApprovalInfoDto != null) {

            Long newCustomerServiceId = customerHandoverApprovalInfoDto.getNewCustomerServiceId();
            List<CustomerHandoverDetailDto> customerHandoverDetailDtoList = customerHandoverApprovalInfoDto.getCustomerHandoverDetailDtoList();

            if (CollectionUtil.isNotEmpty(customerHandoverDetailDtoList)) {

                if (result == 3 || result == 4) {

                    // 纪录日志
                    for (CustomerHandoverDetailDto customerHandoverDetailDto : customerHandoverDetailDtoList) {

                        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                                .setOperator(loginUser == null ? null : loginUser.getId())
                                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                                .setCustomerId(customerHandoverDetailDto.getCustomerId())
                                .setNumber(customerHandoverDetailDto.getCustomerNumber())
                                .setName(customerHandoverDetailDto.getCustomerName())
                                .setNewCustomerService(newCustomerServiceId)
                                .setOldCustomerService(customerHandoverDetailDto.getOldCustomerServiceId())
                                .setOldEstimateEnterOpenSeaTime(customerHandoverDetailDto.getOldEstimateEnterOpenSeaTime())
                                .setNewEstimateEnterOpenSeaTime(null)
                                .setOperateType(CustomerOperateTypeEnum.TRANSFER_APPLY.getValue())
                                .setRemark("客户移交申请-" + (result == 3 ? "拒绝" : "取消"));
                        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                    }
                    return;
                } else {
                    // 审批通过，执行移交
                    List<Long> customerIdList = customerHandoverDetailDtoList.stream().map(CustomerHandoverDetailDto::getCustomerId).collect(Collectors.toList());
                    List<CustomerDO> customerList = getCustomerList(customerIdList);
                    if (CollectionUtil.isNotEmpty(customerList)) {
                        this.assignedCustomer(customerList, newCustomerServiceId, CustomerOperateTypeEnum.TRANSFER, "客户移交申请-通过。" + customerHandoverApprovalInfoDto.getReason(), null);
                    }
                }
            }
        }

    }


    // @Override
    // public CustomerHandoverApprovalInfoDto getHandoverApprovalInfo(Long customerId) {
    //     CustomerHandoverApprovalInfoDto handoverApprovalInfoDto = new CustomerHandoverApprovalInfoDto();
    //     CustomerApprovalDO approvalDO = customerApprovalService.getOne(new LambdaQueryWrapper<CustomerApprovalDO>()
    //             .eq(CustomerApprovalDO::getType, 1)
    //             .eq(CustomerApprovalDO::getStatus, 1)
    //             .eq(CustomerApprovalDO::getCustomerId, customerId)
    //             .orderByDesc(CustomerApprovalDO::getApprovalId)
    //             .last("limit 1"), false
    //     );
    //     if (Objects.nonNull(approvalDO)) {
    //         handoverApprovalInfoDto = JSONObject.parseObject(approvalDO.getDetails(), CustomerHandoverApprovalInfoDto.class);
    //         handoverApprovalInfoDto.setStatus(approvalDO.getStatus());
    //         handoverApprovalInfoDto.setFormId(approvalDO.getFormId());
    //         handoverApprovalInfoDto.setApprovalId(approvalDO.getApprovalId());
    //     } else {
    //         CustomerDO customerDO = customerMapper.selectById(customerId);
    //         if (Objects.isNull(customerDO)) {
    //             throw exception(CUSTOMER_NOT_EXISTS);
    //         }
    //         handoverApprovalInfoDto.setCustomerName(customerDO.getName());
    //         handoverApprovalInfoDto.setCustomerId(customerId);
    //         handoverApprovalInfoDto.setOrgEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime());
    //         handoverApprovalInfoDto.setStatus(0);
    //         AdminUserRespDTO adminUserRespDTO = adminUserApi.getUser(customerDO.getCustomerService());
    //         if (Objects.nonNull(adminUserRespDTO)) {
    //             handoverApprovalInfoDto.setFollowUpSalesmanId(String.valueOf(adminUserRespDTO.getId()));
    //             handoverApprovalInfoDto.setFollowUpSalesmanName(adminUserRespDTO.getNickname());
    //         }
    //     }
    //     return handoverApprovalInfoDto;
    // }

    @Override
    public CustomerHandoverApprovalInfoDto getHandoverApproval(Long approvalId) {
        CustomerHandoverApprovalInfoDto handoverApprovalInfoDto = new CustomerHandoverApprovalInfoDto();
        CustomerApprovalDO approvalDO = customerApprovalService.getCustomerApproval(approvalId);
        if (Objects.nonNull(approvalDO)) {
            handoverApprovalInfoDto = JSONObject.parseObject(approvalDO.getDetails(), CustomerHandoverApprovalInfoDto.class);

            handoverApprovalInfoDto.setStatus(approvalDO.getStatus());
            handoverApprovalInfoDto.setFormId(approvalDO.getFormId());
            handoverApprovalInfoDto.setApprovalId(approvalDO.getApprovalId());
        }
        return handoverApprovalInfoDto;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String handoverApproval(CustomerHandOverReqVO customerHandOverReqVO) {

        List<Long> customerIdList = customerHandOverReqVO.getCustomerIdList();
        if (CollectionUtil.isEmpty(customerIdList)) {
            throw exception(HANDOVER_CUSTOMER_NOT_NULL);
        }

        Long newCustomerServiceId = customerHandOverReqVO.getCustomerServiceId();
        AdminUserRespDTO newCustomerServiceDO = adminUserApi.getUser(newCustomerServiceId);

        Long deptIdNew = newCustomerServiceDO.getDeptId();
        if (deptIdNew == null) {
            throw exception(HANDOVER_CUSTOMER_SERVICE_DEPT_NOT_NULL);
        }
        //未确认接收的客户
        List<CustomerDO> unConfirmedCustomerList = new ArrayList<>();

        // 直接转移的客户
        List<CustomerDO> directHandoverCustomerList = new ArrayList<>();
        // 需要审批的客户对象
        // List<CustomerHandoverDetailDto> handoverApprovalList = new ArrayList<>();

        //key: customerIdOld,  value: 审批客户列表
        Map<Long, List<CustomerHandoverDetailDto>> customerServiceOldWithHandoverApprovalMap = new HashMap<>();

        List<DeptRespDTO> depts = deptApi.getDepts();

        // 无客户经理和客户经理所属部门跟当前客户经理不是一个部门的，需要审批。同一部门或无客户经理的，直接修改。
        for (Long customerId : customerIdList) {
            CustomerDO customerDO = customerMapper.selectById(customerId);
            if (customerDO != null) {
                Long customerServiceOld = customerDO.getCustomerService();
                if (customerServiceOld == null || customerServiceOld.equals(0)) {
                    directHandoverCustomerList.add(customerDO);
                } else {
                    //未确认接收的属于无客户经理
                    if (!customerDO.getIsCustomerServiceConfirmed()) {
                        unConfirmedCustomerList.add(customerDO);
                    } else {
                        //判断客户经理的所属部门跟新经理是不是同一部门
                        AdminUserRespDTO oldCustomerServiceDO = adminUserApi.getUser(customerServiceOld);
                        if (oldCustomerServiceDO != null) {
                            Long deptIdOld = oldCustomerServiceDO.getDeptId();

                            if (Objects.equals(deptIdNew, deptIdOld)) {
                                directHandoverCustomerList.add(customerDO);
                            } else {
                                List<CustomerHandoverDetailDto> handoverApprovalList = customerServiceOldWithHandoverApprovalMap.get(customerServiceOld);
                                if (handoverApprovalList == null) {
                                    handoverApprovalList = new ArrayList<>();
                                    customerServiceOldWithHandoverApprovalMap.put(customerServiceOld, handoverApprovalList);
                                }

                                String deptName = depts.stream().filter(t -> t.getId().equals(deptIdOld)).map(DeptRespDTO::getName).findFirst().orElse(null);
                                handoverApprovalList.add(new CustomerHandoverDetailDto(customerId, customerDO.getName(), customerDO.getNameEn(),
                                        customerDO.getNumber(), customerServiceOld, oldCustomerServiceDO.getNickname(), deptName, customerDO.getEstimateEnterOpenSeaTime()));
                            }
                        }
                    }

                }
            }
        }

        if (CollectionUtil.isNotEmpty(unConfirmedCustomerList)) {

            String unConfirmedContent = unConfirmedCustomerList.stream().map(customerDO -> String.format("%s(%s)",
                    I18nMessage.getLang() == 0 ? customerDO.getName() : customerDO.getNameEn(), customerDO.getNumber()
            )).collect(Collectors.joining(", "));

            throw exception(HANDOVER_CUSTOMER_UNCONFIRMED, unConfirmedContent);
        }

        if (CollectionUtil.isNotEmpty(customerServiceOldWithHandoverApprovalMap)) {
            StringJoiner approvingCustomer = new StringJoiner(", ");

            for (List<CustomerHandoverDetailDto> list : customerServiceOldWithHandoverApprovalMap.values()) {
                for (CustomerHandoverDetailDto customerHandoverDetailDto : list) {
                    // 判断是否有审批中移交的客户
                    CustomerApprovalDO approvalDO = customerApprovalService.getCustomerHandoverApprovalByCustomerId(customerHandoverDetailDto.getCustomerId());
                    if (approvalDO != null) {
                        approvingCustomer.add(String.format("%s(%s)", customerHandoverDetailDto.getCustomerName(), customerHandoverDetailDto.getCustomerNumber()));
                    }
                }
            }

            String approvingCustomerStr = approvingCustomer.toString();
            if (StringUtils.isNotEmpty(approvingCustomerStr)) {
                //客户移交正在审批中不能重复提交：{}
                throw exception(HANDOVER_CUSTOMER_APPROVING, approvingCustomerStr);
            }
        }

        //直接转移
        if (CollectionUtil.isNotEmpty(directHandoverCustomerList)) {
            this.assignedCustomer(directHandoverCustomerList, newCustomerServiceId, CustomerOperateTypeEnum.TRANSFER, "客户移交部门相同，直接移交。" + customerHandOverReqVO.getReason(), JSON.toJSONString(customerHandOverReqVO));
        }

        if (CollectionUtil.isNotEmpty(customerServiceOldWithHandoverApprovalMap)) {
            customerServiceOldWithHandoverApprovalMap.forEach((customerServiceOld, customerHandoverDetailDtoList) -> {

                CustomerHandoverApprovalInfoDto handoverApprovalInfoDto = new CustomerHandoverApprovalInfoDto();
                // 移交审批
                handoverApprovalInfoDto.setType(2);
                // 设置新客户经理的信息
                handoverApprovalInfoDto.setNewCustomerServiceId(newCustomerServiceId);
                String newCustomerServiceName = newCustomerServiceDO.getNickname();
                handoverApprovalInfoDto.setNewCustomerServiceName(newCustomerServiceName);
                DeptRespDTO dept = deptApi.getDept(deptIdNew);
                if (dept != null) {
                    handoverApprovalInfoDto.setNewCustomerServiceDeptName(dept.getName());
                }
                handoverApprovalInfoDto.setReason(customerHandOverReqVO.getReason());
                //设置移交对象
                handoverApprovalInfoDto.setCustomerHandoverDetailDtoList(customerHandoverDetailDtoList);

                // 保存客户审批对象
                CustomerApprovalDO customerApprovalDO = new CustomerApprovalDO();
                // customerApprovalDO.setCustomerId()
                customerApprovalDO.setDetails(JSONObject.toJSONString(handoverApprovalInfoDto));
                customerApprovalDO.setType(2); //移交审批
                customerApprovalDO.setStatus(1);
                // customerApprovalDO.setFollowUpSalesmanId(String.valueOf(customerDO.getCustomerService()));
                customerApprovalDO.setCreateTime(new Date());
                customerApprovalService.save(customerApprovalDO);

                String creator = String.valueOf(getLoginUserId());

                String formId = bpmCreateServiceFactory.createBmpDesignated(Long.valueOf(creator), customerApprovalDO.getApprovalId(), QUOTATION_CUSTOMER_HANDOVER.getKey(),
                        null, null, String.valueOf(customerServiceOld));
                customerApprovalDO.setFormId(formId);
                customerApprovalService.updateById(customerApprovalDO);

                // 纪录日志
                for (CustomerHandoverDetailDto customerHandoverDetailDto : customerHandoverDetailDtoList) {
                    LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                    CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                            .setOperator(loginUser == null ? null : loginUser.getId())
                            .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                            .setCustomerId(customerHandoverDetailDto.getCustomerId())
                            .setNumber(customerHandoverDetailDto.getCustomerNumber())
                            .setName(customerHandoverDetailDto.getCustomerName())
                            .setNewCustomerService(newCustomerServiceId)
                            .setOldCustomerService(customerServiceOld)
                            .setOldEstimateEnterOpenSeaTime(customerHandoverDetailDto.getOldEstimateEnterOpenSeaTime())
                            .setNewEstimateEnterOpenSeaTime(null)
                            .setOperateType(CustomerOperateTypeEnum.TRANSFER_APPLY.getValue())
                            .setUpdateBody(JSON.toJSONString(customerHandOverReqVO))
                            .setRemark("客户移交申请-[" + customerHandoverDetailDto.getOldCustomerServiceName() + "] -> [" + newCustomerServiceName + "]");
                    customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                }

            });

        }

        if (CollectionUtil.isNotEmpty(customerServiceOldWithHandoverApprovalMap) && CollectionUtil.isNotEmpty(directHandoverCustomerList)) {

            List<CustomerHandoverDetailDto> handoverApprovalList = new ArrayList<>();
            customerServiceOldWithHandoverApprovalMap.forEach((aLong, dtos) -> {
                handoverApprovalList.addAll(dtos);
            });

            //部分直接移交，部分需要提交审批
            String submitContent = handoverApprovalList.stream().map(customerHandoverDetailDto -> String.format("%s(%s)",
                    I18nMessage.getLang() == 0 ? customerHandoverDetailDto.getCustomerName() : customerHandoverDetailDto.getCustomerNameEn(), customerHandoverDetailDto.getCustomerNumber()
            )).collect(Collectors.joining(", "));

            String directContent = directHandoverCustomerList.stream().map(customerDO -> String.format("%s(%s)",
                    I18nMessage.getLang() == 0 ? customerDO.getName() : customerDO.getNameEn(), customerDO.getNumber()
            )).collect(Collectors.joining(", "));

            return String.format("%s" + I18nMessage.getMessage("handover.customer.success") + ", " + I18nMessage.getMessage("handover.customer.approval.success"), directContent, submitContent);

        } else if (CollectionUtil.isNotEmpty(customerServiceOldWithHandoverApprovalMap) && CollectionUtil.isEmpty(directHandoverCustomerList)) {

            List<CustomerHandoverDetailDto> handoverApprovalList = new ArrayList<>();
            customerServiceOldWithHandoverApprovalMap.forEach((aLong, dtos) -> {
                handoverApprovalList.addAll(dtos);
            });

            //只有审批提交
            String content = handoverApprovalList.stream().map(customerHandoverDetailDto -> String.format("%s(%s)",
                    I18nMessage.getLang() == 0 ? customerHandoverDetailDto.getCustomerName() : customerHandoverDetailDto.getCustomerNameEn(), customerHandoverDetailDto.getCustomerNumber()
            )).collect(Collectors.joining(", "));
            return String.format(I18nMessage.getMessage("handover.customer.approval.success"), content);

        } else if (CollectionUtil.isEmpty(customerServiceOldWithHandoverApprovalMap) && CollectionUtil.isNotEmpty(directHandoverCustomerList)) {

            //只有直接移交
            String content = directHandoverCustomerList.stream().map(customerDO -> String.format("%s(%s)",
                    I18nMessage.getLang() == 0 ? customerDO.getName() : customerDO.getNameEn(), customerDO.getNumber()
            )).collect(Collectors.joining(", "));
            return String.format(I18nMessage.getMessage("handover.customer.success"), content);

        }

        return "无需移交";
    }

    @Override
    public void cancelHandoverApproval(Long approveId, String reason) {
        Long userId = getLoginUserId();
        CustomerApprovalDO approvalDO = customerApprovalService.getById(approveId);
        if (approvalDO.getDeleted() || (approvalDO.getType() != 2 && approvalDO.getStatus() != 1)) {
            throw exception(CUSTOMER_APPROVAL_STATUS_NOT_CORRECT);
        }
        if (Objects.isNull(approvalDO.getFormId())) {
            throw exception(CUSTOMER_APPROVAL_FORM_ID_NOT_EXISTS);
        }
        bpmCreateServiceFactory.cancelBmpById(userId, approvalDO.getFormId(), reason);
    }

    @Override
    public List<CustomerDO> getToOpenSeaTimeAfterLimitDayCustomerList(Integer limitDay) {
        return customerMapper.getToOpenSeaTimeAfterLimitDayCustomerList(limitDay);
    }

    @Override
    public void assignedCustomer(List<CustomerDO> customerDOList,
                                 Long customerServiceId,
                                 CustomerOperateTypeEnum customerOperateTypeEnum,
                                 String reason,
                                 String reqBodyJson) {

        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        if (CollectionUtil.isNotEmpty(customerDOList)) {

            for (CustomerDO customerDO : customerDOList) {
                String remark = CustomerOperateTypeEnum.TRANSFER.equals(customerOperateTypeEnum) && customerDOList.size() > 1 ? "批量移交" : customerOperateTypeEnum.getName();
                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(loginUser == null ? null : loginUser.getId())
                        .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                        .setCustomerId(customerDO.getId())
                        .setNumber(customerDO.getNumber())
                        .setName(customerDO.getName())

                        .setNewCustomerService(customerServiceId)
                        .setOldCustomerService(customerDO.getCustomerService())
                        .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                        .setNewEstimateEnterOpenSeaTime(null)
                        .setOperateType(customerOperateTypeEnum.getValue())
                        .setUpdateBody(reqBodyJson)
                        .setRemark(StringUtils.isNotEmpty(reason) ? reason : remark);
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
            }
        }

        customerMapper.assignedCustomer(customerDOList, customerServiceId);

        if (CollectionUtil.isNotEmpty(customerDOList)) {
            for (CustomerDO customer : customerDOList) {
                //移交其他客户经理已成交的客户，自主开发变更公司资源类型
                if (customer.getResourceType() != null && customer.getResourceType().equals(1)
                        && CustomerStatusEnum.DEAL.getValue().equals(customer.getStatus())) {
                    customerMapper.update(null, new LambdaUpdateWrapper<CustomerDO>().eq(CustomerDO::getId, customer.getId())
                            .set(CustomerDO::getResourceType, 2));  //1开发开启 2公司客户
                }
            }
        }

        //纪录日志
        if (CollectionUtil.isNotEmpty(customerDOList)) {

            Date now = new Date();
            Integer confirmTime = getCustomerTime("confirm_time", 24);

            customerDOList.stream().forEach(customer -> {
                //添加站内信
                InternalMessageCreateReqVO internalMessageCreateReqVO = new InternalMessageCreateReqVO();
                internalMessageCreateReqVO.setToIdList(Arrays.asList(customerServiceId));
                internalMessageCreateReqVO.setFromId("");
                internalMessageCreateReqVO.setTitle("您有一个新客户已分配，待接收");

                internalMessageCreateReqVO.setContent(
                        String.format("您有一个新客户%s已分配到您，请于%d小时内跟进处理，待接收", customer.getName(), confirmTime));
                internalMessageCreateReqVO.setSendTime(now);
                internalMessageCreateReqVO.setType(3);

                internalMessageService.createInternalMessage(internalMessageCreateReqVO);
            });
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void confirmCustomer(Long customerId) {
        CustomerDO customer = customerMapper.selectById(customerId);

        Long customerService = customer.getCustomerService();
        Long loginUserId = WebFrameworkUtils.getLoginUserId();
        if (!ObjectUtil.equals(customerService, loginUserId)) {
            throw new ServiceException(ErrorCodeConstants.CUSTOMER_CONFIRM_NOT_EQUALS);
        }

        customer.setIsCustomerServiceConfirmed(true);

        Date now = new Date();

        //更新状态更新时间，为以后入公海池提供基准时间
        customer.setStatusUpdateTime(now);

        //设置预计进行公海池时间
        //Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(now, 1).toJdkDate();
        Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(now, 3).toJdkDate(); //改为延期3个月
        if (customer.getEstimateEnterOpenSeaTime() == null || customer.getEstimateEnterOpenSeaTime().compareTo(estimateEnterOpenSeaTime) == -1) {
            customer.setEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime);
            log.info("确认接收客户[{}]，设置预计掉入公海时间为[{}]", customer.getId(), estimateEnterOpenSeaTime);
        }

        customerMapper.updateById(customer);

        //海运整柜 不掉入公海
        boolean isFcl = isFcl(customer);
        if (isFcl) {
            customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
            estimateEnterOpenSeaTime = null;
            log.info("确认接收客户[{}]包含海运整柜，设置不掉入公海", customer.getId());
        }

        // 3.客户默认为新客户，当发生以下情况，需更新客户业绩类型，所指的客户，均为业绩归
        // 属一方的客户
        // 当新客户(已有已装柜订单)移交给其他客户经理，客户经理接收后，业绩类型变成老客户
        // 当新客户(已有已装柜订单)分配给其他客户经理，客户经理接收后，业绩类型变成老客户
        // 其他情况不需更新注:业绩类型只会从新客户更新到老客户，不反向更新
        if (Boolean.TRUE.equals(customer.getIsNew())) {
            //根据部门业绩日志表中的信息把新客户变为老客户
            //ecw_target_log 部门业绩日志表
            customerMapper.updateCustomerIsNewToOldByTargetLog(customerId);
        }

        //接收日志
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                .setOperator(loginUser == null ? null : loginUser.getId())
                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                .setCustomerId(customerId)
                .setNumber(customer.getNumber())
                .setName(customer.getName())
                .setNewCustomerService(customerService)
                .setNewEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime)
                .setOperateType(CustomerOperateTypeEnum.RECEIVE.getValue())
                .setRemark("直接-确认接收" + (isFcl ? "(整柜客户)" : ""));

        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

        //分配确认接收回调
        applicationContext.publishEvent(new AssignConfirmedCustomerEvent(customerId, customerService));

        //添加接收确认后判断客户是新客户还是老客户逻辑
        //前面的逻辑有可能改了客户的业绩类型，需要再次获取客户信息
        CustomerDO customer2 = customerMapper.selectById(customerId);
        ReceiveCustomerCalTypeEvent event = new ReceiveCustomerCalTypeEvent();
        event.setCustomerId(customerId);
        event.setCustomerNumber(customer2.getNumber());
        event.setIsNew(customer2.getIsNew());
        applicationContext.publishEvent(event);
        //end  添加接收确认后判断客户是新客户还是老客户逻辑
    }

    private Date getEstimateTimeByCustomerStatus(CustomerDO customer, Date now) {
        //捞取后设置预计进入公海池时间
        int offsetMonth = 0;
        if (CustomerStatusEnum.CLUE.getValue().equals(customer.getStatus())) {
            //（1）线索客户捞取后一个月未报价调入公海；
            offsetMonth = 1;
        } else if (CustomerStatusEnum.INTENTION.getValue().equals(customer.getStatus())) {
            // （1）意向客户捞取后三个月未成交调入公海 (老需求变更为下面的20230503)
            // 20230503 ）当前客户是意向，掉入公海被捞取后/移交其他客户经理接收后，客户状态变更成线索，捞取后预计掉入公海时间变为一个月后
            offsetMonth = 1;
        } else if (CustomerStatusEnum.DEAL.getValue().equals(customer.getStatus())) {
            // （1）成交客户捞取后六个月未成交调入公海
            offsetMonth = 6;
        }
        Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(now, offsetMonth).toJdkDate();
        return estimateEnterOpenSeaTime;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void catchCustomer(Long customerId) {
        // 添加客户业绩类型逻辑
        //捞取公海池客户
        CustomerDO customer = customerMapper.selectById(customerId);
        if (customer == null) {
            log.error("客户不存在");
            throw exception(ErrorCodeConstants.CUSTOMER_NOT_EXISTS);
        }
        //若数据不在公海中，则提示数据状态错误
        if (BooleanUtil.isFalse(customer.getIsInOpenSea())) {
            log.error("数据不是公海池的数据，不可捞取");
            throw exception(ErrorCodeConstants.CUSTOMER_DATA_STATUS_ERROR);
        }

        //若当前用户非客户经理，则不能捞取
        Long loginUserId = WebFrameworkUtils.getLoginUserId();
        AdminUserRespDTO user = adminUserApi.getUser(loginUserId);
        if (CollectionUtil.isEmpty(user.getPostIds())) {
            throw exception(ErrorCodeConstants.CUSTOMER_CATCH_ERROR);
        }
        // if (!user.getPostIds().contains(adminUserApi.getActiveCustomerServicePostId())) {
        //判断当前用户的角色
        if (!user.getPostIds().contains(2L) && !user.getPostIds().contains(19L)) {
            throw exception(ErrorCodeConstants.CUSTOMER_CATCH_ERROR);
        }

        Date now = new Date();
        //48小时内的数据不能捞取
        Date enterOpenSeaTime = customer.getEnterOpenSeaTime();
        if (DateUtil.offsetHour(enterOpenSeaTime, 48).compareTo(now) > 0
                && loginUserId.equals(customer.getCustomerService())) {
            throw exception(ErrorCodeConstants.CUSTOMER_OPEN_SEA_CAN_NOT_CATCH);
        }

        // 同一业务员捞取同一客户不超过3次
        long count = customerPublicCatchLogMapper.selectCount(new LambdaQueryWrapperX<CustomerPublicCatchLogDO>()
                .eq(CustomerPublicCatchLogDO::getCustomerId, customer.getId())
                .eq(CustomerPublicCatchLogDO::getCatchUserId, loginUserId));
        if (count >= 3) {
            throw exception(ErrorCodeConstants.CUSTOMER_CATCH_TIMES_MORE_THEN_THREE);
        }

        //捞取公海限制要设当天每人只能30个，每个月限制500，每天、每月的限制数值应从字典取。
        Integer catchCustomerLimitOfDay = getCustomerTime("catch_customer_limit_of_day", 30);
        count = customerPublicCatchLogMapper.selectCount(new LambdaQueryWrapperX<CustomerPublicCatchLogDO>()
                .eq(CustomerPublicCatchLogDO::getCatchUserId, loginUserId)
                .between(BaseDO::getCreateTime, DateUtils.formatDateTime(DateUtil.beginOfDay(now).toJdkDate()),
                        DateUtils.formatDateTime(DateUtil.endOfDay(now).toJdkDate())));
        if (count > catchCustomerLimitOfDay) {
            throw exception(ErrorCodeConstants.CUSTOMER_CATCH_COUNTS_LIMIT_OF_DAY, catchCustomerLimitOfDay);
        }
        //每个月限制500
        Integer catchCustomerLimitOfMonth = getCustomerTime("catch_customer_limit_of_month", 500);
        count = customerPublicCatchLogMapper.selectCount(new LambdaQueryWrapperX<CustomerPublicCatchLogDO>()
                .eq(CustomerPublicCatchLogDO::getCatchUserId, loginUserId)
                .between(BaseDO::getCreateTime, DateUtils.formatDateTime(DateUtil.beginOfMonth(now).toJdkDate()),
                        DateUtils.formatDateTime(DateUtil.endOfMonth(now).toJdkDate())));
        if (count > catchCustomerLimitOfMonth) {
            throw exception(ErrorCodeConstants.CUSTOMER_CATCH_COUNTS_LIMIT_OF_MONTH, catchCustomerLimitOfMonth);
        }


        boolean isFcl = isFcl(customer);

        //捞取后设置预计进入公海池时间
        //Date estimateEnterOpenSeaTime = isFcl ? null : DateUtil.offsetMonth(now, 1).toJdkDate();
        Date estimateEnterOpenSeaTime = isFcl ? null : DateUtil.offsetMonth(now, 3).toJdkDate();
        if (!loginUserId.equals(customer.getCustomerService())) {//如果捞取新旧客户经理不是同一个，
            estimateEnterOpenSeaTime = isFcl ? null : DateUtil.offsetMonth(now, 3).toJdkDate();//改为3个月
        }
        if (loginUserId.equals(customer.getCustomerService())) {//如果捞取新旧客户经理是同一个,且客户的最后一次成交订单归属当前客户经理，延期6个月

            List<CustomerOrderBackPageVO> orderList = customerMapper.orderList(0, 10, new CustomerOrderQueryDTO().setCustomerId(customerId));
            if (CollectionUtil.isNotEmpty(orderList) && orderList.size() > 0) {//客户成交的订单不为空
                CustomerOrderBackPageVO orderBackPageVO = orderList.get(0);
                if (loginUserId.equals(customer.getCustomerService()) && orderBackPageVO != null && loginUserId.equals(orderBackPageVO.getSalesmanId())) {//订单的客户经理和当前是同一个
                    estimateEnterOpenSeaTime = isFcl ? null : DateUtil.offsetMonth(now, 6).toJdkDate();//改为6个月
                }
            }
        }


        customerMapper.catchCustomer(loginUserId, estimateEnterOpenSeaTime, customerId);
        log.info("catchCustomer成功， customerId={}", customer.getId());

        //2. 自主开发的（指客户原来有订单）客户调入公海，捞取后变成公司资源，如果是原客户经理捞取还是自主开发，类型不变更
        if (!loginUserId.equals(customer.getCustomerService())
                && customer.getResourceType().equals(1)
                && CustomerStatusEnum.DEAL.getValue().equals(customer.getStatus())) {
            customerMapper.update(null, new LambdaUpdateWrapper<CustomerDO>().eq(CustomerDO::getId, customerId)
                    .set(CustomerDO::getResourceType, 2)); //1为开发客户 2为公司客户
        }

        //赋值新老客户经理
        Long oldCustomerService = customer.getCustomerService();
        Long newCustomerService = loginUserId;

        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        //保存客户捞取记录
        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                .setOperator(loginUser == null ? null : loginUser.getId())
                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                .setCustomerId(customer.getId())
                .setNumber(customer.getNumber())
                .setName(customer.getName())
                .setNewCustomerService(newCustomerService)
                .setOldCustomerService(oldCustomerService)
                .setOldEstimateEnterOpenSeaTime(null)
                .setNewEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime)
                .setOperateType(CustomerOperateTypeEnum.CATCH_FROM_OPEN_SEA.getValue())
                .setRemark("公海池捞取" + (isFcl ? "(整柜客户)" : ""));
        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

        if (isFcl) {
            customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
            log.info("公海池捞取客户[{}]包含海运整柜，设置不掉入公海", customer.getId());
        }

        //记录catch时间
        //对应的数据库表为 ecw_customer_public_catch_log
        customerPublicCatchLogMapper.insert(new CustomerPublicCatchLogDO(null, customer.getId(), loginUserId));

        //捞取完后 自动处理未分配客户经理异常
        applicationContext.publishEvent(
                new AutoProcessNotCustomerServiceExceptionEvent(customer.getNumber()));


        //添加捞取后修改客户是否为新客户的相关逻辑
        CalculateCustomerTypeEvent cevent = new CalculateCustomerTypeEvent();
        cevent.setCustomerNumber(customer.getNumber());
        cevent.setStatus(customer.getStatus());
        cevent.setNewCustomerService(newCustomerService);
        cevent.setOldCustomerService(oldCustomerService);
        cevent.setCustomerId(customer.getId());
        applicationContext.publishEvent(cevent);
        //end  添加捞取后修改客户是否为新客户的相关逻辑
    }

    /*
     接收客户， 添加客户业绩类型逻辑运算
     */
    public void receiveCustomer(Long customerId, Long customerServiceId) {
        CustomerDO customerDO = customerMapper.selectById(customerId);
        if (customerDO != null) {

            //完善信息后，就代表被接收，就退出公海池
            if (!Boolean.TRUE.equals(customerDO.getIsCustomerServiceConfirmed())
                    && customerServiceId.equals(customerDO.getCustomerService())) {
                Date now = new Date();
                //退出公海
                customerDO.setIsInOpenSea(false);

                //更新客户经理
                customerDO.setCustomerService(WebFrameworkUtils.getLoginUserId());
                //设置接收
                customerDO.setIsCustomerServiceConfirmed(true);
                //老的无分配时间时，需要设置分配时间
                if (customerDO.getCustomerServiceAssignedTime() == null) {
                    customerDO.setCustomerServiceAssignedTime(now);
                }

                //设置预计进行公海池时间
                //Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(now, 1).toJdkDate();
                Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(now, 3).toJdkDate();
                if (customerDO.getEstimateEnterOpenSeaTime() == null || customerDO.getEstimateEnterOpenSeaTime().compareTo(estimateEnterOpenSeaTime) == -1) {
                    customerDO.setEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime);
                }
                customerMapper.updateById(customerDO);


                boolean isFcl = isFcl(customerDO);
                //海运整柜 不掉入公海
                if (isFcl) {
                    customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
                    log.info("报价-确认接收客户[{}]包含海运整柜，设置不掉入公海", customerId);
                }

                //添加操作日志
                LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(loginUser == null ? null : loginUser.getId())
                        .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                        .setCustomerId(customerId)
                        .setNumber(customerDO.getNumber())
                        .setName(customerDO.getName())
                        .setNewCustomerService(customerServiceId)
                        .setOldCustomerService(null)
                        .setNewEstimateEnterOpenSeaTime(isFcl ? null : customerDO.getEstimateEnterOpenSeaTime())
                        .setOldEstimateEnterOpenSeaTime(null)
                        .setOperateType(CustomerOperateTypeEnum.RECEIVE.getValue())
                        .setRemark("报价-确认接收" + (isFcl ? "(整柜客户)" : ""));
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

                //分配确认接收回调
                applicationContext.publishEvent(new AssignConfirmedCustomerEvent(customerId, customerDO.getCustomerService()));

                //报价成功后就会确认接收客户，所以在此做客户类型逻辑运算
                //
                //添加接收确认后判断客户是新客户还是老客户逻辑
                //前面的逻辑有可能改了客户的业绩类型，需要再次获取客户信息
                CustomerDO customer2 = customerMapper.selectById(customerId);
                ReceiveCustomerCalTypeEvent event = new ReceiveCustomerCalTypeEvent();
                event.setCustomerId(customerId);
                event.setCustomerNumber(customer2.getNumber());
                event.setIsNew(customer2.getIsNew());
                applicationContext.publishEvent(event);
                //end  添加接收确认后判断客户是新客户还是老客户逻辑
            }
        }
    }


    @Override
    public void updateCustomerByCreateOffer(Long customerId, Date offerCreateTime) {

        CustomerDO customer = customerMapper.selectById(customerId);
        if (customer != null) {
            boolean offerConfirmFlag = false;
            Long loginUserId = WebFrameworkUtils.getLoginUserId();

            //若未被接收，则接收引客户
            if (!Boolean.TRUE.equals(customer.getIsCustomerServiceConfirmed())
                    && loginUserId.equals(customer.getCustomerService())) {

                Date now = new Date();
                // 退出公海
                customer.setIsInOpenSea(false);

                // 更新客户经理
                customer.setCustomerService(loginUserId);
                // 设置接收
                customer.setIsCustomerServiceConfirmed(true);
                // 老的无分配时间时，需要设置分配时间
                if (customer.getCustomerServiceAssignedTime() == null) {
                    customer.setCustomerServiceAssignedTime(now);
                }

                //纪录接收日志
                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(loginUserId)
                        .setOperatorName(SecurityFrameworkUtils.getLoginUserNickName())
                        .setCustomerId(customerId)
                        .setNumber(customer.getNumber())
                        .setName(customer.getName())
                        .setNewCustomerService(loginUserId)
                        .setOperateType(CustomerOperateTypeEnum.RECEIVE.getValue())
                        .setRemark("报价后接收待接收的客户");
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

                offerConfirmFlag = true;
            }

            Date oldEstimateEnterOpenSeaTime = customer.getEstimateEnterOpenSeaTime();

            //纪录接收日志
            LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
            CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                    .setOperator(loginUser == null ? null : loginUser.getId())
                    .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                    .setCustomerId(customer.getId())
                    .setNumber(customer.getNumber())
                    .setName(customer.getName())
                    .setOldEstimateEnterOpenSeaTime(oldEstimateEnterOpenSeaTime)
                    .setNewCustomerService(customer.getCustomerService())
//                    .setOldCustomerService(loginUserId)
                    .setOperateType(CustomerOperateTypeEnum.UPDATE.getValue());

            Integer customerStatus = customer.getStatus();
            if (customerStatus == null) {
                customerStatus = CustomerStatusEnum.CLUE.getValue();
            }


            //海运整柜 不掉入公海
            boolean isFcl = isFcl(customer);
            if (isFcl) {
                if (offerConfirmFlag) {
                    customerMapper.updateById(customer);
                }
                customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
                log.info("创建报价客户[{}]包含海运整柜，设置不掉入公海", customer.getId());
            } else {

                String customerStatusName = CustomerStatusEnum.getNameByValue(customerStatus);
                //int offerPostponeTimes = 3;
                int offerPostponeTimes = 2;
                // 当超过2次后不可再用报价延期
                if (customer.getCreateOfferPostponeNum() < offerPostponeTimes) {

                    Date estimateEnterOpenSeaTime = DateUtil.offsetMonth(offerCreateTime, 3).toJdkDate();
                    if (customer.getEstimateEnterOpenSeaTime() == null || customer.getEstimateEnterOpenSeaTime().compareTo(estimateEnterOpenSeaTime) == -1) {
                        customer.setEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime);
                    }
                    customer.setCreateOfferPostponeNum(customer.getCreateOfferPostponeNum() + 1);

                    customerOperateLogCreateReqVO.setNewEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                            .setRemark(customerStatusName + "客户报价后更新预计进入公海时间+3月");
                } else {
                    customerOperateLogCreateReqVO.setNewEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                            .setRemark(customerStatusName + "客户报价超过了" + offerPostponeTimes + "次，不更新进入公海时间。");
                }

                customerMapper.updateById(customer);
            }
            String remark = customerOperateLogCreateReqVO.getRemark();

            customerOperateLogCreateReqVO.setRemark((StringUtils.isNotEmpty(remark) ? remark : "") + (isFcl ? "(整柜客户)" : ""));

            //纪录日志
            customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

            if (CustomerStatusEnum.CLUE.getValue().equals(customerStatus)) {
                //（2）线索客户报价后升级到意向客户
                this.updateCustomerStatus(customerId, CustomerStatusEnum.INTENTION);

                //纪录接收日志
                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO2 = new CustomerOperateLogCreateReqVO()
                        .setOperator(loginUserId)
                        .setOperatorName(SecurityFrameworkUtils.getLoginUserNickName())
                        .setCustomerId(customer.getId())
                        .setNumber(customer.getNumber())
                        .setName(customer.getName())
                        .setOldEstimateEnterOpenSeaTime(oldEstimateEnterOpenSeaTime)
                        .setNewEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                        .setNewCustomerService(loginUserId)
                        .setOldCustomerService(loginUserId)
                        .setOperateType(CustomerOperateTypeEnum.UPDATE.getValue())
                        .setRemark("报价后将线索更新为意向" + (isFcl ? "(整柜客户)" : ""));
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO2);
            }

        }
    }

    @Override
    public void updateCustomerByCreateOrder(Long customerId, Long orderId, String orderNo, Date orderCreateTime) {

        // //下单未入仓或取消订单，线索客户变成为意向客户, 意向客户需要等下单入仓完成后才转成交客户
        CustomerDO customer = customerMapper.selectById(customerId);
        if (customer != null) {
        //     if (customer.getIsNew()) {
        //         OrderCustomerServiceEvent event = new OrderCustomerServiceEvent(customerId, null);
        //         applicationContext.publishEvent(event);
        //         if (Objects.nonNull(event.getCustomerServices()) && CollectionUtil.isNotEmpty(event.getCustomerServices()) && event.getCustomerServices().size() > 1) {
        //             // 此客户下单有过多个客户经理，确认为老客户
        //             customer.setIsNew(Boolean.FALSE);
        //         }
        //     }
        //     //若是空运，直接设置为成交
        //     if (StringUtils.isNotEmpty(customer.getTransportType()) && (customer.getTransportType().contains("4") || customer.getTransportType().contains("3"))
        //             && CustomerStatusEnum.DEAL.getValue().equals(customer.getStatus())) {
        //         // 成交
        //         this.updateCustomerStatus(customerId, CustomerStatusEnum.DEAL);
        //         //更新预计进入公海时间为null
        //         customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
        //
        //         //纪录日志
        //         LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        //         CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
        //                 .setOperator(loginUser == null ?  null : loginUser.getId())
        //                 .setOperatorName(loginUser == null ?  null : loginUser.getNickname())
        //                 .setCustomerId(customer.getId())
        //                 .setNumber(customer.getNumber())
        //                 .setName(customer.getName())
        //                 .setOrderId(orderId)
        //                 .setOrderNo(orderNo)
        //                 .setOperateType(CustomerOperateTypeEnum.UPDATE.getValue())
        //                 .setRemark("空运/整柜客户下单，更新入公海时间为空");
        //         customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
        //
        //         return;
        //     }
        //
        //     Date oldEstimateEnterOpenSeaTime = customer.getEstimateEnterOpenSeaTime();
        //
        //     if (CustomerStatusEnum.CLUE.getValue().equals(customer.getStatus())) {
        //         //（3）下单未完成入仓或取消，掉公海时间，根据订单生成的时间往后延期三个月
        //         Date date = DateUtil.offsetMonth(orderCreateTime, 3).toJdkDate();
        //         if (customer.getEstimateEnterOpenSeaTime() == null || customer.getEstimateEnterOpenSeaTime().compareTo(date) == -1) {
        //             customer.setEstimateEnterOpenSeaTime(date);
        //         }
        //         customerMapper.updateById(customer);
        //         //线索转意向
        //         this.updateCustomerStatus(customerId, CustomerStatusEnum.INTENTION);
        //
        //     } else if (CustomerStatusEnum.INTENTION.getValue().equals(customer.getStatus())) {
        //         //（2）赢单下单未入仓或取消，根据创建的时间往后延期三个月调入公海。
        //         //（3）赢单下单入仓或新建订单入仓，根据订单入仓的时间往后延期六个月调入公海。
        //         Date date = DateUtil.offsetMonth(orderCreateTime, 3).toJdkDate();
        //         if (customer.getEstimateEnterOpenSeaTime() == null || customer.getEstimateEnterOpenSeaTime().compareTo(date) == -1) {
        //             customer.setEstimateEnterOpenSeaTime(date);
        //         }
        //         customerMapper.updateById(customer);
        //     } else if (CustomerStatusEnum.DEAL.getValue().equals(customer.getStatus())) {
        //
        //         // （（2）报价赢单或下单未完成入仓，根据捞取时间往后延期六个月（注意：期间如产生多个报价单或订单，都未完成入仓，初始时间默认按照捞取的时间）
        //         Date date = DateUtil.offsetMonth(orderCreateTime, 6).toJdkDate();
        //         if (customer.getEstimateEnterOpenSeaTime() == null || customer.getEstimateEnterOpenSeaTime().compareTo(date) == -1) {
        //             customer.setEstimateEnterOpenSeaTime(date);
        //         }
        //         customerMapper.updateById(customer);
        //     }
        //
            //纪录日志
            LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
            CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                    .setOperator(loginUser == null ?  null : loginUser.getId())
                    .setOperatorName(loginUser == null ?  null : loginUser.getNickname())
                    .setCustomerId(customer.getId())
                    .setNumber(customer.getNumber())
                    .setName(customer.getName())
                    .setOrderId(orderId)
                    .setOrderNo(orderNo)
                    // .setOldEstimateEnterOpenSeaTime(oldEstimateEnterOpenSeaTime)
                    .setOldEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                    .setNewEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                    .setOperateType(CustomerOperateTypeEnum.ORDER_CREATED.getValue())
                    .setRemark("客户下单");
            customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
        }

    }

    @Override
    public void updateCustomerByFinishWarehouseIn(Long customerId,
                                                  Long orderId,
                                                  String orderNo,
                                                  Date rucangTime) {

        //更新客户状态
        CustomerDO customer = customerMapper.selectById(customerId);
        if (customer != null) {
            Date oldEstimateEnterOpenSeaTime =
                    customer.getEstimateEnterOpenSeaTime();

            boolean isFcl = isFcl(customer);
            //海运整柜 不掉入公海
            if (isFcl) {
                customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
                log.info("完成入仓客户[{}]包含海运整柜，设置不掉入公海", customer.getId());
            } else {
                // 下单完成入仓，根据订单入仓的时间往后延期六个月
                //Date date = DateUtil.offsetMonth(rucangTime, 6).toJdkDate();
                Date date = DateUtil.offsetMonth(rucangTime, 12).toJdkDate();
                if (customer.getEstimateEnterOpenSeaTime() == null ||
                        customer.getEstimateEnterOpenSeaTime().compareTo(date) == -1) {
                    customer.setEstimateEnterOpenSeaTime(date);
                }


                customerMapper.updateById(customer);

                //纪录日志
                LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(loginUser == null ? null : loginUser.getId())
                        .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                        .setCustomerId(customer.getId())
                        .setNumber(customer.getNumber())
                        .setName(customer.getName())
                        .setOrderId(orderId)
                        .setOrderNo(orderNo)
                        .setOldEstimateEnterOpenSeaTime(oldEstimateEnterOpenSeaTime)
                        .setNewEstimateEnterOpenSeaTime(isFcl ? null : customer.getEstimateEnterOpenSeaTime())
                        .setOperateType(CustomerOperateTypeEnum.ORDER_WAREHOUSE_IN.getValue())
                        .setRemark("操作入仓完成，延长掉入公海日期");
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

            }

            //纪录日志
            LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
            CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                    .setOperator(loginUser == null ? null : loginUser.getId())
                    .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                    .setCustomerId(customer.getId())
                    .setNumber(customer.getNumber())
                    .setName(customer.getName())
                    .setOrderId(orderId)
                    .setOrderNo(orderNo)
                    .setOldEstimateEnterOpenSeaTime(oldEstimateEnterOpenSeaTime)
                    .setNewEstimateEnterOpenSeaTime(isFcl ? null : customer.getEstimateEnterOpenSeaTime())
                    .setOperateType(CustomerOperateTypeEnum.ORDER_WAREHOUSE_IN.getValue())
                    .setRemark("下单完成入仓" + (isFcl ? "(整柜客户)" : ""));
            customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

            //转成成交客户
            if (CustomerStatusEnum.CLUE.getValue().equals(customer.getStatus()) ||
                    CustomerStatusEnum.INTENTION.getValue().equals(customer.getStatus())) {
                this.updateCustomerStatus(customerId, CustomerStatusEnum.DEAL);
            }
        }

    }

    @Override
    public void updateCustomerStatusAndEstimateEnterOpenSeaTime(Long customerId, CustomerStatusEnum customerStatusEnum,
                                                                Date estimateEnterToOpenSeaTime, boolean logOrNot, String logRemark) {
        //更新客户状态
        CustomerDO customer = customerMapper.selectById(customerId);
        if (customer != null) {
            Date oldEstimateEnterOpenSeaTime = customer.getEstimateEnterOpenSeaTime();

            if (estimateEnterToOpenSeaTime == null) {
                customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerId);
            } else {

                // 当老的入公海时间为空 或者 小于新的入公海时间，则更新
                if (oldEstimateEnterOpenSeaTime == null || oldEstimateEnterOpenSeaTime.compareTo(estimateEnterToOpenSeaTime) == -1) {
                    customer.setEstimateEnterOpenSeaTime(estimateEnterToOpenSeaTime);
                }
                customerMapper.updateById(customer);
            }

            //纪录日志
            if (logOrNot) {
                LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(loginUser == null ? null : loginUser.getId())
                        .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                        .setCustomerId(customer.getId())
                        .setNumber(customer.getNumber())
                        .setName(customer.getName())
                        .setOldEstimateEnterOpenSeaTime(oldEstimateEnterOpenSeaTime)
                        .setNewEstimateEnterOpenSeaTime(estimateEnterToOpenSeaTime == null ? null : customer.getEstimateEnterOpenSeaTime())
                        .setOperateType(CustomerOperateTypeEnum.UPDATE.getValue())
                        .setRemark(StringUtils.isNotEmpty(logRemark) ? logRemark : "更新客户状态和入公海时间");
                customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
            }

            //更新客户状态
            this.updateCustomerStatus(customerId, customerStatusEnum);
        }
    }

    @Override
    public void updateCustomerStatusByExistedOrderAndOffer(Long customerId, boolean logOrNot) {
        CustomerDO customerDO = customerMapper.selectById(customerId);

        if (customerDO != null) {
            QueryEstimateEnterOpenSeaTimeEvent orderEvent = new QueryEstimateEnterOpenSeaTimeEvent(customerDO.getId(), customerDO.getCreateTime(), customerDO.getTransportType(), null, null);
            applicationContext.publishEvent(orderEvent);

            //返回的预计进行公海池时间和客户类型
            Integer customerStatus = orderEvent.getReturnEstimateCustomerStatus();
            Date estimateEnterOpenSeaTime = orderEvent.getReturnEstimateEnterOpenSeaTime();

            this.updateCustomerStatusAndEstimateEnterOpenSeaTime(customerId, CustomerStatusEnum.get(customerStatus),
                    estimateEnterOpenSeaTime, logOrNot, "根据现有订单和报价更新客户状态和入公海时间");

            //若是新客户，则看是否需要更新为老客户
            if (Boolean.TRUE.equals(customerDO.getIsNew())) {
                customerMapper.updateCustomerIsNewToOldByTargetLog(customerId);
            } else {
                //TODO 老客户还原为新客户

            }
        }

    }

    @Override
    public void enterToOpenSea(List<CustomerDO> customerDOList) {
        customerMapper.enterToOpenSea(customerDOList);
    }

    @Override
    public void changeOldCustomerNumber() {


        List<CustomerDO> oldCustomerNumberList = customerMapper.getOldCustomerNumberList();
        if (CollectionUtil.isNotEmpty(oldCustomerNumberList)) {
            for (CustomerDO customerDO : oldCustomerNumberList) {

                Long countryId = customerDO.getCountry();

                String customerNumber = genCustomerNumber(countryId);
                customerDO.setNumber(customerNumber);

                //更新用户
                customerMapper.updateById(customerDO);
            }
        }


    }


    @Override
    public void changeCustomerAir(CustomerChangeAirReqVO customerChangeAirReqVO) {

        List<CustomerDO> customerDOList = customerMapper.selectBatchIds(customerChangeAirReqVO.getCustomerIdList());

        if (CollectionUtil.isNotEmpty(customerDOList)) {

            List<String> openSeaCustomerNameList = customerDOList.stream().filter(t -> Boolean.TRUE.equals(t.getIsInOpenSea())).map(CustomerDO::getNumber).collect(Collectors.toList());
            if (CollectionUtil.isNotEmpty(openSeaCustomerNameList)) {
                String customerName = String.join(", ", openSeaCustomerNameList);
                throw ServiceExceptionUtil.exception(ErrorCodeConstants.OPEN_SEA_CUSTOMER_CANNOT_SET_AIR, customerName);
            }

            List<CustomerDO> estimateEnterToOpenSeaList = new ArrayList<>();

            customerDOList.stream().forEach(customerDO -> {

                // 设置空运客户
                Boolean isAir = customerChangeAirReqVO.getIsAir();
                if (Boolean.TRUE.equals(isAir)) {


                    // 2. 全部客户列表中，新增【空运客户】按钮和【非空运客户】按钮，支持权限配置
                    // 当勾选客户点击【空运客户】，则客户不掉入公海，出货渠道-空运专线默认勾选，客户状态修改成成交

                    // 设置空运专线
                    String transportType = customerDO.getTransportType();
                    if (StringUtils.isEmpty(transportType)) {
                        transportType = "4";
                    } else if (!transportType.contains("4")) {
                        transportType += ",4";
                    }
                    customerDO.setTransportType(transportType);

                    // 设置成交
                    customerDO.setStatus(CustomerStatusEnum.DEAL.getValue());

                    //设置非公海客户
                    customerDO.setIsInOpenSea(false);

                    customerMapper.updateById(customerDO);

                    //更新进入公海时间为 null
                    customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerDO.getId());

                    LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                    CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                            .setOperator(loginUser == null ? null : loginUser.getId())
                            .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                            .setCustomerId(customerDO.getId())
                            .setNumber(customerDO.getNumber())
                            .setName(customerDO.getName())
                            .setOperateType(CustomerOperateTypeEnum.CHANGE_TO_AIR.getValue())
                            .setRemark("设置空运-不进入公海");
                    customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                }
                // 取消设置空运专线
                else {

                    // 当勾选客户点击【非空运客户】，则客户根据系统当前掉入公海逻辑，出货渠道-空运专线取消勾选，客户状态跟进原有逻辑判断，客户有报价单则为意向，有订单已入仓则成交，否则为线索
                    String transportType = customerDO.getTransportType();
                    if (StringUtils.isNotEmpty(transportType) && transportType.contains("4")) {
                        List<String> list = Arrays.stream(StringUtils.split(transportType, ",")).filter(t -> !t.equals("4")).collect(Collectors.toList());
                        transportType = String.join(",", list);
                    }
                    customerDO.setTransportType(transportType);

                    QueryEstimateEnterOpenSeaTimeEvent orderEvent = new QueryEstimateEnterOpenSeaTimeEvent(customerDO.getId(), customerDO.getCreateTime(), customerDO.getTransportType(), null, null);
                    applicationContext.publishEvent(orderEvent);

                    //返回的预计进行公海池时间和客户类型
                    Integer customerStatus = orderEvent.getReturnEstimateCustomerStatus();
                    Date estimateEnterOpenSeaTime = orderEvent.getReturnEstimateEnterOpenSeaTime();


                    //若小于当前时间,则进入公海
                    if (estimateEnterOpenSeaTime != null && estimateEnterOpenSeaTime.compareTo(new Date()) < 1) {
                        //进入公海
                        estimateEnterToOpenSeaList.add(customerDO);

                    }
                    if (customerDO.getEstimateEnterOpenSeaTime() == null || customerDO.getEstimateEnterOpenSeaTime().compareTo(estimateEnterOpenSeaTime) == -1) {
                        customerDO.setEstimateEnterOpenSeaTime(estimateEnterOpenSeaTime);
                    }
                    customerDO.setStatus(customerStatus);

                    customerMapper.updateById(customerDO);

                    LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                    CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                            .setOperator(loginUser == null ? null : loginUser.getId())
                            .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                            .setCustomerId(customerDO.getId())
                            .setNumber(customerDO.getNumber())
                            .setName(customerDO.getName())
                            .setNewEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                            .setOperateType(CustomerOperateTypeEnum.CHANGE_TO_UNAIR.getValue())
                            .setRemark("设置非空运-重新计算掉入公海时间");
                    customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                }

                if (CollectionUtil.isNotEmpty(estimateEnterToOpenSeaList)) {
                    customerMapper.enterToOpenSea(estimateEnterToOpenSeaList);
                }


                // 纪录日志
                CustomerAirLogDO customerAirLogDO = new CustomerAirLogDO();
                customerAirLogDO.setCustomerId(customerDO.getId());
                customerAirLogDO.setCustomerNumber(customerDO.getNumber());
                customerAirLogDO.setIsAir(isAir);
                customerAirLogMapper.insert(customerAirLogDO);

            });
        }
    }

    @Override
    public void changeCustomerFcl(CustomerChangeFclReqVO customerChangeFclReqVO) {

        List<CustomerDO> customerDOList = customerMapper.selectBatchIds(customerChangeFclReqVO.getCustomerIdList());

        if (CollectionUtil.isNotEmpty(customerDOList)) {

            List<String> openSeaCustomerNameList = customerDOList.stream().filter(t -> Boolean.TRUE.equals(t.getIsInOpenSea())).map(CustomerDO::getNumber).collect(Collectors.toList());
            if (CollectionUtil.isNotEmpty(openSeaCustomerNameList)) {
                String customerName = String.join(", ", openSeaCustomerNameList);
                throw ServiceExceptionUtil.exception(ErrorCodeConstants.OPEN_SEA_CUSTOMER_CANNOT_SET_FCL, customerName);
            }

            List<CustomerDO> estimateEnterToOpenSeaList = new ArrayList<>();

            customerDOList.stream().forEach(customerDO -> {

                // 设置海运整柜客户
                Boolean isFcl = customerChangeFclReqVO.getIsFcl();
                if (Boolean.TRUE.equals(isFcl)) {


                    // 2. 全部客户列表中，新增【海运整柜客户】按钮和【非海运整柜客户】按钮，支持权限配置
                    // 当勾选客户点击【海运整柜客户】，则客户不掉入公海，出货渠道-海运整柜默认勾选，客户状态修改成成交

                    // 设置空运专线
                    String transportType = customerDO.getTransportType();
                    if (StringUtils.isEmpty(transportType)) {
                        transportType = "3";
                    } else if (!transportType.contains("3")) {
                        transportType += ",3";
                    }
                    customerDO.setTransportType(transportType);

                    // 设置成交
                    customerDO.setStatus(CustomerStatusEnum.DEAL.getValue());

                    //设置非公海客户
                    customerDO.setIsInOpenSea(false);

                    customerMapper.updateById(customerDO);

                    //更新进入公海时间为
                    customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerDO.getId());

                    LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                    CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                            .setOperator(loginUser == null ? null : loginUser.getId())
                            .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                            .setCustomerId(customerDO.getId())
                            .setNumber(customerDO.getNumber())
                            .setName(customerDO.getName())
                            .setOperateType(CustomerOperateTypeEnum.CHANGE_TO_FCL.getValue())
                            .setRemark("设置海运整柜客户-不进入公海");
                    customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                }
                // 取消设置整柜客户
                else {

                    // 当勾选客户点击【非整柜客户】，则客户根据系统当前掉入公海逻辑，出货渠道-海运整柜取消勾选，客户状态跟进原有逻辑判断，客户有报价单则为意向，有订单已入仓则成交，否则为线索
                    String transportType = customerDO.getTransportType();
                    if (StringUtils.isNotEmpty(transportType) && transportType.contains("3")) {
                        List<String> list = Arrays.stream(StringUtils.split(transportType, ",")).filter(t -> !t.equals("3")).collect(Collectors.toList());
                        transportType = String.join(",", list);
                    }
                    customerDO.setTransportType(transportType);

                    QueryEstimateEnterOpenSeaTimeEvent orderEvent = new QueryEstimateEnterOpenSeaTimeEvent(customerDO.getId(), customerDO.getCreateTime(), customerDO.getTransportType(), null, null);
                    applicationContext.publishEvent(orderEvent);

                    //返回的预计进行公海池时间和客户类型
                    Integer customerStatus = orderEvent.getReturnEstimateCustomerStatus();
                    Date calcEstimateEnterOpenSeaTime = orderEvent.getReturnEstimateEnterOpenSeaTime();


                    //若小于当前时间,则进入公海
                    if (calcEstimateEnterOpenSeaTime != null && calcEstimateEnterOpenSeaTime.compareTo(new Date()) < 1) {
                        //进入公海
                        estimateEnterToOpenSeaList.add(customerDO);

                    }
                    if (customerDO.getEstimateEnterOpenSeaTime() == null || customerDO.getEstimateEnterOpenSeaTime().compareTo(calcEstimateEnterOpenSeaTime) == -1) {
                        customerDO.setEstimateEnterOpenSeaTime(calcEstimateEnterOpenSeaTime);
                    }
                    customerDO.setStatus(customerStatus);

                    customerMapper.updateById(customerDO);

                    //若计算出来的掉入公海时间为空，则更新为空
                    if (calcEstimateEnterOpenSeaTime == null) {
                        customerMapper.updateCustomerEstimateEnterOpenSeaTimeToNull(customerDO.getId());
                    }

                    LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                    CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                            .setOperator(loginUser == null ? null : loginUser.getId())
                            .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                            .setCustomerId(customerDO.getId())
                            .setNumber(customerDO.getNumber())
                            .setName(customerDO.getName())
                            .setNewEstimateEnterOpenSeaTime(calcEstimateEnterOpenSeaTime == null ? null : customerDO.getEstimateEnterOpenSeaTime())
                            .setOperateType(CustomerOperateTypeEnum.CHANGE_TO_UNFCL.getValue())
                            .setRemark("设置非海运整柜客户-重新计算掉入公海时间");
                    customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                }

                if (CollectionUtil.isNotEmpty(estimateEnterToOpenSeaList)) {
                    customerMapper.enterToOpenSea(estimateEnterToOpenSeaList);
                }

            });
        }
    }

    @Override
    public void changeCustomerNoConsignee(CustomerChangeNoConsigneeReqVO customerChangeNoConsigneeReqVO) {
        List<CustomerDO> customerDOList = customerMapper.selectBatchIds(customerChangeNoConsigneeReqVO.getCustomerIdList());

        if (CollectionUtil.isNotEmpty(customerDOList)) {
            Boolean noConsigee = customerChangeNoConsigneeReqVO.getNoConsigee();

            customerDOList.stream()
                    .filter(t -> t.getNoConsignee() == null || !t.getNoConsignee().equals(noConsigee))
                    .forEach(customerDO -> {
                        customerDO.setNoConsignee(noConsigee);
                        customerMapper.updateById(customerDO);

                        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                                .setOperator(loginUser == null ? null : loginUser.getId())
                                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                                .setCustomerId(customerDO.getId())
                                .setNumber(customerDO.getNumber())
                                .setName(customerDO.getName())
                                .setOperateType(CustomerOperateTypeEnum.CHANGE_NO_CONSIGNEE.getValue())
                                .setRemark("设置客户的控货无收货人为：" + (noConsigee ? "【是】" : "【否】"));
                        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                    });
        }
    }

    @Override
    public void changeCustomerDefaultPay(CustomerChangeDefaultPayReqVO customerChangeDefaultPayReqVO) {
        List<CustomerDO> customerDOList = customerMapper.selectBatchIds(customerChangeDefaultPayReqVO.getCustomerIdList());

        if (CollectionUtil.isNotEmpty(customerDOList)) {
            Boolean defaultPay = customerChangeDefaultPayReqVO.getDefaultPay();

            customerDOList.stream()
                    .filter(t -> t.getDefaultPay() == null || !t.getDefaultPay().equals(defaultPay))
                    .forEach(customerDO -> {
                        customerDO.setDefaultPay(defaultPay);
                        customerMapper.updateById(customerDO);

                        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                                .setOperator(loginUser == null ? null : loginUser.getId())
                                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                                .setCustomerId(customerDO.getId())
                                .setNumber(customerDO.getNumber())
                                .setName(customerDO.getName())
                                .setOperateType(CustomerOperateTypeEnum.CHANGE_DEFAULT_PAY.getValue())
                                .setRemark("设置客户的默认付款为：" + (defaultPay ? "【是】" : "【否】"));
                        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                    });
        }
    }

    @Override
    public void changeCustomerDefaultBilling(CustomerChangeDefaultBillingReqVO customerChangeDefaultBillingReqVO) {
        List<CustomerDO> customerDOList = customerMapper.selectBatchIds(customerChangeDefaultBillingReqVO.getCustomerIdList());

        if (CollectionUtil.isNotEmpty(customerDOList)) {
            Boolean defaultBilling = customerChangeDefaultBillingReqVO.getDefaultBilling();

            customerDOList.stream()
                    .filter(t -> t.getDefaultPay() == null || !t.getDefaultPay().equals(defaultBilling))
                    .forEach(customerDO -> {
                        customerDO.setDefaultBilling(defaultBilling);
                        customerMapper.updateById(customerDO);

                        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
                        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                                .setOperator(loginUser == null ? null : loginUser.getId())
                                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                                .setCustomerId(customerDO.getId())
                                .setNumber(customerDO.getNumber())
                                .setName(customerDO.getName())
                                .setOperateType(CustomerOperateTypeEnum.CHANGE_DEFAULT_PAY.getValue())
                                .setRemark("设置客户的默认开票为：" + (defaultBilling ? "【是】" : "【否】"));
                        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
                    });
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void recycleUnConfirmedCustomer(CustomerUnConfirmReqVO customerUnConfirmReqVO) {

        Long customerId = customerUnConfirmReqVO.getCustomerId();

        this.validateCustomerExists(customerId);

        CustomerDO customer = getCustomer(customerId);

        if (customer.getCustomerService() != null && customer.getCustomerServiceAssignedTime() != null
                && Boolean.FALSE.equals(customer.getIsCustomerServiceConfirmed()) && Boolean.FALSE.equals(customer.getIsInOpenSea())) {

            LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
            CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                    .setOperator(loginUser == null ? null : loginUser.getId())
                    .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                    .setCustomerId(customer.getId())
                    .setNumber(customer.getNumber())
                    .setName(customer.getName())
                    .setOldEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                    .setNewEstimateEnterOpenSeaTime(customer.getEstimateEnterOpenSeaTime())
                    .setOldCustomerService(customer.getCustomerService())
                    .setNewCustomerService(null)
                    .setOperateType(CustomerOperateTypeEnum.RECYCLE_UN_CONFIRMED_CUSTOMER.getValue())
                    .setRemark("主动回收，转移到待分配");
            customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);

            // 转移到待分配中去。
            customerMapper.moveToWaitAssigned(CollectionUtil.newArrayList(customer));
        } else {
            throw exception(CUSTOMER_CANNOT_BE_RECYCLED);
        }
    }

    @Override
    public CustomerContactsDO getUniqueOneAndValidate(String areaCode, String phone, Long excludeCustomerId) {

        return customerContactsService.getUniqueOneAndValidate(areaCode, phone, excludeCustomerId);
    }

    @Override
    public List<Long> updateCustomerToOldByCustomerService(Long customerServiceId) {
        // 判断是否是客户经理
        AdminUserRespDTO adminUserRespDTO = adminUserApi.getUser(customerServiceId);
        if (Objects.isNull(adminUserRespDTO)) {
            throw exception(PARAMETER_NOT_CUSTOMER_SERVICE);
        }
        List<Long> newDealCustomerIdList = customerMapper.getNewDealCustomerIdList(customerServiceId);

        customerMapper.updateCustomerToOldByCustomerService(customerServiceId);

        return newDealCustomerIdList;
    }

    @Override
    @Async
    public void asyncLogUpdateCustomerToOldByCustomerService(Long customerService, List<Long> newDealCustomerIdList) {
        // 纪录日志
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        int pageSize = 100;

        //异常执行，分页查询，记录客户操作日志。
        int count = newDealCustomerIdList.size();
        if (count <= 0) {
            return;
        }

        // 批量插入操作日志
        for (int pageNo = 0; ; pageNo++) {

            List<Long> pageList = CollUtil.page(pageNo, pageSize, newDealCustomerIdList);
            if (CollectionUtil.isEmpty(pageList)) break;

            List<CustomerDO> customerDOList = customerMapper.selectBatchIds(pageList);
            if (CollectionUtil.isEmpty(customerDOList)) break;

            List<CustomerOperateLogCreateReqVO> customerOperateLogCreateReqVOList = customerDOList.stream().map(customerDO -> {
                CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                        .setOperator(loginUser == null ? null : loginUser.getId())
                        .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                        .setCustomerId(customerDO.getId())
                        .setNumber(customerDO.getNumber())
                        .setName(customerDO.getName())
                        .setOldCustomerService(customerDO.getCustomerService())
                        .setNewCustomerService(customerDO.getCustomerService())
                        .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                        .setNewEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                        .setOrderId(null)
                        .setOrderNo(null)
                        .setOperateType(CustomerOperateTypeEnum.UPDATE_CUSTOMER_TO_OLD_BY_CUSTOMER_SERVICE.getValue())
                        .setRemark("手动修改客户经理的所有成交客户为【老客户】");

                return customerOperateLogCreateReqVO;
            }).collect(Collectors.toList());

            customerOperateLogService.batchCreateOperateLog(customerOperateLogCreateReqVOList);
        }

    }

    @Override
    public void updateCustomerNewOrOld(Long customerId, Boolean isNew) {
        // 判断客户是否存在
        CustomerDO customerDO = customerMapper.selectById(customerId);
        if (customerDO == null) {
            throw exception(CUSTOMER_NOT_EXISTS);
        }

        if (Objects.equals(customerDO.getIsNew(), isNew)) {
            // throw exception(CUSTOMER_IS_NEW_OR_OLD_NO_CHANGE, isNew ? "新" : "老");
            // 修改此处逻辑，修改客户类型时，不用炮异常，直接不修改就可以了
            return;
        }

        // 更新
        customerMapper.updateCustomerNewOrOld(customerId, isNew);

        // 纪录操作日志
        LoginUser loginUser = SecurityFrameworkUtils.getLoginUser();
        CustomerOperateLogCreateReqVO customerOperateLogCreateReqVO = new CustomerOperateLogCreateReqVO()
                .setOperator(loginUser == null ? null : loginUser.getId())
                .setOperatorName(loginUser == null ? null : loginUser.getNickname())
                .setCustomerId(customerDO.getId())
                .setNumber(customerDO.getNumber())
                .setName(customerDO.getName())
                .setOldCustomerService(customerDO.getCustomerService())
                .setNewCustomerService(customerDO.getCustomerService())
                .setOldEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                .setNewEstimateEnterOpenSeaTime(customerDO.getEstimateEnterOpenSeaTime())
                .setOrderId(null)
                .setOrderNo(null)
                .setOperateType(CustomerOperateTypeEnum.UPDATE_CUSTOMER_NEW_OR_OLD.getValue())
                .setRemark("手动设置客户业绩类型为【" + (isNew ? "新客户" : "老客户") + "】");
        customerOperateLogService.createOperateLog(customerOperateLogCreateReqVO);
    }
}
