package cn.iocoder.yudao.module.customer.service.customerApproval;

import java.util.*;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.module.customer.vo.customerApproval.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerApproval.CustomerApprovalDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.customer.convert.customerApproval.CustomerApprovalConvert;
import cn.iocoder.yudao.module.customer.dal.mysql.customerApproval.CustomerApprovalMapper;

/**
 * 客户相关审核详情 Service 实现类
 *
 * @author 系统管理员
 */
@Service
@Validated
public class CustomerApprovalServiceImpl extends AbstractService<CustomerApprovalMapper, CustomerApprovalDO> implements CustomerApprovalService {

    @Resource
    private CustomerApprovalMapper customerApprovalMapper;

    @Override
    public Long createCustomerApproval(CustomerApprovalCreateReqVO createReqVO) {
        // 插入
        CustomerApprovalDO customerApproval = CustomerApprovalConvert.INSTANCE.convert(createReqVO);
        customerApprovalMapper.insert(customerApproval);
        // 返回
        return customerApproval.getApprovalId();
    }

    @Override
    public void updateCustomerApproval(CustomerApprovalUpdateReqVO updateReqVO) {
        // 更新
        CustomerApprovalDO updateObj = CustomerApprovalConvert.INSTANCE.convert(updateReqVO);
        customerApprovalMapper.updateById(updateObj);
    }

    @Override
    public void deleteCustomerApproval(Long id) {
        // 删除
        customerApprovalMapper.deleteById(id);
    }


    @Override
    public CustomerApprovalDO getCustomerApproval(Long id) {
        return customerApprovalMapper.selectById(id);
    }

    @Override
    public List<CustomerApprovalDO> getCustomerApprovalList(Collection<Long> ids) {
        return customerApprovalMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<CustomerApprovalDO> getCustomerApprovalPage(CustomerApprovalQueryVO query, PageVO page) {
        return customerApprovalMapper.selectPage(page, query);
    }

    @Override
    public List<CustomerApprovalDO> getCustomerApprovalList(CustomerApprovalQueryVO query) {
        return customerApprovalMapper.selectList(query);
    }

    @Override
    public CustomerApprovalDO getCustomerHandoverApprovalByCustomerId(Long customerId) {
        return customerApprovalMapper.getCustomerHandoverApprovalByCustomerId(customerId);
    }
}
