package cn.iocoder.yudao.module.customer.service.customerCredit;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.customer.vo.customerCredit.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerCredit.CustomerCreditDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 信用等级 Service 接口
 *
 * @author yanghao
 */
public interface CustomerCreditService extends IService<CustomerCreditDO> {

    /**
     * 创建信用等级
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCredit(@Valid CustomerCreditCreateReqVO createReqVO);

    /**
     * 更新信用等级
     * @param updateReqVO 更新信息
     */
    void updateCredit(@Valid CustomerCreditUpdateReqVO updateReqVO);

    /**
     * 删除信用等级
     * @param id 编号
     */
    void deleteCredit(Long id);

    /**
     * 获得信用等级
     * @param id 编号
     * @return 信用等级
     */
    CustomerCreditDO getCredit(Long id);

    /**
     * 获得信用等级列表
     * @param ids 编号
     * @return 信用等级列表
     */
    List<CustomerCreditDO> getCreditList(Collection<Long> ids);

    /**
     * 获得信用等级分页
     * @param page 分页查询
     * @param query 查询
     * @return 信用等级分页
     */
    PageResult<CustomerCreditDO> getCreditPage(CustomerCreditQueryVO query, PageVO page);

    /**
     * 获得信用等级列表, 用于 Excel 导出
     * @param query 查询
     * @return 信用等级列表
     */
    List<CustomerCreditDO> getCreditList(CustomerCreditQueryVO query);
}
