package cn.iocoder.yudao.module.customer.service.customerLevel;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.customer.vo.customerLevel.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevel.CustomerLevelDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 客户级别 Service 接口
 *
 * @author yanghao
 */
public interface CustomerLevelService extends IService<CustomerLevelDO> {

    /**
     * 创建客户级别
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createLevel(@Valid CustomerLevelCreateReqVO createReqVO);

    /**
     * 更新客户级别
     * @param updateReqVO 更新信息
     */
    void updateLevel(@Valid CustomerLevelUpdateReqVO updateReqVO);

    /**
     * 删除客户级别
     * @param id 编号
     */
    void deleteLevel(Long id);

    /**
     * 获得客户级别
     * @param id 编号
     * @return 客户级别
     */
    CustomerLevelDO getLevel(Long id);

    /**
     * 获得客户级别列表
     * @param ids 编号
     * @return 客户级别列表
     */
    List<CustomerLevelDO> getLevelList(Collection<Long> ids);

    /**
     * 获得客户级别分页
     * @param page 分页查询
     * @param query 查询
     * @return 客户级别分页
     */
    PageResult<CustomerLevelDO> getLevelPage(CustomerLevelQueryVO query, PageVO page);

    /**
     * 获得客户级别列表, 用于 Excel 导出
     * @param query 查询
     * @return 客户级别列表
     */
    List<CustomerLevelDO> getLevelList(CustomerLevelQueryVO query);
}
