package cn.iocoder.yudao.module.customer.service.customerLevelRule;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.customer.vo.customerLevelRule.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerLevelRule.CustomerLevelRuleDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 客户级别规则 Service 接口
 *
 * @author 系统管理员
 */
public interface CustomerLevelRuleService extends IService<CustomerLevelRuleDO> {

    /**
     * 创建客户级别规则
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createLevelRule(@Valid CustomerLevelRuleCreateReqVO createReqVO);

    /**
     * 更新客户级别规则
     * @param updateReqVO 更新信息
     */
    void updateLevelRule(@Valid CustomerLevelRuleUpdateReqVO updateReqVO);

    /**
     * 删除客户级别规则
     * @param id 编号
     */
    void deleteLevelRule(Long id);

    /**
     * 获得客户级别规则
     * @param id 编号
     * @return 客户级别规则
     */
    CustomerLevelRuleDO getLevelRule(Long id);

    /**
     * 获得客户级别规则列表
     * @param ids 编号
     * @return 客户级别规则列表
     */
    List<CustomerLevelRuleDO> getLevelRuleList(Collection<Long> ids);

    /**
     * 获得客户级别规则分页
     * @param page 分页查询
     * @param query 查询
     * @return 客户级别规则分页
     */
    PageResult<CustomerLevelRuleDO> getLevelRulePage(CustomerLevelRuleQueryVO query, PageVO page);

    /**
     * 获得客户级别规则列表, 用于 Excel 导出
     * @param query 查询
     * @return 客户级别规则列表
     */
    List<CustomerLevelRuleDO> getLevelRuleList(CustomerLevelRuleQueryVO query);
}
