package cn.iocoder.yudao.module.customer.service.customerOperateLog;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.customer.vo.customerOperateLog.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerOperateLog.CustomerOperateLogDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 客户操作日志 Service 接口
 *
 * @author yanghao
 */
public interface CustomerOperateLogService extends IService<CustomerOperateLogDO> {

    /**
     * 创建客户操作日志
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createOperateLog(@Valid CustomerOperateLogCreateReqVO createReqVO);

    /**
     * 批量插入日志
     * @param createReqVOList
     */
    void batchCreateOperateLog(List<CustomerOperateLogCreateReqVO> createReqVOList);

    /**
     * 更新客户操作日志
     * @param updateReqVO 更新信息
     */
    void updateOperateLog(@Valid CustomerOperateLogUpdateReqVO updateReqVO);

    /**
     * 删除客户操作日志
     * @param id 编号
     */
    void deleteOperateLog(Long id);

    /**
     * 获得客户操作日志
     * @param id 编号
     * @return 客户操作日志
     */
    CustomerOperateLogDO getOperateLog(Long id);

    /**
     * 获得客户操作日志列表
     * @param ids 编号
     * @return 客户操作日志列表
     */
    List<CustomerOperateLogDO> getOperateLogList(Collection<Long> ids);

    /**
     * 获得客户操作日志分页
     * @param page 分页查询
     * @param query 查询
     * @return 客户操作日志分页
     */
    PageResult<CustomerOperateLogDO> getOperateLogPage(CustomerOperateLogQueryVO query, PageVO page);

    /**
     * 获得客户操作日志列表, 用于 Excel 导出
     * @param query 查询
     * @return 客户操作日志列表
     */
    List<CustomerOperateLogDO> getOperateLogList(CustomerOperateLogQueryVO query);
}
