package cn.iocoder.yudao.module.customer.service.customerPublicCatchLog;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.customer.vo.customerPublicCatchLog.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerPublicCatchLog.CustomerPublicCatchLogDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 公海客户捞取日志 Service 接口
 *
 * @author yanghao
 */
public interface CustomerPublicCatchLogService extends IService<CustomerPublicCatchLogDO> {

    /**
     * 创建公海客户捞取日志
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createPublicCatchLog(@Valid CustomerPublicCatchLogCreateReqVO createReqVO);

    /**
     * 更新公海客户捞取日志
     * @param updateReqVO 更新信息
     */
    void updatePublicCatchLog(@Valid CustomerPublicCatchLogUpdateReqVO updateReqVO);

    /**
     * 删除公海客户捞取日志
     * @param id 编号
     */
    void deletePublicCatchLog(Long id);

    /**
     * 获得公海客户捞取日志
     * @param id 编号
     * @return 公海客户捞取日志
     */
    CustomerPublicCatchLogDO getPublicCatchLog(Long id);

    /**
     * 获得公海客户捞取日志列表
     * @param ids 编号
     * @return 公海客户捞取日志列表
     */
    List<CustomerPublicCatchLogDO> getPublicCatchLogList(Collection<Long> ids);

    /**
     * 获得公海客户捞取日志分页
     * @param page 分页查询
     * @param query 查询
     * @return 公海客户捞取日志分页
     */
    PageResult<CustomerPublicCatchLogDO> getPublicCatchLogPage(CustomerPublicCatchLogQueryVO query, PageVO page);

    /**
     * 获得公海客户捞取日志列表, 用于 Excel 导出
     * @param query 查询
     * @return 公海客户捞取日志列表
     */
    List<CustomerPublicCatchLogDO> getPublicCatchLogList(CustomerPublicCatchLogQueryVO query);
}
