package cn.iocoder.yudao.module.customer.service.indirectCustomerContacts;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.customer.vo.indirectCustomerContacts.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomerContacts.IndirectCustomerContactsDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 间接客户联系人 Service 接口
 *
 * @author yanghao
 */
public interface IndirectCustomerContactsService extends IService<IndirectCustomerContactsDO> {

    /**
     * 创建间接客户联系人
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createIndirectCustomerContacts(@Valid IndirectCustomerContactsCreateReqVO createReqVO);

    /**
     * 更新间接客户联系人
     * @param updateReqVO 更新信息
     */
    void updateIndirectCustomerContacts(@Valid IndirectCustomerContactsUpdateReqVO updateReqVO);

    /**
     * 删除间接客户联系人
     * @param id 编号
     */
    void deleteIndirectCustomerContacts(Long id);

    /**
     * 获得间接客户联系人
     * @param id 编号
     * @return 间接客户联系人
     */
    IndirectCustomerContactsDO getIndirectCustomerContacts(Long id);

    /**
     * 获得间接客户联系人列表
     * @param ids 编号
     * @return 间接客户联系人列表
     */
    List<IndirectCustomerContactsDO> getIndirectCustomerContactsList(Collection<Long> ids);

    /**
     * 获得间接客户联系人分页
     * @param page 分页查询
     * @param query 查询
     * @return 间接客户联系人分页
     */
    PageResult<IndirectCustomerContactsDO> getIndirectCustomerContactsPage(IndirectCustomerContactsQueryVO query, PageVO page);

    /**
     * 获得间接客户联系人列表, 用于 Excel 导出
     * @param query 查询
     * @return 间接客户联系人列表
     */
    List<IndirectCustomerContactsDO> getIndirectCustomerContactsList(IndirectCustomerContactsQueryVO query);
}
