package cn.iocoder.yudao.module.customer.task;

import cn.iocoder.yudao.framework.quartz.core.handler.JobHandler;
import cn.iocoder.yudao.framework.tenant.core.job.TenantJob;
import cn.iocoder.yudao.module.customer.service.customer.CustomerService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * 将超时未接收的客户转到待分配
 */
@Component
@TenantJob
@Slf4j
public class CustomerMoveWaitConfirmUserToWaitAssigned implements JobHandler {

    @Resource
    private CustomerService customerService;

    @Override
    public String execute(String param) throws Exception {
        if (StringUtils.isBlank(param)){
            param = "24";
        }
        customerService.moveWaitConfirmUserToWaitAssigned(Integer.valueOf(param));

        param = "72";
        customerService.moveWebConsigneeCustomerToWaitAssigned(Integer.valueOf(param));
        return "";
    }
}
