package cn.iocoder.yudao.module.customer.vo.customer.commission;

import lombok.*;
import io.swagger.annotations.*;
import javax.validation.constraints.*;

/**
* 客户佣金类型 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class CustomerCommissionBaseVO {

    @ApiModelProperty(value = "客户id", required = true)
    @NotNull(message = "客户id不能为空")
    private Long customerId;

    @ApiModelProperty(value = "佣金类型", required = true)
    @NotNull(message = "佣金类型不能为空")
    private Integer type;

    @ApiModelProperty(value = "运输方式")
    private Integer transportId;

    @ApiModelProperty(value = "始发地id")
    private Long departureId;

    @ApiModelProperty(value = "目的地id")
    private Long objectiveId;

    @ApiModelProperty(value = "报关类别：我司全代：1，自单代报：2，混合报关：3")
    private Integer customsType;

    @ApiModelProperty(value = "产品备案")
    private Integer approval;

    @ApiModelProperty(value = "暗佣类型 1产品2达标", required = true)
    @NotNull(message = "暗佣类型 1产品2达标不能为空")
    private Integer darkReturnType;

}
