package cn.iocoder.yudao.module.customer.vo.customer.commission;

import lombok.*;

import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;


/**
 * 客户佣金类型 Excel VO
 *
 * @author yanghao
 */
@Data
public class CustomerCommissionExcelVO {

    @ExcelProperty("客户id")
    private Long customerId;

    @ExcelProperty(value = "佣金类型", converter = DictConvert.class)
    @DictFormat("commission_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer type;

    @ExcelProperty(value = "运输方式", converter = DictConvert.class)
    @DictFormat("transport_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer transportId;

    @ExcelProperty("始发地id")
    private Long departureId;

    @ExcelProperty("目的地id")
    private Long objectiveId;

    @ExcelProperty(value = "报关类别：我司全代：1，自单代报：2，混合报关：3", converter = DictConvert.class)
    @DictFormat("customs_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer customsType;

    @ExcelProperty(value = "产品备案", converter = DictConvert.class)
    @DictFormat("commission_product_approval") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer approval;

    @ExcelProperty(value = "暗佣类型 1产品2达标", converter = DictConvert.class)
    @DictFormat("commission_dark_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer darkReturnType;


    @ExcelProperty("佣金编码")
    private Long id;

    @ExcelProperty("客户名称")
    private String customerName;

    @ExcelProperty("主联系人")
    private String defaultContactName;

    @ExcelProperty("主联系电话区号")
    private String defaultContactPhoneAreaCode;

    @ExcelProperty("主联系电话")
    private String defaultContactPhone;
    

}
