package cn.iocoder.yudao.module.customer.vo.customer.commission;

import lombok.*;

import java.math.BigDecimal;

import io.swagger.annotations.*;

/**
* 客户佣金详情 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class CustomerCommissionInfoBaseVO {

    @ApiModelProperty(value = "佣金表id 新增时可不传", required = true)
    private Long commissionId;

    @ApiModelProperty(value = "暗佣 产品类型")
    private Long productType;

    @ApiModelProperty(value = "暗佣 产品属性")
    private Long productAttr;


    @ApiModelProperty(value = "暗佣 佣金")
    private BigDecimal darkCommission;

    @ApiModelProperty(value = "暗佣 货币")
    private Integer darkCurrency;

    @ApiModelProperty(value = "暗佣 单位")
    private Integer darkUnit;



    @ApiModelProperty(value = "暗佣+明佣 上调金额")
    private BigDecimal darkAdjustCommission;

    @ApiModelProperty(value = "暗佣+明佣 上调对应的货币")
    private Integer darkAdjustCurrency;

    @ApiModelProperty(value = "暗佣+明佣 上调对应的单位")
    private Integer darkAdjustUnit;



    @ApiModelProperty(value = "暗佣-满减金额")
    private BigDecimal amount;

    @ApiModelProperty(value = "暗佣-满减金额对应货币")
    private Integer amountCurrency;

    @ApiModelProperty(value = "暗佣-满减金额对应单位")
    private Integer amountUnit;




    @ApiModelProperty(value = "暗佣-满之后返还金额 / 明佣返的金额")
    private BigDecimal refund;

    @ApiModelProperty(value = "暗佣-满之后返还金额的货币 / 明佣返的金额的货币")
    private Integer refundCurrency;

    @ApiModelProperty(value = "暗佣-满之后返还金额的单位 / 明佣返的金额的单位")
    private Integer refundUnit;

}
