package cn.iocoder.yudao.module.customer.vo.customer.commission;

import lombok.*;

import java.math.BigDecimal;
import java.util.*;

import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;


/**
 * 客户佣金详情 Excel VO
 *
 * @author yanghao
 */
@Data
public class CustomerCommissionInfoExcelVO {

    @ExcelProperty("佣金表id")
    private Long commissionId;

    @ExcelProperty("产品类型")
    private Long productType;

    @ExcelProperty("产品属性")
    private Long productAttr;

    @ExcelProperty("暗佣佣金")
    private BigDecimal darkCommission;

    @ExcelProperty(value = "暗佣货币", converter = DictConvert.class)
    private Integer darkCurrency;

    @ExcelProperty(value = "暗佣单位", converter = DictConvert.class)
    @DictFormat("commission_unit") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer darkUnit;

    @ExcelProperty("暗佣上调")
    private BigDecimal darkAdjustCommission;

    @ExcelProperty(value = "暗佣货币上调", converter = DictConvert.class)
    private Integer darkAdjustCurrency;

    @ExcelProperty(value = "暗佣单位上调", converter = DictConvert.class)
    @DictFormat("commission_unit") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer darkAdjustUnit;

    @ExcelProperty("满减")
    private BigDecimal amount;

    @ExcelProperty(value = "满的货多少币", converter = DictConvert.class)
    private Integer amountCurrency;

    @ExcelProperty(value = "满多少的单位", converter = DictConvert.class)
    @DictFormat("commission_unit") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer amountUnit;

    @ExcelProperty(value = "返佣金的货币", converter = DictConvert.class)
    private Integer refundCurrency;

    @ExcelProperty("满返")
    private BigDecimal refund;

    @ExcelProperty(value = "返佣金的单位", converter = DictConvert.class)
    @DictFormat("commission_unit") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer refundUnit;

    @ExcelProperty("创建时间")
    private Date createTime;

}
