package cn.iocoder.yudao.module.customer.vo.customer.commission;

import lombok.*;

import java.math.BigDecimal;
import java.util.*;
import io.swagger.annotations.*;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 客户佣金详情分页 Request VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerCommissionInfoPageReqVO extends PageParam {

    @ApiModelProperty(value = "佣金表id")
    private Long commissionId;

    @ApiModelProperty(value = "产品类型")
    private Long productType;

    @ApiModelProperty(value = "产品属性")
    private Long productAttr;

    @ApiModelProperty(value = "暗佣佣金")
    private BigDecimal darkCommission;

    @ApiModelProperty(value = "暗佣货币")
    private Integer darkCurrency;

    @ApiModelProperty(value = "暗佣单位")
    private Integer darkUnit;

    @ApiModelProperty(value = "暗佣上调")
    private BigDecimal darkAdjustCommission;

    @ApiModelProperty(value = "暗佣货币上调")
    private Integer darkAdjustCurrency;

    @ApiModelProperty(value = "暗佣单位上调")
    private Integer darkAdjustUnit;

    @ApiModelProperty(value = "满减")
    private BigDecimal amount;

    @ApiModelProperty(value = "满的货多少币")
    private Integer amountCurrency;

    @ApiModelProperty(value = "满多少的单位")
    private Integer amountUnit;

    @ApiModelProperty(value = "返佣金的货币")
    private Integer refundCurrency;

    @ApiModelProperty(value = "满返")
    private BigDecimal refund;

    @ApiModelProperty(value = "返佣金的单位")
    private Integer refundUnit;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
