package cn.iocoder.yudao.module.customer.vo.customer.commission;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import javax.validation.constraints.NotNull;
import java.util.List;

@ApiModel("管理后台 - 客户暗佣查询 Request VO")
@Data
@EqualsAndHashCode
@ToString
public class CustomerDarkReturnCommissionQueryReqVO  {



    @ApiModelProperty(value = "客户id", required = true)
    @NotNull(message = "客户id不能为空")
    private Long customerId;

    @ApiModelProperty(value = "佣金类型 暗佣为2", required = true)
    // @NotNull(message = "佣金类型不能为空")
    private Integer type = 2;

    @ApiModelProperty(value = "运输方式")
    private Integer transportId;

    @ApiModelProperty(value = "始发地id")
    private Long departureId;

    @ApiModelProperty(value = "目的地id")
    private Long objectiveId;

    @ApiModelProperty(value = "报关类别：我司全代：1，自单代报：2，混合报关：3")
    private Integer customsType;

    @ApiModelProperty(value = "产品备案")
    private Integer approval;

    /**
     * 暗佣类型 1产品2达标不能为空
     */
    private Integer darkReturnType = 1;



    @ApiModelProperty(value = "暗佣 产品类型")
    private Long productType;

    @ApiModelProperty(value = "暗佣 产品属性")
    private List<Long> productAttr;

    //
    // @ApiModelProperty(value = "暗佣 佣金")
    // private BigDecimal darkCommission;

    @ApiModelProperty(value = "暗佣 货币")
    private Integer darkCurrency;

    @ApiModelProperty(value = "暗佣 单位")
    private Integer darkUnit;


}
