package cn.iocoder.yudao.module.customer.vo.customer.complaint;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户投诉 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class CustomerComplaintBaseVO {

    @ApiModelProperty(value = "客户id")
    private Long customerId;

    @ApiModelProperty(value = "投诉编号")
    private String code;

    @ApiModelProperty(value = "app会员id")
    private Long memberUserId;

    @ApiModelProperty(value = "投诉类型")
    private Integer type;

    @ApiModelProperty(value = "订单号")
    private String orderId;

    @ApiModelProperty(value = "提单号")
    private String ladingbillId;

    @ApiModelProperty(value = "投诉内容")
    private String content;

    @ApiModelProperty(value = "查明原因")
    private String ascertainReason;

    @ApiModelProperty(value = "处理方案")
    private String plan;

    @ApiModelProperty(value = "处理结果")
    private String result;

    @ApiModelProperty(value = "赔付金额")
    private java.math.BigDecimal indemnity;

    @ApiModelProperty(value = "赔付货币单位")
    private Integer currencyUnit;

    @ApiModelProperty(value = "处理时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date handleAt;

    @ApiModelProperty(value = "取消原因")
    private String cancelReason;

    @ApiModelProperty(value = "标题")
    private String title;

    @ApiModelProperty(value = "联系人")
    private String contacter;

    @ApiModelProperty(value = "联系人电话")
    private String contactPhone;

    @ApiModelProperty(value = "登记客服id")
    private Long adminId;

    @ApiModelProperty(value = "处理状态")
    private Integer status;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "投诉时间")
    private Date createTime;

}
