package cn.iocoder.yudao.module.customer.vo.customer.complaint;

import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;


/**
 * 客户投诉 Excel VO
 *
 * @author yanghao
 */
@Data
public class CustomerComplaintExcelVO {


    @ExcelProperty("投诉编号")
    private String code;

    @ExcelProperty(value = "登记客服")
    private String adminNickname;


    @ExcelProperty("投诉时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date createTime;

    @ExcelProperty("客户名称")
    private String customerName;

    @ExcelProperty(value = "投诉类型", converter = DictConvert.class)
    @DictFormat("customer_complaint_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer type;

    @ExcelProperty("订单号")
    private String orderId;

    @ExcelProperty("提单号")
    private String ladingbillId;

    @ExcelProperty("投诉内容")
    private String content;

    @ExcelProperty(value = "处理状态", converter = DictConvert.class)
    @DictFormat("customer_complaint_status") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer status;


    @ExcelProperty(value = "处理时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date handleAt;

    @ExcelProperty(value = "查明原因")
    private String ascertainReason;

    @ExcelProperty(value = "处理方案")
    private String plan;

    @ExcelProperty(value = "处理结果")
    private String result;

    @ExcelProperty(value = "赔付金额")
    private java.math.BigDecimal indemnity;

    @ExcelProperty(value = "赔付货币单位")
    private String currencyUnitName;

}
