package cn.iocoder.yudao.module.customer.vo.customer.complaint;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel(value = "管理后台 - 客户投诉 Excel 导出 Request VO", description = "参数和 CustomerComplaintPageReqVO 是一致的")
@Data
public class CustomerComplaintExportReqVO {

    @ApiModelProperty(value = "后台客户id")
    private Long customerId;

    @ApiModelProperty(value = "app会员id")
    private Long memberUserId;

    @ApiModelProperty(value = "投诉类型")
    private Integer type;

    @ApiModelProperty(value = "订单号")
    private String orderId;

    @ApiModelProperty(value = "提单号")
    private String ladingbillId;

    @ApiModelProperty(value = "处理状态")
    private Integer status;

    @ApiModelProperty(value = "管理员id")
    private Long adminId;

    @ApiModelProperty(value = "投诉编号")
    private String code;

    @ApiModelProperty(value = "创建人")
    private Long creator;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
