package cn.iocoder.yudao.module.customer.vo.customer.customerContacts;

import lombok.*;
import io.swagger.annotations.*;
import javax.validation.constraints.*;

/**
* 客户联系人 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class CustomerContactsBaseVO {

    @ApiModelProperty(value = "客户id，新增客户时可为空")
    private Long customerId;

    @ApiModelProperty(value = "部门")
    private String department;

    @ApiModelProperty(value = "职位")
    private String position;

    @ApiModelProperty(value = "联系人", required = true)
    @NotNull(message = "联系人不能为空")
    private String name;

    @ApiModelProperty(value = "联系人英文名称")
    private String nameEn;

    @ApiModelProperty(value = "社交方式")
    private Integer social;

    @ApiModelProperty(value = "社交软件号码")
    private String socialNumber;

    @ApiModelProperty(value = "电子邮箱")
    private String email;

    @ApiModelProperty(value = "默认联系人：1为默认 0为非默认")
    private Integer isDefault;

    @ApiModelProperty(value = "关联账户id")
    private Long userid;

    @ApiModelProperty(value = "关联账户名")
    private String username;

    @ApiModelProperty(value = "区号", required = true)
    @NotNull(message = "区号不能为空")
    @Pattern(regexp = "^[0-9]+$", message = "{order.area.code}")
    private String areaCode;

    @ApiModelProperty(value = "手机号码(不带任何区号)", required = true)
    @NotNull(message = "手机号码(不带任何区号)不能为空")
    private String phoneNew;

}
