package cn.iocoder.yudao.module.customer.vo.customer.customerContacts;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel(value = "管理后台 - 客户联系人 Excel 导出 Request VO", description = "参数和 CustomerContactsPageReqVO 是一致的")
@Data
public class CustomerContactsExportReqVO {

    @ApiModelProperty(value = "关联账户名")
    private String username;

    @ApiModelProperty(value = "区号")
    private String areaCode;

    @ApiModelProperty(value = "手机号码(不带任何区号)")
    private String phoneNew;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
