package cn.iocoder.yudao.module.customer.vo.customer.follow;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
 * 客户投诉跟进 Base VO，提供给添加、修改、详细的子 VO 使用
 * 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
 */
@Data
public class CustomerFollowBaseVO {

    @ApiModelProperty(value = "客户ID")
    @NotNull(message = "客户ID不能为空")
    private Long customerId;

    @ApiModelProperty(value = "跟进业务数据ID，回访类型的就是客户id，投诉跟进类型的就是投诉id", required = true)
    @NotNull(message = "跟进业务数据ID不能为空")
    private Long bizId;

    /**
     * 业务编号
     */
    @ApiModelProperty(value = "业务编号")
    private String bizNo;

    @ApiModelProperty(value = "跟进类型，参见字典 customer_follow_type")
    private Integer followType;

    @ApiModelProperty(value = "跟进时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date followTime;

    @ApiModelProperty(value = "联系人")
    private String contactName;

    @ApiModelProperty(value = "跟进方式，参见字典 customer_follow_method")
    private Integer followMethod;

    @ApiModelProperty(value = "跟进业务员")
    private Long followUserId;

    @ApiModelProperty(value = "客户反馈")
    private String feedback;

    @ApiModelProperty(value = "处理结果")
    private String result;

    @ApiModelProperty(value = "跟进业务员(客户经理)名称")
    private String followUserName;

}
