package cn.iocoder.yudao.module.customer.vo.customer.follow;

import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import java.util.*;

import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;


/**
 * 客户投诉跟进 Excel VO
 *
 * @author yanghao
 */
@Data
public class CustomerFollowExcelVO {

    @ExcelProperty("跟进业务数据ID，回访类型的就是客户id，投诉跟进类型的就是投诉id")
    private Long bizId;

    /**
     * 业务编号
     */
    @ExcelProperty(value = "业务编号")
    private String bizNo;

    @ExcelProperty(value = "跟进类型", converter = DictConvert.class)
    @DictFormat("customer_follow_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer followType;

    @ExcelProperty("跟进时间")
    private Date followTime;

    @ExcelProperty("联系人")
    private String contactName;

    @ExcelProperty(value = "跟进方式", converter = DictConvert.class)
    @DictFormat("customer_follow_method") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer followMethod;

    @ExcelProperty("跟进业务员")
    private Long followUserId;

    @ExcelProperty("客户反馈")
    private String feedback;

    @ExcelProperty("处理结果")
    private String result;

    @ExcelProperty("管理员id")
    private Long adminId;

    @ExcelProperty("创建时间")
    private Date createTime;

}
