package cn.iocoder.yudao.module.customer.vo.customer.follow;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel(value = "管理后台 - 客户投诉跟进 Excel 导出 Request VO", description = "参数和 CustomerFollowPageReqVO 是一致的")
@Data
public class CustomerFollowExportReqVO {

    @ApiModelProperty(value = "跟进业务数据ID，回访类型的就是客户id，投诉跟进类型的就是投诉id")
    private Long bizId;

    @ApiModelProperty(value = "业务编号")
    private String bizNo;

    @ApiModelProperty(value = "跟进类型 参见字典customer_follow_type")
    private Integer followType;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
