package cn.iocoder.yudao.module.customer.vo.customer.follow;

import cn.iocoder.yudao.framework.common.pojo.PageParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 客户投诉跟进分页 Request VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CustomerFollowPageReqVO extends PageParam {

    @ApiModelProperty(value = "客户ID")
    private Long customerId;

    @ApiModelProperty(value = "跟进业务数据ID，回访类型的就是客户id，投诉跟进类型的就是投诉id, 商务洽谈就是报价单ID")
    private Long bizId;

    @ApiModelProperty(value = "业务编号")
    private String bizNo;

    @ApiModelProperty(value = "跟进类型 参见字典customer_follow_type 查询参数可以多个使用','分割")
    private String followType;

    //@ApiModelProperty(value = "联系人")
    //private String contactName;

    @ApiModelProperty(value = "跟进业务员")
    private Long followUserId;

    //@ApiModelProperty(value = "管理员id")
    //private Long adminId;
    //
    //@DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    //@ApiModelProperty(value = "开始跟进时间")
    //private Date beginFollowTime;
    //
    //@DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    //@ApiModelProperty(value = "结束跟进时间")
    //private Date endFollowTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;



}
