package cn.iocoder.yudao.module.customer.vo.customer.line;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;

/**
* 客户线路 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class CustomerLineBaseVO {


    @ApiModelProperty(value = "客户ID")
    private Long customerId;

    @ApiModelProperty(value = "始发地ID")
    @NotNull(message = "始发地ID不能为空")
    private Long departureId;

    @ApiModelProperty(value = "目的地ID列表", example = "1,2,3,4")
    @NotNull(message = "目的地ID列表不能为空")
    private String objectiveIds;

    @ApiModelProperty(value = "重泡货类型，字典zhong_pao_type", required = true)
    @NotNull(message = "重泡货类型不能为空")
    private Integer zhongPaoType;

}
