package cn.iocoder.yudao.module.customer.vo.customer.line;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel(value = "管理后台 - 客户线路 Excel 导出 Request VO", description = "参数和 CustomerLinePageReqVO 是一致的")
@Data
public class CustomerLineExportReqVO {

    @ApiModelProperty(value = "客户ID")
    private Long customerId;

    @ApiModelProperty(value = "始发地ID")
    private Long departureId;

    @ApiModelProperty(value = "目的地ID列表", example = "1,2,3,4")
    private String objectiveIds;

    @ApiModelProperty(value = "重泡货类型，字典zhong_pao_type", example = "1")
    private Integer zhongPaoType;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
