package cn.iocoder.yudao.module.customer.vo.customer.vo;

import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.CustomerIsNewConvert;
import cn.iocoder.yudao.framework.excel.convert.DictMultiConvert;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;

import java.util.Date;


/**
 * 客户 Excel VO
 *
 * @author yanghao
 */
@Data
public class CustomerExcelVO {
    @ExcelProperty("客户编号")
    private String number;

    @ExcelProperty("客户名称")
    private String name;

    @ExcelProperty(value = "客户等级", converter = DictConvert.class)
    @DictFormat("customer_level")
    private Integer level;

    @ExcelProperty(value = "国家")
    private String countryName;

    @ExcelProperty(value = "跟进客服")
    private String customerServiceName;

    @ExcelProperty(value = "客户状态", converter = DictConvert.class)
    @DictFormat("customer_status")
    private Integer status;

    @ExcelProperty(value = "主联系人")
    private String defaultContactName;

    @ExcelProperty(value = "主联系人电话")
    private String defaultContactPhone;


    @ExcelProperty("主联系人邮箱")
    private String defaultEmail;

    @ExcelProperty(value = "出货渠道", converter = DictMultiConvert.class)
    @DictFormat(value = "customer_transport_type")
    private String transportType;

    @ExcelProperty(value = "资源类型", converter = DictConvert.class)
    @DictFormat("customer_resource_type")
    private Integer resourceType;

    @ExcelProperty(value = "新老客户", converter = CustomerIsNewConvert.class)
    private Boolean isNew;

    @ExcelProperty(value = "公司名称")
    private String company;

    @ExcelProperty(value = "联系地址")
    private String address;


    @ExcelProperty("创建时间")
    private Date createTime;

    @ExcelProperty("备注")
    private String remarks;



}
