package cn.iocoder.yudao.module.customer.vo.customer.vo;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel(value = "管理后台 - 客户 Excel 导出 Request VO", description = "参数和 CustomerPageReqVO 是一致的")
@Data
public class CustomerExportReqVO {

    @ApiModelProperty(value = "客户编号")
    private String number;

    @ApiModelProperty(value = "客户名称")
    private String name;

    @ApiModelProperty(value = "客户等级")
    private Integer level;

    @ApiModelProperty(value = "客户来源")
    private Integer source;

    @ApiModelProperty(value = "客户类别")
    private String type;

    @ApiModelProperty(value = "客户货运类型", notes = "参见customer_transport_type数据字典")
    private String transportType;

    @ApiModelProperty(value = "客户资源类型", notes = "参见customer_resource_type数据字典")
    private Integer resourceType;

    @ApiModelProperty(value = "跟进客服")
    private Long customerService;

    @ApiModelProperty(value = "客户状态")
    private Integer status;

    @ApiModelProperty(value = "部门")
    private String department;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;



    @ApiModelProperty(value = "主联系人")
    private String defaultContactName;

    @ApiModelProperty(value = "主联系电话")
    private String defaultContactPhone;



    @ApiModelProperty(value = "信用等级")
    private Integer creditLevel;

    @ApiModelProperty(value = "国家")
    private Integer country;

    @ApiModelProperty(value = "是否在公海")
    private Boolean isInOpenSea;

    @ApiModelProperty(value = "是否潜在客户")
    private Boolean isPotential;



    //api不显示此3个字段
    //是否接收，后台使用
    @JsonIgnore
    private Boolean isCustomerServiceConfirmed;

    //因接口公用方法新增：24小时内数据查询条件标识
    private String flag4QueryCondition;

    private Integer marketType;

}
