package cn.iocoder.yudao.module.customer.vo.customer.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

@ApiModel("管理后台 - 客户移交 Request VO")
@Data
@EqualsAndHashCode
@ToString
public class CustomerHandOverReqVO {

    @ApiModelProperty(value = "客户ID列表", required = true)
    @NotEmpty(message = "客户ID列表不能为空")
    private List<Long> customerIdList;

    @ApiModelProperty(value = "跟进客服", required = true)
    @NotNull(message = "跟进客服不能为空")
    private Long customerServiceId;

    @ApiModelProperty(value = "申请原因")
    private String reason;

}
