package cn.iocoder.yudao.module.customer.vo.customerAirLog;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户空运日志 Response VO
* @author 江楠
*/
@Data
@ApiModel("管理后台 - 客户空运日志 Response VO")
public class CustomerAirLogBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("客户id")
    @ApiModelProperty(value = "客户id", required = true)
    private Long customerId;

    @ExcelProperty("客户编号")
    @ApiModelProperty(value = "客户编号")
    private String customerNumber;

    @ExcelProperty("是否空运客户")
    @ApiModelProperty(value = "是否空运客户")
    private Boolean isAir;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
