package cn.iocoder.yudao.module.customer.vo.customerApproval;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户相关审核详情 Response VO
* @author 系统管理员
*/
@Data
@ApiModel("管理后台 - 客户相关审核详情 Response VO")
public class CustomerApprovalBackVO {

    @ExcelProperty("主键ID")
    @ApiModelProperty(value = "主键ID", required = true)
    private Long approvalId;

    @ExcelProperty("客户ID")
    @ApiModelProperty(value = "客户ID", required = true)
    private Long customerId;

    @ExcelProperty("流程表单实例ID")
    @ApiModelProperty(value = "流程表单实例ID")
    private String formId;

    @ExcelProperty("审批类型1 延迟进入公海")
    @ApiModelProperty(value = "审批类型1 延迟进入公海")
    private Integer type;

    @ExcelProperty("跟进业务员")
    @ApiModelProperty(value = "跟进业务员")
    private String followUpSalesmanId;

    @ExcelProperty("审核内容详情")
    @ApiModelProperty(value = "审核内容详情")
    private String details;

    @ExcelProperty("状态：1 处理中 2 通过 3 不通过 4 取消")
    @ApiModelProperty(value = "状态：1 处理中 2 通过 3 不通过 4 取消")
    private Integer status;

    @ExcelProperty("处理结果")
    @ApiModelProperty(value = "处理结果")
    private String processingResults;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ExcelProperty("结束人")
    @ApiModelProperty(value = "结束人")
    private String finishBy;

    @ExcelProperty("结束时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束时间")
    private Date finishTime;

}
