package cn.iocoder.yudao.module.customer.vo.customerBank;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户银行账户 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 客户银行账户 Response VO")
public class CustomerBankBackVO {

    @ExcelProperty("")
    @ApiModelProperty(value = "", required = true)
    private Long id;

    @ExcelProperty("客户id")
    @ApiModelProperty(value = "客户id", required = true)
    private Long customerId;

    @ExcelProperty("银行账户")
    @ApiModelProperty(value = "银行账户", required = true)
    private String accountName;

    @ExcelProperty("币种")
    @ApiModelProperty(value = "币种", required = true)
    private String currency;

    @ExcelProperty("银行名称")
    @ApiModelProperty(value = "银行名称", required = true)
    private String bankName;

    @ExcelProperty("银行账户")
    @ApiModelProperty(value = "银行账户", required = true)
    private String bankAccount;

    @ExcelProperty("银行代码")
    @ApiModelProperty(value = "银行代码")
    private String bankCode;

    @ExcelProperty("账户类型")
    @ApiModelProperty(value = "账户类型")
    private String accountType;

    @ExcelProperty("银行地址")
    @ApiModelProperty(value = "银行地址")
    private String bankAddress;

    @ExcelProperty("是否展示 默认为展示")
    @ApiModelProperty(value = "是否展示 默认为展示")
    private Integer status;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
