package cn.iocoder.yudao.module.customer.vo.customerCreditRule;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 信用规则 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 信用规则 Response VO")
public class CustomerCreditRuleBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("规则名称")
    @ApiModelProperty(value = "规则名称", required = true)
    private String name;

    @ExcelProperty("规则名称En")
    @ApiModelProperty(value = "规则名称En", required = true)
    private String nameEn;

    @ExcelProperty(value = "规则分类", converter = DictConvert.class)
    @DictFormat("customer_credit_rule_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    @ApiModelProperty(value = "规则分类", required = true)
    private Integer type;

    @ExcelProperty("规则得分")
    @ApiModelProperty(value = "规则得分", required = true)
    private Integer score;

    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String remark;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
