package cn.iocoder.yudao.module.customer.vo.customerDetail;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 客户基本信息客诉 Response VO")
@Data
public class CustomerComplaintBackVO {

    @ApiModelProperty(value = "id")
    private Long id;

    @ApiModelProperty(value = "客诉单号")
    private String code;

    @ApiModelProperty(value = "投诉类型")
    private Integer type;

    @ApiModelProperty(value = "投诉时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date createTime;

    @ApiModelProperty(value = "提单号")
    private String ladingbillId;

    @ApiModelProperty(value = "投诉内容")
    private String content;

    @ApiModelProperty(value = "状态")
    private Integer status;

    @ApiModelProperty(value = "查明原因")
    private String ascertainReason;

    @ApiModelProperty(value = "处理时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date handleAt;

    @ApiModelProperty(value = "处理结果")
    private String result;

    @ApiModelProperty(value = "赔付金额")
    private java.math.BigDecimal indemnity;

    @ApiModelProperty(value = "赔付货币单位")
    private Integer currencyUnit;

}
