package cn.iocoder.yudao.module.customer.vo.customerDetail;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 客户基本信息跟进 Response VO")
@Data
public class CustomerFollowBackVo {
    @ApiModelProperty(value = "客诉ID")
    private Long id;

    @ApiModelProperty(value = "业务ID")
    private Long bizId;

    @ApiModelProperty(value = "业务编号")
    private String bizNo;

    @ApiModelProperty(value = "跟进类型，参见字典 customer_follow_type")
    private Integer followType;

    @ApiModelProperty(value = "跟进时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date followTime;

    @ApiModelProperty(value = "联系人")
    private String contactName;

    @ApiModelProperty(value = "跟进方式，参见字典 customer_follow_method")
    private Integer followMethod;

    @ApiModelProperty(value = "跟进业务员名称")
    private String followUserName;

    @ApiModelProperty(value = "客户反馈")
    private String feedback;

    @ApiModelProperty(value = "处理结果")
    private String result;

}
