package cn.iocoder.yudao.module.customer.vo.customerDetail;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 客户基本信息客户报价 Response VO")
@Data
public class CustomerOfferBackVo {
    @ApiModelProperty(value = "报价单ID")
    private String offerId;

    @ApiModelProperty(value = "报价单号")
    private String number;

    @ApiModelProperty(value = "订单号")
    private String orderNo;

    @ApiModelProperty(value = "客户名称")
    private String consignorName;


    @ApiModelProperty(value = "目的地中文")
    private String objectiveName;

    @ApiModelProperty(value = "目的地英文")
    private String objectiveNameEn;

    @ApiModelProperty(value = "取消报价：0，特价审批中：1，草稿：2, 需求确认：3，赢单：4，输单：5，报价完成：6 跟进中：7")
    private Integer status;

    @ApiModelProperty(value = "业务员名称-客户经理")
    private String businessManagerName;

    @ApiModelProperty(value = "预计结束时间")
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    private Date stopTime;


    @ApiModelProperty(value = "创建时间", required = true)
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date createTime;

    @ExcelProperty("价格有效期开始")
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    private Date startTime;
    @ExcelProperty("价格有效期结束")
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    private Date endTime;
    @ExcelProperty("重要程度")
    private Integer importance;




    @ApiModelProperty(value = "联系人名称")
    private String relationName;
    @ApiModelProperty(value = "联系人区号")
    private String relationAreaCode;
    @ApiModelProperty(value = "联系人手机号")
    private String relationPhone;


    // 线路相关
    @ExcelProperty("始发仓库id")
    private Long startWarehouseId;
    @ExcelProperty("目的仓库id")
    private Long destWarehouseId;
    @ExcelProperty("运输方式")
    private String transportType;

}
