package cn.iocoder.yudao.module.customer.vo.customerDetail;

import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY;

@Data
@ApiModel("管理后台 - 客户基本信息客户订单 Response VO")
public class CustomerOrderBackVo {
    @ApiModelProperty(value = "订单号")
    private String orderNo;

    @ApiModelProperty(value = "唛头")
    private String marks;

    @ApiModelProperty(value = "箱数,体积,重量,销售费用")
    private CostVO costVO;

    @ApiModelProperty(value = "订单状态 详情见字典：order_status")
    private String status;

    @ApiModelProperty(value = "入仓时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    private Date houseDate;

    /**
     * 费用清单
     */
    private String cost;

    public void setCostVO(CostVO costVO) {
        this.costVO = costVO;
        this.cost = JSONObject.toJSONString(this.cost);
    }

    public CostVO getCostVO() {
        return JSONObject.parseObject(this.cost, CostVO.class);
    }


}
