package cn.iocoder.yudao.module.customer.vo.customerDetail;

import cn.iocoder.yudao.framework.common.pojo.PageParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("客户订单查询参数")
public class CustomerOrderQueryVO extends PageParam {

    @ApiModelProperty(value = "客户ID不能为空")
    @NotNull(message = "客户ID不能为空")
    private Long customerId;

    @ApiModelProperty(value = "运输方式")
    private Long transportId;

    @ApiModelProperty(value = "订单状态")
    private Integer status;

    @ApiModelProperty(value = "报关方式")
    private Integer customerType;

    @ApiModelProperty(value = "是否控货")
    private Integer isCargoControl;

    @ApiModelProperty(value = "入仓时间开始")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date houseStartDate;

    @ApiModelProperty(value = "入仓时间结束")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date houseEndDate;


}
