package cn.iocoder.yudao.module.customer.vo.customerDetail;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("管理后台 - 客户基本信数据 Response VO")
public class CustomerOrderStatisticsBackVo {
    @ApiModelProperty(value = "海空联运")
    private Long hklyTotal = 0l;

    @ApiModelProperty(value = "海运拼柜")
    private Long hypgTotal = 0l;

    @ApiModelProperty(value = "海运整柜")
    private Long hyzgTotal = 0l;

    @ApiModelProperty(value = "专线空运")
    private Long zxkyTotal = 0l;

    @ApiModelProperty(value = "全部订单总数")
    private Long allOrderTotal = 0l;

    @ApiModelProperty(value = "控货订单总数")
    private Long controlOrderTotal = 0l;

    @ApiModelProperty(value = "报价")
    private Long offerOrderTotal = 0l;

    @ApiModelProperty(value = "下单")
    private Long pickOrderTotal = 0l;

    @ApiModelProperty(value = "入仓")
    private Long wareHousingTotal = 0l;

    @ApiModelProperty(value = "出货")
    private Long shipmentTotal = 0l;


    @ApiModelProperty(value = "最后交易日期")
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date lastBusinessDate;

    @ApiModelProperty(value = "最后交易单号")
    private String lastBusinessOrderNo;

    @ApiModelProperty(value = "库存量")
    private String stock = "0";


}
