package cn.iocoder.yudao.module.customer.vo.customerDetail;

import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel("管理后台 - 客户基本信息账单 Response VO")
public class CustomerReceivableBackVO {

    @ApiModelProperty(value = "收款单号")
    private String receiptNo;

    @ApiModelProperty(value = "订单号")
    private String orderNo;

    @ExcelProperty("数量")
    @ApiModelProperty(value = "数量")
    private Integer quantity;

    @ExcelProperty("箱数")
    @ApiModelProperty(value = "箱数")
    private Integer num;

    @ExcelProperty("体积/重量")
    @ApiModelProperty(value = "体积/重量")
    private BigDecimal weight;

    @ExcelProperty("体积")
    @ApiModelProperty(value = "体积")
    private BigDecimal volume;

    @ApiModelProperty(value = "收款类型(字典 payment_type)")
    private Integer collectionType;

    @ApiModelProperty(value = "费用类型(字典 receivable_fee_type)")
    private Integer feeType;

    @ApiModelProperty(value = "货币id")
    private Long currencyId;

    @ApiModelProperty(value = "金额")
    private BigDecimal totalAmount;

    @ApiModelProperty(value = "优惠金额")
    private BigDecimal discountTotal;

    @ApiModelProperty(value = "实收日期")
    private Date writeOffAt;

    @ApiModelProperty(value = "核销比例")
    private BigDecimal writeOffScale;

    @ApiModelProperty(value = "业务员名称")
    private String salesmanName;
}
