package cn.iocoder.yudao.module.customer.vo.customerFollowup;

import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户跟进 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 客户跟进 Response VO")
public class CustomerFollowupBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("编号")
    @ApiModelProperty(value = "编号")
    private String number;

    @ExcelProperty("上一级跟进单号")
    @ApiModelProperty(value = "上一级跟进单号")
    private String parentNumber;

    @ExcelProperty(value = "状态", converter = DictConvert.class)
    @DictFormat("customer_followup_status")
    @ApiModelProperty(value = "状态 字典customer_followup_status")
    private Integer status;

    @ApiModelProperty(value = "客户编号")
    private Long customerId;

    @ApiModelProperty(value = "报价单")
    private Long offerId;

    @ExcelProperty(value = "跟进类型", converter = DictConvert.class)
    @DictFormat("customer_followup_type")
    @ApiModelProperty(value = "跟进类型 字典customer_followup_type")
    private Integer followType;

    @ExcelProperty("跟进时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "跟进时间")
    private Date followTime;

    @ExcelProperty("联系人")
    @ApiModelProperty(value = "联系人")
    private String contactName;

    @ExcelProperty(value = "跟进方式", converter = DictConvert.class)
    @DictFormat("customer_followup_method")
    @ApiModelProperty(value = "跟进类型 字典customer_followup_type")
    private Integer followMethod;

    @ExcelProperty("客户经理/跟进业务员id")
    @ApiModelProperty(value = "客户经理/跟进业务员id")
    private Long followUserId;

    @ExcelProperty("目的")
    @ApiModelProperty(value = "目的")
    private String purpose;

    @ExcelProperty(value = "跟进结果", converter = DictConvert.class)
    @DictFormat("customer_followup_result_type")
    @ApiModelProperty(value = "跟进结果 字典customer_followup_result_type")
    private Integer resultType;

    @ExcelProperty("客户反馈")
    @ApiModelProperty(value = "客户反馈")
    private String feedback;

    @ExcelProperty("附件 多个以逗号分隔")
    @ApiModelProperty(value = "附件 多个以逗号分隔")
    private String attatchment;

    @ExcelProperty("下次跟进时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "下次跟进时间")
    private Date nextTime;

    @ExcelProperty("下次跟进计划")
    @ApiModelProperty(value = "下次跟进计划")
    private String nextPlan;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ExcelProperty("更新时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;


    @ExcelProperty("客户编号")
    @ApiModelProperty(value = "客户编号")
    private String customerNumber;
    @ExcelProperty("报价单")
    @ApiModelProperty(value = "报价单编号")
    private String offerNumber;
    //creator_name
    @ExcelProperty("创建人id")
    @ApiModelProperty(value = "创建人名称")
    private String creatorName;
    // updater_name
    @ExcelProperty("更新人id")
    @ApiModelProperty(value = "更新人名称")
    private String updaterName;


}
