package cn.iocoder.yudao.module.customer.vo.customerFollowup;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("管理后台 - 客户跟进查询 VO")
public class CustomerFollowupQueryVO extends PageParam {

    @ApiModelProperty(value = "编号")
    private String number;

    @ApiModelProperty(value = "上一级跟进单号")
    private String parentNumber;

    @ApiModelProperty(value = "状态 字典customer_followup_status")
    private Integer status;

    @ApiModelProperty(value = "客户编号")
    private Long customerId;

    @ApiModelProperty(value = "客户编号")
    private Long customerDetailId;

    @ApiModelProperty(value = "报价单")
    private Long offerId;

    @ApiModelProperty(value = "跟进类型 字典customer_followup_type")
    private Integer followType;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始跟进时间")
    private Date beginFollowTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束跟进时间")
    private Date endFollowTime;

    @ApiModelProperty(value = "联系人")
    private String contactName;

    @ApiModelProperty(value = "跟进方式 字典customer_followup_method")
    private Integer followMethod;

    @ApiModelProperty(value = "客户经理/跟进业务员id")
    private Long followUserId;

    @ApiModelProperty(value = "目的")
    private String purpose;

    @ApiModelProperty(value = "跟进结果 字典customer_followup_result_type")
    private Integer resultType;

    @ApiModelProperty(value = "客户反馈")
    private String feedback;

    @ApiModelProperty(value = "附件 多个以逗号分隔")
    private String attatchment;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始下次跟进时间")
    private Date beginNextTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束下次跟进时间")
    private Date endNextTime;

    @ApiModelProperty(value = "下次跟进计划")
    private String nextPlan;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
