package cn.iocoder.yudao.module.customer.vo.customerLevel;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户级别 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 客户级别 Response VO")
public class CustomerLevelBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("中文名称")
    @ApiModelProperty(value = "中文名称")
    private String nameZh;

    @ExcelProperty("英文名称")
    @ApiModelProperty(value = "英文名称")
    private String nameEn;

    @ExcelProperty("最大分值")
    @ApiModelProperty(value = "最大分值", required = true)
    private Integer scoreMax;

    @ExcelProperty("最小分值")
    @ApiModelProperty(value = "最小分值", required = true)
    private Integer scoreMin;

    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String remark;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
