package cn.iocoder.yudao.module.customer.vo.customerLevel;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import javax.validation.constraints.*;

/**
* 客户级别 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class CustomerLevelBaseVO {

    @ApiModelProperty(value = "中文名称", required = true)
    @NotNull(message = "中文名称不能为空")
    private String nameZh;

    @ApiModelProperty(value = "英文名称", required = true)
    @NotNull(message = "英文名称不能为空")
    private String nameEn;

    @ApiModelProperty(value = "最大分值", required = true)
    @NotNull(message = "最大分值不能为空")
    private Integer scoreMax;

    @ApiModelProperty(value = "最小分值", required = true)
    @NotNull(message = "最小分值不能为空")
    private Integer scoreMin;

    @ApiModelProperty(value = "备注")
    private String remark;

}
