package cn.iocoder.yudao.module.customer.vo.customerOperateLog;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户操作日志 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 客户操作日志 Response VO")
public class CustomerOperateLogBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("客户编号")
    @ApiModelProperty(value = "客户编号")
    private String number;

    @ExcelProperty("客户id")
    @ApiModelProperty(value = "客户id")
    private Long customerId;

    @ExcelProperty("客户名称")
    @ApiModelProperty(value = "客户名称", required = true)
    private String name;

    @ExcelProperty("操作类型 见字典Customer_operate_type")
    @ApiModelProperty(value = "操作类型 见字典Customer_operate_type")
    private Integer operateType;

    @ExcelProperty("老客户经理")
    @ApiModelProperty(value = "老客户经理")
    private Long oldCustomerService;

    @ExcelProperty("新客户经理")
    @ApiModelProperty(value = "新客户经理")
    private Long newCustomerService;

    @ExcelProperty("订单id")
    @ApiModelProperty(value = "订单id")
    private Long orderId;

    @ExcelProperty("订单编号")
    @ApiModelProperty(value = "订单编号")
    private String orderNo;

    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "操作人id")
    private Long operator;

    /**
     * 操作人名称
     */
    @ApiModelProperty(value = "操作人姓名")
    private String operatorName;

    @ExcelProperty("老的预计进入公海的时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "老的预计进入公海的时间")
    private Date oldEstimateEnterOpenSeaTime;

    @ExcelProperty("新的预计进入公海的时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "新的预计进入公海的时间")
    private Date newEstimateEnterOpenSeaTime;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ExcelProperty("更新json")
    @ApiModelProperty(value = "更新json")
    private String updateBody;

    /**
     * 差异json
     */
    @ApiModelProperty(value = "差异json")
    private String note;

}
