package cn.iocoder.yudao.module.customer.vo.customerOperateLog;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import javax.validation.constraints.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 客户操作日志 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class CustomerOperateLogBaseVO {

    @ApiModelProperty(value = "客户编号")
    private String number;

    @ApiModelProperty(value = "客户id")
    private Long customerId;

    @ApiModelProperty(value = "客户名称", required = true)
    @NotNull(message = "客户名称不能为空")
    private String name;

    @ApiModelProperty(value = "操作类型 见字典Customer_operate_type")
    private Integer operateType;

    @ApiModelProperty(value = "老客户经理")
    private Long oldCustomerService;

    @ApiModelProperty(value = "新客户经理")
    private Long newCustomerService;

    @ApiModelProperty(value = "订单id")
    private Long orderId;

    @ApiModelProperty(value = "订单编号")
    private String orderNo;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "操作人")
    private Long operator;

    /**
     * 操作人名称
     */
    @ApiModelProperty(value = "操作人姓名")
    private String operatorName;

    @ApiModelProperty(value = "老的预计进入公海的时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date oldEstimateEnterOpenSeaTime;

    @ApiModelProperty(value = "新的预计进入公海的时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date newEstimateEnterOpenSeaTime;

    @ApiModelProperty(value = "更新json")
    private String updateBody;

    /**
     * 差异json
     */
    @ApiModelProperty(value = "差异json")
    private String note;

}
