package cn.iocoder.yudao.module.customer.vo.customerPublicCatchLog;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 公海客户捞取日志 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 公海客户捞取日志 Response VO")
public class CustomerPublicCatchLogBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("客户id")
    @ApiModelProperty(value = "客户id")
    private Long customerId;

    @ExcelProperty("捞取业务经理id")
    @ApiModelProperty(value = "捞取业务经理id")
    private Long catchUserId;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
