package cn.iocoder.yudao.module.customer.vo.indirectCustomer;

import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 间接客户 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 间接客户 Response VO")
public class IndirectCustomerBackInfoVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("客户编号")
    @ApiModelProperty(value = "客户编号")
    private String number;

    @ExcelProperty("客户名称")
    @ApiModelProperty(value = "客户名称", required = true)
    private String name;

    @ExcelProperty("客户等级")
    @ApiModelProperty(value = "客户等级")
    private Integer level;

    @ExcelProperty("信用等级")
    @ApiModelProperty(value = "信用等级")
    private Integer creditLevel;

    @ExcelProperty("国家")
    @ApiModelProperty(value = "国家")
    private Long country;

    @ExcelProperty("客户类型")
    @ApiModelProperty(value = "客户类型")
    private String type;

    @ExcelProperty("客户货运类型 见customer_transport_type")
    @ApiModelProperty(value = "客户货运类型 见customer_transport_type")
    private String transportType;

    @ExcelProperty("客户资源类型 见customer_resource_type")
    @ApiModelProperty(value = "客户资源类型 见customer_resource_type")
    private Integer resourceType;

    @ExcelProperty("来源客户id")
    @ApiModelProperty(value = "所属代理")
    private Long agentId;

    @ExcelProperty("公司名称")
    @ApiModelProperty(value = "公司名称")
    private String company;

    @ExcelProperty("联系地址")
    @ApiModelProperty(value = "联系地址")
    private String address;

    @ExcelProperty("产品类型")
    @ApiModelProperty(value = "产品类型")
    private Long productType;

    @ExcelProperty("产品id")
    @ApiModelProperty(value = "产品id")
    private Long productId;

    @ExcelProperty("常用提货网点")
    @ApiModelProperty(value = "常用提货网点")
    private Long pickupPoint;

    @ExcelProperty("关联会员账号")
    @ApiModelProperty(value = "关联会员账号")
    private Long memberId;

    @ExcelProperty("客户生日")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "客户生日")
    private Date birthday;

    @ExcelProperty("结算方式")
    @ApiModelProperty(value = "结算方式")
    private Integer balance;

    @ExcelProperty("客户来源")
    @ApiModelProperty(value = "客户来源")
    private Integer source;

    @ExcelProperty("图片")
    @ApiModelProperty(value = "图片")
    private String picture;

    @ExcelProperty("跟进客服")
    @ApiModelProperty(value = "跟进客服")
    private Long customerService;

    @ExcelProperty("跟进客服分配时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "跟进客服分配时间")
    private Date customerServiceAssignedTime;

    @ExcelProperty("推介人")
    @ApiModelProperty(value = "推介人")
    private Long promoter;

    @ExcelProperty("客户状态：1.线索2.意向3.成交")
    @ApiModelProperty(value = "客户状态：1.线索2.意向3.成交")
    private Integer status;

    @ExcelProperty("客户状态更新时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "客户状态更新时间")
    private Date statusUpdateTime;

    @ExcelProperty("是否被接收")
    @ApiModelProperty(value = "是否被接收", required = true)
    private Boolean isCustomerServiceConfirmed;

    @ExcelProperty("创建人")
    @ApiModelProperty(value = "创建人")
    private Long founder;

    @ExcelProperty("部门")
    @ApiModelProperty(value = "部门")
    private String department;

    @ExcelProperty("发票抬头")
    @ApiModelProperty(value = "发票抬头")
    private String invoiceTitle;

    @ExcelProperty("纳税人识别号")
    @ApiModelProperty(value = "纳税人识别号")
    private String licenseNumber;

    @ExcelProperty("开户行")
    @ApiModelProperty(value = "开户行")
    private String bank;

    @ExcelProperty("账户")
    @ApiModelProperty(value = "账户")
    private String bankNumber;

    @ExcelProperty("项目")
    @ApiModelProperty(value = "项目")
    private String project;

    @ExcelProperty("开票地址")
    @ApiModelProperty(value = "开票地址")
    private String billingAddress;

    @ExcelProperty("开票电话")
    @ApiModelProperty(value = "开票电话")
    private String billingTell;

    @ExcelProperty("税率")
    @ApiModelProperty(value = "税率")
    private java.math.BigDecimal taxRate;

    @ExcelProperty("完善时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "完善时间")
    private Date perfectTime;

    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String remarks;

    @ExcelProperty("管理员id")
    @ApiModelProperty(value = "管理员id")
    private Long adminId;

    @ExcelProperty("审批人id")
    @ApiModelProperty(value = "审批人id")
    private Long approver;

    @ExcelProperty("通知人id")
    @ApiModelProperty(value = "通知人id")
    private Long notifier;

    @ExcelProperty("其他审批id")
    @ApiModelProperty(value = "其他审批id")
    private Long otherApprovalId;

    @ExcelProperty("到仓确认")
    @ApiModelProperty(value = "到仓确认")
    private Integer arrivalConfirm;

    @ExcelProperty("重货标准(CBM)")
    @ApiModelProperty(value = "重货标准(CBM)")
    private java.math.BigDecimal weightUnit;

    @ExcelProperty("泡货标准")
    @ApiModelProperty(value = "泡货标准")
    private java.math.BigDecimal lightUnit;

    @ExcelProperty("重货标准修改人")
    @ApiModelProperty(value = "重货标准修改人")
    private String weightEditWho;

    @ExcelProperty("重货标准修时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "重货标准修时间")
    private Date weightEditTime;

    @ExcelProperty("询价详情")
    @ApiModelProperty(value = "询价详情")
    private String enquiryInfo;

    @ExcelProperty("是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建")
    @ApiModelProperty(value = "是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建")
    private Integer isAuto;

    @ExcelProperty("是否公海客户")
    @ApiModelProperty(value = "是否公海客户")
    private Boolean isInOpenSea;

    @ExcelProperty("进入公海时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "进入公海时间")
    private Date enterOpenSeaTime;

    @ExcelProperty("预计进入公海池时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "预计进入公海池时间")
    private Date estimateEnterOpenSeaTime;

    @ExcelProperty("延期x月")
    @ApiModelProperty(value = "延期x月")
    private Integer postponeMonth;

    @ExcelProperty("从公海池捞取时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "从公海池捞取时间")
    private Date catchTime;

    @ExcelProperty("是否显示提单价格")
    @ApiModelProperty(value = "是否显示提单价格")
    private Boolean isShowTidanPrice;

    @ExcelProperty("vip等级分数")
    @ApiModelProperty(value = "vip等级分数")
    private Long vipLevelScore;

    @ExcelProperty("信用等级分数")
    @ApiModelProperty(value = "信用等级分数")
    private Long creditLevelScore;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
