package cn.iocoder.yudao.module.customer.vo.indirectCustomer;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 间接客户 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 间接客户 Response VO")
public class IndirectCustomerBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    // @ExcelProperty("客户编号")
    // @ApiModelProperty(value = "客户编号")
    // private String number;

    @ExcelProperty("客户名称")
    @ApiModelProperty(value = "客户名称", required = true)
    private String name;

    // @ExcelProperty("客户等级")
    // @ApiModelProperty(value = "客户等级")
    // private Integer level;
    //
    // @ExcelProperty("信用等级")
    // @ApiModelProperty(value = "信用等级")
    // private Integer creditLevel;
    /**
     * 客户来源
     */
    @ExcelProperty("客户来源")
    @ApiModelProperty(value = "客户来源")
    private Integer source;

    @ExcelProperty("国家")
    @ApiModelProperty(value = "国家")
    private Long country;

    @ExcelProperty("客户类型")
    @ApiModelProperty(value = "客户类型")
    private String type;

    // @ExcelProperty("客户货运类型 见customer_transport_type")
    // @ApiModelProperty(value = "客户货运类型 见customer_transport_type")
    // private String transportType;

    @ExcelProperty("客户资源类型 见customer_resource_type")
    @ApiModelProperty(value = "客户资源类型 见customer_resource_type")
    private Integer resourceType;

    @ExcelProperty("来源客户id")
    @ApiModelProperty(value = "来源客户id")
    private Long agentId;

    @ExcelProperty("跟进客服")
    @ApiModelProperty(value = "跟进客服")
    private Long customerService;

    @ExcelProperty("是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建")
    @ApiModelProperty(value = "是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建")
    private Integer isAuto;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;




    @ApiModelProperty(value = "主联系人")
    private String defaultContactName;

    @ApiModelProperty(value = "主联系电话")
    private String defaultContactPhone;




    /**
     * 来源客户id
     */
    @ApiModelProperty(value = "来源客户id")
    private Long agentCustomerId;

    /**
     * 来源客户名称
     */
    @ApiModelProperty(value = "来源客户名称")
    private String agentCustomerName;

}
