package cn.iocoder.yudao.module.customer.vo.indirectCustomer;

import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import cn.iocoder.yudao.framework.excel.convert.DictMultiConvert;
import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
 * 间接客户 Response VO
 *
 * @author yanghao
 */
@Data
@ApiModel("管理后台 - 间接客户 ExcelResponse VO")
public class IndirectCustomerExcelVO {

    @ExcelProperty("客户名称")
    private String name;

    @ExcelProperty(value = "联系方式")
    private String defaultContactPhone;

    @ExcelProperty("客户来源")
    private String agentCustomerName;


    @ExcelProperty(value = "客户资源类型", converter = DictConvert.class)
    @DictFormat("customer_resource_type")
    private Integer resourceType;

    @ExcelProperty(value = "客户类型", converter = DictMultiConvert.class)
    @DictFormat(value = "customer_type")
    private String type;

    @ExcelProperty("跟进客服")
    @ApiModelProperty(value = "跟进客服")
    private String customerServiceName;


    
    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;


}
