package cn.iocoder.yudao.module.customer.vo.indirectCustomerContacts;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 间接客户联系人 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 间接客户联系人 Response VO")
public class IndirectCustomerContactsBackVO {

    @ExcelProperty("")
    @ApiModelProperty(value = "", required = true)
    private Long id;

    @ExcelProperty("客户id")
    @ApiModelProperty(value = "客户id")
    private Long customerId;

    @ExcelProperty("部门")
    @ApiModelProperty(value = "部门")
    private String department;

    @ExcelProperty("职位")
    @ApiModelProperty(value = "职位")
    private String position;

    @ExcelProperty("联系人")
    @ApiModelProperty(value = "联系人")
    private String name;

    @ExcelProperty("社交方式")
    @ApiModelProperty(value = "社交方式")
    private Integer social;

    @ExcelProperty("社交软件号码")
    @ApiModelProperty(value = "社交软件号码")
    private String socialNumber;

    @ExcelProperty("电子邮箱")
    @ApiModelProperty(value = "电子邮箱")
    private String email;

    @ExcelProperty("默认联系人：1为默认")
    @ApiModelProperty(value = "默认联系人：1为默认")
    private Integer isDefault;

    @ExcelProperty("关联账户id")
    @ApiModelProperty(value = "关联账户id")
    private Long userid;

    @ExcelProperty("关联账户名")
    @ApiModelProperty(value = "关联账户名")
    private String username;

    @ExcelProperty("区号")
    @ApiModelProperty(value = "区号", required = true)
    private String areaCode;

    @ExcelProperty("手机号码(不带任何区号)")
    @ApiModelProperty(value = "手机号码(不带任何区号)", required = true)
    private String phoneNew;

    @ExcelProperty("是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建")
    @ApiModelProperty(value = "是否系统创建 0为手动 1为注册时系统创建 2为下单时系统创建", required = true)
    private Integer isAuto;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
