package cn.iocoder.yudao.module.customer.vo.zhongPao;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

@Data
@ToString
@EqualsAndHashCode
@ApiModel("管理后台 - 重泡货配置请求 Request VO")
public class CustomerZhongPaoQueryVO {

    /**
     * 用于查询重泡货配置时设置的始发市和目的市
     */
    @ApiModelProperty(value = "始发地城市ID", example = "1")
    private Long departureId;

    @ApiModelProperty(value = "目的地城市ID", example = "1")
    private Long objectiveId;



    /**
     * 用于查询客户重泡货标准时指定的路线
     */
    @ApiModelProperty(value = "客户id")
    private Long customerId;

    @ApiModelProperty(value = "发货客户id")
    private Long consignorId;

    @ApiModelProperty(value = "收货客户id")
    private Long consigneeId;

    @ApiModelProperty(value = "始发地仓库ID", example = "1")
    private Long startWarehouseId;

    @ApiModelProperty(value = "目的地仓库ID", example = "1")
    private Long destWarehouseId;


}
