package cn.iocoder.yudao.module.customer.vo.zhongPao;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;

import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 重泡货配置 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 重泡货配置 Response VO")
public class ZhongPaoBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty(value = "重泡货类型 见字典zhong_pao_type", converter = DictConvert.class)
    @DictFormat("zhong_pao_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    @ApiModelProperty(value = "重泡货类型 见字典zhong_pao_type")
    private Integer type;

    @ExcelProperty("临介值")
    @ApiModelProperty(value = "临介值")
    private java.math.BigDecimal edge;

    @ExcelProperty("公式")
    @ApiModelProperty(value = "公式")
    private java.math.BigDecimal formulas;

    @ExcelProperty(value = "传输方式ids", converter = DictConvert.class)
    @DictFormat("transport_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    @ApiModelProperty(value = "传输方式ids")
    private String transportTypes;

    @ExcelProperty("始发地ID")
    @ApiModelProperty(value = "始发地ID")
    private Long departureId;

    @ExcelProperty("目的地ID列表")
    @ApiModelProperty(value = "目的地ID列表", example = "1,2,3")
    private String objectiveIds;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ExcelProperty(value = "状态 0:开启;1:关闭 见字典common_status", converter = DictConvert.class)
    @DictFormat("common_status")
    @ApiModelProperty(value = "状态 0:开启;1:关闭 见字典common_status")
    private Integer status;

    @ApiModelProperty(value = "创建人")
    private String creatorName;

    @ExcelProperty("更新时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "更新时间", required = true)
    private Date updateTime;

    @ApiModelProperty(value = "更新人")
    private String updaterName;

    private String creator;
   
    private String updater;

}
