package cn.iocoder.yudao.module.customer.vo.zhongPao;

import lombok.*;
import io.swagger.annotations.*;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
* 重泡货配置 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class ZhongPaoBaseVO {

    @ApiModelProperty(value = "重泡货类型 见字典zhong_pao_type")
    @NotNull(message = "重泡货类型不能为空")
    private Integer type;

    @ApiModelProperty(value = "临介值")
    private java.math.BigDecimal edge;

    @ApiModelProperty(value = "公式")
    private java.math.BigDecimal formulas;

    @ApiModelProperty(value = "传输方式ids")
    private String transportTypes;

    @ApiModelProperty(value = "始发地ID")
    @NotNull(message = "始发地不能为空")
    private Long departureId;

    @ApiModelProperty(value = "目的地ID列表", example = "1,2,3")
    @NotBlank(message = "目的地不能为空")
    private String objectiveIds;

    @ApiModelProperty(value = "状态 0:开启;1:关闭 见字典common_status")
    private Integer status;

}
