package cn.iocoder.yudao.module.customer.vo.zhongPao;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("管理后台 - 重泡货配置查询 VO")
public class ZhongPaoQueryVO {

    @ApiModelProperty(value = "重泡货类型 见字典zhong_pao_type")
    private Integer type;

    @ApiModelProperty(value = "始发地ID")
    private Long departureId;

    @ApiModelProperty(value = "目的地ID列表", example = "1,2,3")
    private String objectiveIds;

    @ApiModelProperty(value = "状态 0开启1关闭 见common_status")
    private Integer status;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
