package cn.iocoder.yudao.module.customer.controller.admin.customer.commission;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.module.customer.convert.customer.commission.CustomerCommissionInfoConvert;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.commission.CustomerCommissionInfoDO;
import cn.iocoder.yudao.module.customer.dto.CustomerCommissionDto;
import cn.iocoder.yudao.module.customer.dto.CustomerCommissionQueryDto;
import cn.iocoder.yudao.module.customer.service.customer.commission.CustomerCommissionInfoService;
import cn.iocoder.yudao.module.customer.vo.customer.commission.CustomerCommissionInfoExportReqVO;
import cn.iocoder.yudao.module.customer.vo.customer.commission.CustomerCommissionInfoRespVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Api(tags = "管理后台 - 客户佣金详情")
@RestController
@RequestMapping("/ecw/customer-commission-info")
@Validated
public class CustomerCommissionInfoController {

    @Resource
    private CustomerCommissionInfoService customerCommissionInfoService;

    //@PostMapping("/create")
    //@ApiOperation("创建客户佣金详情")
    ////@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:create')")
    //public CommonResult<Long> createCustomerCommissionInfo(@Valid @RequestBody CustomerCommissionInfoCreateReqVO createReqVO) {
    //    return success(customerCommissionInfoService.createCustomerCommissionInfo(createReqVO));
    //}
    //
    //@PutMapping("/update")
    //@ApiOperation("更新客户佣金详情")
    ////@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:update')")
    //public CommonResult<Boolean> updateCustomerCommissionInfo(@Valid @RequestBody CustomerCommissionInfoUpdateReqVO updateReqVO) {
    //    customerCommissionInfoService.updateCustomerCommissionInfo(updateReqVO);
    //    return success(true);
    //}
    //
    //@DeleteMapping("/delete")
    //@ApiOperation("删除客户佣金详情")
    //@ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
    ////@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:delete')")
    //public CommonResult<Boolean> deleteCustomerCommissionInfo(@RequestParam("id") Long id) {
    //    customerCommissionInfoService.deleteCustomerCommissionInfo(id);
    //    return success(true);
    //}

    @GetMapping("/get-by-commission-id")
    @ApiOperation("根据佣金类型ID获得客户佣金详情")
    @ApiImplicitParam(name = "commissionId", value = "客户佣金ID", required = true, example = "1024", dataTypeClass = Long.class)
    //@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:query')")
    public CommonResult<List<CustomerCommissionInfoRespVO>> getByCommissionId(@RequestParam("commissionId") Long commissionId) {

        CustomerCommissionInfoExportReqVO customerCommissionInfoExportReqVO = new CustomerCommissionInfoExportReqVO();
        customerCommissionInfoExportReqVO.setCommissionId(commissionId);

        List<CustomerCommissionInfoDO> list = customerCommissionInfoService.getCustomerCommissionInfoList(customerCommissionInfoExportReqVO);
        return success(CustomerCommissionInfoConvert.INSTANCE.convertList(list));
    }

    //@GetMapping("/get")
    //@ApiOperation("根据详情ID获得客户佣金详情")
    //@ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
    ////@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:query')")
    //public CommonResult<CustomerCommissionInfoRespVO> getCustomerCommissionInfo(@RequestParam("id") Long id) {
    //    CustomerCommissionInfoDO customerCommissionInfo = customerCommissionInfoService.getCustomerCommissionInfo(id);
    //    return success(CustomerCommissionInfoConvert.INSTANCE.convert(customerCommissionInfo));
    //}
    //
    //@GetMapping("/list")
    //@ApiOperation("获得客户佣金详情列表")
    //@ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
    ////@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:query')")
    //public CommonResult<List<CustomerCommissionInfoRespVO>> getCustomerCommissionInfoList(@RequestParam("ids") Collection<Long> ids) {
    //    List<CustomerCommissionInfoDO> list = customerCommissionInfoService.getCustomerCommissionInfoList(ids);
    //    return success(CustomerCommissionInfoConvert.INSTANCE.convertList(list));
    //}

    //@GetMapping("/page")
    //@ApiOperation("获得客户佣金详情分页")
    ////@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:query')")
    //public CommonResult<PageResult<CustomerCommissionInfoRespVO>> getCustomerCommissionInfoPage(@Valid CustomerCommissionInfoPageReqVO pageVO) {
    //    PageResult<CustomerCommissionInfoDO> pageResult = customerCommissionInfoService.getCustomerCommissionInfoPage(pageVO);
    //    return success(CustomerCommissionInfoConvert.INSTANCE.convertPage(pageResult));
    //}
    //
    //@GetMapping("/export-excel")
    //@ApiOperation("导出客户佣金详情 Excel")
    ////@PreAuthorize("@ss.hasPermission('ecw:customer-commission-info:export')")
    //@OperateLog(type = EXPORT)
    //public void exportCustomerCommissionInfoExcel(@Valid CustomerCommissionInfoExportReqVO exportReqVO,
    //          HttpServletResponse response) throws IOException {
    //    List<CustomerCommissionInfoDO> list = customerCommissionInfoService.getCustomerCommissionInfoList(exportReqVO);
    //    // 导出 Excel
    //    List<CustomerCommissionInfoExcelVO> datas = CustomerCommissionInfoConvert.INSTANCE.convertList02(list);
    //    ExcelUtils.write(response, "客户佣金详情.xls", "数据", CustomerCommissionInfoExcelVO.class, datas);
    //}


    @PostMapping("/customer-commission")
    public CommonResult<CustomerCommissionDto> getCustomerCommissionInfo(@RequestBody CustomerCommissionQueryDto customerCommissionQueryDto) {
        CustomerCommissionDto customerCommissionDto = customerCommissionInfoService.customerCommission(customerCommissionQueryDto);
        return success(customerCommissionDto);
    }

}
