package cn.iocoder.yudao.module.customer.controller.admin.customer.line;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.module.customer.convert.customer.line.CustomerLineConvert;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.line.CustomerLineDO;
import cn.iocoder.yudao.module.customer.service.customer.line.CustomerLineService;
import cn.iocoder.yudao.module.customer.vo.customer.line.CustomerLineRespVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Api(tags = "管理后台 - 客户线路")
@RestController
@RequestMapping("/ecw/customer-line")
@Validated
public class CustomerLineController {

    @Resource
    private CustomerLineService customerLineService;

    //@PostMapping("/create")
    //@ApiOperation("创建客户线路")
    //@PreAuthorize("@ss.hasPermission('ecw:customer-line:create')")
    //public CommonResult<Long> createCustomerLine(@Valid @RequestBody CustomerLineCreateReqVO createReqVO) {
    //    return success(customerLineService.createCustomerLine(createReqVO));
    //}
    //
    //@PutMapping("/update")
    //@ApiOperation("更新客户线路")
    //@PreAuthorize("@ss.hasPermission('ecw:customer-line:update')")
    //public CommonResult<Boolean> updateCustomerLine(@Valid @RequestBody CustomerLineUpdateReqVO updateReqVO) {
    //    customerLineService.updateCustomerLine(updateReqVO);
    //    return success(true);
    //}
    //
    //@DeleteMapping("/delete")
    //@ApiOperation("删除客户线路")
    //@ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
    //@PreAuthorize("@ss.hasPermission('ecw:customer-line:delete')")
    //public CommonResult<Boolean> deleteCustomerLine(@RequestParam("id") Long id) {
    //    customerLineService.deleteCustomerLine(id);
    //    return success(true);
    //}

    @GetMapping("/get-by-customer")
    @ApiOperation("根据客户ID获得客户指定的重泡货配置的线路")
    @ApiImplicitParam(name = "customerId", value = "客户id", required = true, example = "1024", dataTypeClass = Long.class)
    // @PreAuthorize("@ss.hasPermission('ecw:customer-line:query')")
    public CommonResult<List<CustomerLineRespVO>> getCustomerLine(@RequestParam("customerId") Long customerId) {

        List<CustomerLineDO> customerLineDOS = customerLineService.selectList(CustomerLineDO::getCustomerId, customerId);

        return success(CustomerLineConvert.INSTANCE.convertList(customerLineDOS));
    }

    //@GetMapping("/list")
    //@ApiOperation("获得客户线路列表")
    //@ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
    //@PreAuthorize("@ss.hasPermission('ecw:customer-line:query')")
    //public CommonResult<List<CustomerLineRespVO>> getCustomerLineList(@RequestParam("ids") Collection<Long> ids) {
    //    List<CustomerLineDO> list = customerLineService.getCustomerLineList(ids);
    //    return success(CustomerLineConvert.INSTANCE.convertList(list));
    //}
    //
    //@GetMapping("/page")
    //@ApiOperation("获得客户线路分页")
    //@PreAuthorize("@ss.hasPermission('ecw:customer-line:query')")
    //public CommonResult<PageResult<CustomerLineRespVO>> getCustomerLinePage(@Valid CustomerLinePageReqVO pageVO) {
    //    PageResult<CustomerLineDO> pageResult = customerLineService.getCustomerLinePage(pageVO);
    //    return success(CustomerLineConvert.INSTANCE.convertPage(pageResult));
    //}
    //
    //@GetMapping("/export-excel")
    //@ApiOperation("导出客户线路 Excel")
    //@PreAuthorize("@ss.hasPermission('ecw:customer-line:export')")
    //@OperateLog(type = EXPORT)
    //public void exportCustomerLineExcel(@Valid CustomerLineExportReqVO exportReqVO,
    //          HttpServletResponse response) throws IOException {
    //    List<CustomerLineDO> list = customerLineService.getCustomerLineList(exportReqVO);
    //    // 导出 Excel
    //    List<CustomerLineExcelVO> datas = CustomerLineConvert.INSTANCE.convertList02(list);
    //    ExcelUtils.write(response, "客户线路.xls", "数据", CustomerLineExcelVO.class, datas);
    //}

}
