package cn.iocoder.yudao.module.customer.controller.admin.customerApproval;

import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import org.springframework.web.bind.annotation.*;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.security.access.prepost.PreAuthorize;
import io.swagger.annotations.*;
import javax.validation.constraints.*;
import javax.validation.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.IOException;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;
import cn.iocoder.yudao.framework.excel.util.ExcelUtils;
import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;
import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;
import cn.iocoder.yudao.module.customer.vo.customerApproval.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerApproval.CustomerApprovalDO;
import cn.iocoder.yudao.module.customer.convert.customerApproval.CustomerApprovalConvert;
import cn.iocoder.yudao.module.customer.service.customerApproval.CustomerApprovalService;

@Validated
@RestController
@Api(tags = "管理后台 - 客户相关审核详情")
@RequestMapping("/ecw/customer-approval")
public class CustomerApprovalController {

    @Resource
    private CustomerApprovalService customerApprovalService;

//    @PostMapping("/create")
//    @ApiOperation("创建客户相关审核详情")
//    @PreAuthorize("@ss.hasPermission('ecw:customer-approval:create')")
//    public CommonResult<Long> createCustomerApproval(@Valid @RequestBody CustomerApprovalCreateReqVO createReqVO) {
//        return success(customerApprovalService.createCustomerApproval(createReqVO));
//    }
//
//    @PutMapping("/update")
//    @ApiOperation("更新客户相关审核详情")
//    @PreAuthorize("@ss.hasPermission('ecw:customer-approval:update')")
//    public CommonResult<Boolean> updateCustomerApproval(@Valid @RequestBody CustomerApprovalUpdateReqVO updateReqVO) {
//        customerApprovalService.updateCustomerApproval(updateReqVO);
//        return success(true);
//    }
//
//    @DeleteMapping("/delete")
//    @ApiOperation("删除客户相关审核详情")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('ecw:customer-approval:delete')")
//    public CommonResult<Boolean> deleteCustomerApproval(@RequestParam("id") Long id) {
//        customerApprovalService.deleteCustomerApproval(id);
//        return success(true);
//    }

    @GetMapping("/get")
    @ApiOperation("获得客户相关审核详情")
    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('ecw:customer-approval:query')")
    public CommonResult<CustomerApprovalBackVO> getCustomerApproval(@RequestParam("id") Long id) {
        CustomerApprovalDO customerApproval = customerApprovalService.getCustomerApproval(id);
        return success(CustomerApprovalConvert.INSTANCE.convert(customerApproval));
    }

//    @GetMapping("/list")
//    @ApiOperation("获得客户相关审核详情列表")
//    @ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
//    @PreAuthorize("@ss.hasPermission('ecw:customer-approval:query')")
//    public CommonResult<List<CustomerApprovalBackVO>> getCustomerApprovalList(@RequestParam("ids") Collection<Long> ids) {
//        List<CustomerApprovalDO> list = customerApprovalService.getCustomerApprovalList(ids);
//        return success(CustomerApprovalConvert.INSTANCE.convertList(list));
//    }

//    @GetMapping("/page")
//    @ApiOperation("获得客户相关审核详情分页")
//    @PreAuthorize("@ss.hasPermission('ecw:customer-approval:query')")
//    public CommonResult<PageResult<CustomerApprovalBackVO>> getCustomerApprovalPage(@Valid CustomerApprovalQueryVO query, PageVO page) {
//        PageResult<CustomerApprovalDO> pageResult = customerApprovalService.getCustomerApprovalPage(query, page);
//        return success(CustomerApprovalConvert.INSTANCE.convertPage(pageResult));
//    }
//
//    @GetMapping("/export-excel")
//    @ApiOperation("导出客户相关审核详情 Excel")
//    @PreAuthorize("@ss.hasPermission('ecw:customer-approval:export')")
//    @OperateLog(type = EXPORT)
//    public void exportCustomerApprovalExcel(@Valid CustomerApprovalQueryVO query,
//              HttpServletResponse response) throws IOException {
//        List<CustomerApprovalDO> list = customerApprovalService.getCustomerApprovalList(query);
//        // 导出 Excel
//        List<CustomerApprovalBackVO> datas = CustomerApprovalConvert.INSTANCE.convertList(list);
//        ExcelUtils.write(response, "客户相关审核详情.xls", "数据", CustomerApprovalBackVO.class, datas);
//    }
}
