package cn.iocoder.yudao.module.customer.controller.admin.indirectCustomerContacts;

import cn.hutool.core.collection.CollectionUtil;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.customer.convert.customerContacts.CustomerContactsConvert;
import cn.iocoder.yudao.module.customer.dal.dataobject.customer.CustomerDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerContacts.CustomerContactsDO;
import cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomer.IndirectCustomerDO;
import cn.iocoder.yudao.module.customer.service.indirectCustomer.IndirectCustomerService;
import cn.iocoder.yudao.module.customer.vo.customer.customerContacts.CustomerContactsRespVO;
import org.springframework.web.bind.annotation.*;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.security.access.prepost.PreAuthorize;
import io.swagger.annotations.*;
import javax.validation.constraints.*;
import javax.validation.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.IOException;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;
import cn.iocoder.yudao.framework.excel.util.ExcelUtils;
import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;
import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;
import cn.iocoder.yudao.module.customer.vo.indirectCustomerContacts.*;
import cn.iocoder.yudao.module.customer.dal.dataobject.indirectCustomerContacts.IndirectCustomerContactsDO;
import cn.iocoder.yudao.module.customer.convert.indirectCustomerContacts.IndirectCustomerContactsConvert;
import cn.iocoder.yudao.module.customer.service.indirectCustomerContacts.IndirectCustomerContactsService;

@Validated
@RestController
@Api(tags = "管理后台 - 间接客户联系人")
@RequestMapping("/ecw/indirect-customer-contacts")
public class IndirectCustomerContactsController {

    @Resource
    private IndirectCustomerContactsService indirectCustomerContactsService;

    @Resource
    private IndirectCustomerService indirectCustomerService;



    @GetMapping("/list-by-customer")
    @ApiOperation("根据客户ID获得联系人列表")
    @ApiImplicitParam(name = "customerId", value = "客户主键ID", required = true, example = "1024", dataTypeClass = Long.class)
    // @PreAuthorize("@ss.hasPermission('ecw:customer-contacts:query')")
    public CommonResult<List<IndirectCustomerContactsRespVO>> getCustomerContactsListByCustomerId(@RequestParam("customerId") Long customerId) {

        IndirectCustomerContactsQueryVO indirectCustomerContactsQueryVO = new IndirectCustomerContactsQueryVO();
        indirectCustomerContactsQueryVO.setCustomerId(customerId);
        List<IndirectCustomerContactsDO> list = indirectCustomerContactsService.getIndirectCustomerContactsList(indirectCustomerContactsQueryVO);

        List<IndirectCustomerContactsRespVO> respVOList = IndirectCustomerContactsConvert.INSTANCE.convertList(list);
        if (CollectionUtil.isNotEmpty(respVOList)) {
            IndirectCustomerDO customer = indirectCustomerService.getById(customerId);
            if (customer != null) {
                respVOList.stream().forEach(customerContactsRespVO -> {
                    customerContactsRespVO.setCompany(customer.getCompany());
                });
            }
        }
        return success(respVOList);
    }
}
